import{S as $s,i as Ss,s as ks,e as s,k as p,w as I,t as o,M as Es,c as a,d as n,m as c,a as i,x,h as r,b as d,G as e,g as b,y as w,q as P,o as D,B as j,v as Cs,L as Kn}from"../../../../chunks/vendor-hf-doc-builder.js";import{D as O}from"../../../../chunks/Docstring-hf-doc-builder.js";import{C as Rn}from"../../../../chunks/CodeBlock-hf-doc-builder.js";import{I as js}from"../../../../chunks/IconCopyLink-hf-doc-builder.js";import{E as Bn}from"../../../../chunks/ExampleCodeBlock-hf-doc-builder.js";function Fs(G){let f,$,h,m,v;return m=new Rn({props:{code:`import requests
import torch
from PIL import Image
from io import BytesIO

from diffusers import StableDiffusionImg2ImgPipeline

device = "cuda"
model_id_or_path = "runwayml/stable-diffusion-v1-5"
pipe = StableDiffusionImg2ImgPipeline.from_pretrained(model_id_or_path, torch_dtype=torch.float16)
pipe = pipe.to(device)

url = "https://raw.githubusercontent.com/CompVis/stable-diffusion/main/assets/stable-samples/img2img/sketch-mountains-input.jpg"

response = requests.get(url)
init_image = Image.open(BytesIO(response.content)).convert("RGB")
init_image = init_image.resize((768, 512))

prompt = "A fantasy landscape, trending on artstation"

images = pipe(prompt=prompt, image=init_image, strength=0.75, guidance_scale=7.5).images
images[0].save("fantasy_landscape.png")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> io <span class="hljs-keyword">import</span> BytesIO

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionImg2ImgPipeline

<span class="hljs-meta">&gt;&gt;&gt; </span>device = <span class="hljs-string">&quot;cuda&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model_id_or_path = <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = StableDiffusionImg2ImgPipeline.from_pretrained(model_id_or_path, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(device)

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;https://raw.githubusercontent.com/CompVis/stable-diffusion/main/assets/stable-samples/img2img/sketch-mountains-input.jpg&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>response = requests.get(url)
<span class="hljs-meta">&gt;&gt;&gt; </span>init_image = Image.<span class="hljs-built_in">open</span>(BytesIO(response.content)).convert(<span class="hljs-string">&quot;RGB&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>init_image = init_image.resize((<span class="hljs-number">768</span>, <span class="hljs-number">512</span>))

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;A fantasy landscape, trending on artstation&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>images = pipe(prompt=prompt, image=init_image, strength=<span class="hljs-number">0.75</span>, guidance_scale=<span class="hljs-number">7.5</span>).images
<span class="hljs-meta">&gt;&gt;&gt; </span>images[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;fantasy_landscape.png&quot;</span>)`}}),{c(){f=s("p"),$=o("Examples:"),h=p(),I(m.$$.fragment)},l(l){f=a(l,"P",{});var _=i(f);$=r(_,"Examples:"),_.forEach(n),h=c(l),x(m.$$.fragment,l)},m(l,_){b(l,f,_),e(f,$),b(l,h,_),w(m,l,_),v=!0},p:Kn,i(l){v||(P(m.$$.fragment,l),v=!0)},o(l){D(m.$$.fragment,l),v=!1},d(l){l&&n(f),l&&n(h),j(m,l)}}}function Ts(G){let f,$,h,m,v;return m=new Rn({props:{code:`import torch
from diffusers import DiffusionPipeline
from xformers.ops import MemoryEfficientAttentionFlashAttentionOp

pipe = DiffusionPipeline.from_pretrained("stabilityai/stable-diffusion-2-1", torch_dtype=torch.float16)
pipe = pipe.to("cuda")
pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
# Workaround for not accepting attention shape using VAE for Flash Attention
pipe.vae.enable_xformers_memory_efficient_attention(attention_op=None)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> xformers.ops <span class="hljs-keyword">import</span> MemoryEfficientAttentionFlashAttentionOp

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;stabilityai/stable-diffusion-2-1&quot;</span>, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Workaround for not accepting attention shape using VAE for Flash Attention</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.vae.enable_xformers_memory_efficient_attention(attention_op=<span class="hljs-literal">None</span>)`}}),{c(){f=s("p"),$=o("Examples:"),h=p(),I(m.$$.fragment)},l(l){f=a(l,"P",{});var _=i(f);$=r(_,"Examples:"),_.forEach(n),h=c(l),x(m.$$.fragment,l)},m(l,_){b(l,f,_),e(f,$),b(l,h,_),w(m,l,_),v=!0},p:Kn,i(l){v||(P(m.$$.fragment,l),v=!0)},o(l){D(m.$$.fragment,l),v=!1},d(l){l&&n(f),l&&n(h),j(m,l)}}}function qs(G){let f,$,h,m,v;return m=new Rn({props:{code:`import jax
import numpy as np
import jax.numpy as jnp
from flax.jax_utils import replicate
from flax.training.common_utils import shard
import requests
from io import BytesIO
from PIL import Image
from diffusers import FlaxStableDiffusionImg2ImgPipeline


def create_key(seed=0):
    return jax.random.PRNGKey(seed)


rng = create_key(0)

url = "https://raw.githubusercontent.com/CompVis/stable-diffusion/main/assets/stable-samples/img2img/sketch-mountains-input.jpg"
response = requests.get(url)
init_img = Image.open(BytesIO(response.content)).convert("RGB")
init_img = init_img.resize((768, 512))

prompts = "A fantasy landscape, trending on artstation"

pipeline, params = FlaxStableDiffusionImg2ImgPipeline.from_pretrained(
    "CompVis/stable-diffusion-v1-4",
    revision="flax",
    dtype=jnp.bfloat16,
)

num_samples = jax.device_count()
rng = jax.random.split(rng, jax.device_count())
prompt_ids, processed_image = pipeline.prepare_inputs(
    prompt=[prompts] * num_samples, image=[init_img] * num_samples
)
p_params = replicate(params)
prompt_ids = shard(prompt_ids)
processed_image = shard(processed_image)

output = pipeline(
    prompt_ids=prompt_ids,
    image=processed_image,
    params=p_params,
    prng_seed=rng,
    strength=0.75,
    num_inference_steps=50,
    jit=True,
    height=512,
    width=768,
).images

output_images = pipeline.numpy_to_pil(np.asarray(output.reshape((num_samples,) + output.shape[-3:])))`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> jax
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> jax.numpy <span class="hljs-keyword">as</span> jnp
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> flax.jax_utils <span class="hljs-keyword">import</span> replicate
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> flax.training.common_utils <span class="hljs-keyword">import</span> shard
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> io <span class="hljs-keyword">import</span> BytesIO
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> FlaxStableDiffusionImg2ImgPipeline


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">create_key</span>(<span class="hljs-params">seed=<span class="hljs-number">0</span></span>):
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> jax.random.PRNGKey(seed)


<span class="hljs-meta">&gt;&gt;&gt; </span>rng = create_key(<span class="hljs-number">0</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;https://raw.githubusercontent.com/CompVis/stable-diffusion/main/assets/stable-samples/img2img/sketch-mountains-input.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>response = requests.get(url)
<span class="hljs-meta">&gt;&gt;&gt; </span>init_img = Image.<span class="hljs-built_in">open</span>(BytesIO(response.content)).convert(<span class="hljs-string">&quot;RGB&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>init_img = init_img.resize((<span class="hljs-number">768</span>, <span class="hljs-number">512</span>))

<span class="hljs-meta">&gt;&gt;&gt; </span>prompts = <span class="hljs-string">&quot;A fantasy landscape, trending on artstation&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline, params = FlaxStableDiffusionImg2ImgPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>,
<span class="hljs-meta">... </span>    revision=<span class="hljs-string">&quot;flax&quot;</span>,
<span class="hljs-meta">... </span>    dtype=jnp.bfloat16,
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>num_samples = jax.device_count()
<span class="hljs-meta">&gt;&gt;&gt; </span>rng = jax.random.split(rng, jax.device_count())
<span class="hljs-meta">&gt;&gt;&gt; </span>prompt_ids, processed_image = pipeline.prepare_inputs(
<span class="hljs-meta">... </span>    prompt=[prompts] * num_samples, image=[init_img] * num_samples
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>p_params = replicate(params)
<span class="hljs-meta">&gt;&gt;&gt; </span>prompt_ids = shard(prompt_ids)
<span class="hljs-meta">&gt;&gt;&gt; </span>processed_image = shard(processed_image)

<span class="hljs-meta">&gt;&gt;&gt; </span>output = pipeline(
<span class="hljs-meta">... </span>    prompt_ids=prompt_ids,
<span class="hljs-meta">... </span>    image=processed_image,
<span class="hljs-meta">... </span>    params=p_params,
<span class="hljs-meta">... </span>    prng_seed=rng,
<span class="hljs-meta">... </span>    strength=<span class="hljs-number">0.75</span>,
<span class="hljs-meta">... </span>    num_inference_steps=<span class="hljs-number">50</span>,
<span class="hljs-meta">... </span>    jit=<span class="hljs-literal">True</span>,
<span class="hljs-meta">... </span>    height=<span class="hljs-number">512</span>,
<span class="hljs-meta">... </span>    width=<span class="hljs-number">768</span>,
<span class="hljs-meta">... </span>).images

<span class="hljs-meta">&gt;&gt;&gt; </span>output_images = pipeline.numpy_to_pil(np.asarray(output.reshape((num_samples,) + output.shape[-<span class="hljs-number">3</span>:])))`}}),{c(){f=s("p"),$=o("Examples:"),h=p(),I(m.$$.fragment)},l(l){f=a(l,"P",{});var _=i(f);$=r(_,"Examples:"),_.forEach(n),h=c(l),x(m.$$.fragment,l)},m(l,_){b(l,f,_),e(f,$),b(l,h,_),w(m,l,_),v=!0},p:Kn,i(l){v||(P(m.$$.fragment,l),v=!0)},o(l){D(m.$$.fragment,l),v=!1},d(l){l&&n(f),l&&n(h),j(m,l)}}}function As(G){let f,$,h,m,v,l,_,ke,ht,Qe,N,U,Ee,X,_t,Ce,bt,Xe,S,vt,ee,yt,It,te,xt,wt,ne,Pt,Dt,se,jt,$t,Ie,St,kt,et,ae,Et,ie,Ct,tt,V,xe,Ft,Tt,we,qt,nt,W,At,oe,Mt,Lt,st,u,re,Ot,Fe,Nt,zt,le,Gt,Pe,Ut,Vt,Wt,T,pe,Bt,Te,Kt,Rt,B,Jt,q,ce,Ht,qe,Yt,Zt,Ae,Qt,Xt,K,de,en,me,tn,Me,nn,sn,an,k,fe,on,Le,rn,ln,Oe,pn,cn,Ne,dn,mn,R,fn,J,ge,gn,ze,un,hn,H,ue,_n,E,bn,Ge,vn,yn,Ue,In,xn,Ve,wn,Pn,We,Dn,jn,$n,Y,he,Sn,z,kn,Be,En,Cn,Ke,Fn,Tn,at,C,_e,qn,Re,An,Mn,be,Ln,Je,On,Nn,zn,A,ve,Gn,He,Un,Vn,Z,it;return l=new js({}),X=new js({}),re=new O({props:{name:"class diffusers.StableDiffusionImg2ImgPipeline",anchor:"diffusers.StableDiffusionImg2ImgPipeline",parameters:[{name:"vae",val:": AutoencoderKL"},{name:"text_encoder",val:": CLIPTextModel"},{name:"tokenizer",val:": CLIPTokenizer"},{name:"unet",val:": UNet2DConditionModel"},{name:"scheduler",val:": KarrasDiffusionSchedulers"},{name:"safety_checker",val:": StableDiffusionSafetyChecker"},{name:"feature_extractor",val:": CLIPImageProcessor"},{name:"requires_safety_checker",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.StableDiffusionImg2ImgPipeline.vae",description:`<strong>vae</strong> (<a href="/docs/diffusers/pr_2813/en/api/models#diffusers.AutoencoderKL">AutoencoderKL</a>) &#x2014;
Variational Auto-Encoder (VAE) Model to encode and decode images to and from latent representations.`,name:"vae"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.text_encoder",description:`<strong>text_encoder</strong> (<code>CLIPTextModel</code>) &#x2014;
Frozen text-encoder. Stable Diffusion uses the text portion of
<a href="https://huggingface.co/docs/transformers/model_doc/clip#transformers.CLIPTextModel" rel="nofollow">CLIP</a>, specifically
the <a href="https://huggingface.co/openai/clip-vit-large-patch14" rel="nofollow">clip-vit-large-patch14</a> variant.`,name:"text_encoder"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.tokenizer",description:`<strong>tokenizer</strong> (<code>CLIPTokenizer</code>) &#x2014;
Tokenizer of class
<a href="https://huggingface.co/docs/transformers/v4.21.0/en/model_doc/clip#transformers.CLIPTokenizer" rel="nofollow">CLIPTokenizer</a>.`,name:"tokenizer"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/pr_2813/en/api/models#diffusers.UNet2DConditionModel">UNet2DConditionModel</a>) &#x2014; Conditional U-Net architecture to denoise the encoded image latents.',name:"unet"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/pr_2813/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image latents. Can be one of
<a href="/docs/diffusers/pr_2813/en/api/schedulers/ddim#diffusers.DDIMScheduler">DDIMScheduler</a>, <a href="/docs/diffusers/pr_2813/en/api/schedulers/lms_discrete#diffusers.LMSDiscreteScheduler">LMSDiscreteScheduler</a>, or <a href="/docs/diffusers/pr_2813/en/api/schedulers/pndm#diffusers.PNDMScheduler">PNDMScheduler</a>.`,name:"scheduler"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.safety_checker",description:`<strong>safety_checker</strong> (<code>StableDiffusionSafetyChecker</code>) &#x2014;
Classification module that estimates whether generated images could be considered offensive or harmful.
Please, refer to the <a href="https://huggingface.co/runwayml/stable-diffusion-v1-5" rel="nofollow">model card</a> for details.`,name:"safety_checker"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.feature_extractor",description:`<strong>feature_extractor</strong> (<code>CLIPImageProcessor</code>) &#x2014;
Model that extracts features from generated images to be used as inputs for the <code>safety_checker</code>.`,name:"feature_extractor"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_img2img.py#L94"}}),pe=new O({props:{name:"__call__",anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__",parameters:[{name:"prompt",val:": typing.Union[str, typing.List[str]] = None"},{name:"image",val:": typing.Union[torch.FloatTensor, PIL.Image.Image] = None"},{name:"strength",val:": float = 0.8"},{name:"num_inference_steps",val:": typing.Optional[int] = 50"},{name:"guidance_scale",val:": typing.Optional[float] = 7.5"},{name:"negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"num_images_per_prompt",val:": typing.Optional[int] = 1"},{name:"eta",val:": typing.Optional[float] = 0.0"},{name:"generator",val:": typing.Union[torch._C.Generator, typing.List[torch._C.Generator], NoneType] = None"},{name:"prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": int = 1"}],parametersDescription:[{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts to guide the image generation. If not defined, one has to pass <code>prompt_embeds</code>.
instead.`,name:"prompt"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.image",description:`<strong>image</strong> (<code>torch.FloatTensor</code> or <code>PIL.Image.Image</code>) &#x2014;
<code>Image</code>, or tensor representing an image batch, that will be used as the starting point for the
process.`,name:"image"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.strength",description:`<strong>strength</strong> (<code>float</code>, <em>optional</em>, defaults to 0.8) &#x2014;
Conceptually, indicates how much to transform the reference <code>image</code>. Must be between 0 and 1. <code>image</code>
will be used as a starting point, adding more noise to it the larger the <code>strength</code>. The number of
denoising steps depends on the amount of noise initially added. When <code>strength</code> is 1, added noise will
be maximum and the denoising process will run for the full number of iterations specified in
<code>num_inference_steps</code>. A value of 1, therefore, essentially ignores <code>image</code>.`,name:"strength"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference. This parameter will be modulated by <code>strength</code>.`,name:"num_inference_steps"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.negative_prompt",description:`<strong>negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. If not defined, one has to pass
<code>negative_prompt_embeds</code>. instead. Ignored when not using guidance (i.e., ignored if <code>guidance_scale</code>
is less than <code>1</code>).`,name:"negative_prompt"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.num_images_per_prompt",description:`<strong>num_images_per_prompt</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of images to generate per prompt.`,name:"num_images_per_prompt"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.eta",description:`<strong>eta</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Corresponds to parameter eta (&#x3B7;) in the DDIM paper: <a href="https://arxiv.org/abs/2010.02502" rel="nofollow">https://arxiv.org/abs/2010.02502</a>. Only applies to
<a href="/docs/diffusers/pr_2813/en/api/schedulers/ddim#diffusers.DDIMScheduler">schedulers.DDIMScheduler</a>, will be ignored for others.`,name:"eta"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.generator",description:`<strong>generator</strong> (<code>torch.Generator</code>, <em>optional</em>) &#x2014;
One or a list of <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator(s)</a>
to make generation deterministic.`,name:"generator"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.prompt_embeds",description:`<strong>prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt weighting. If not
provided, text embeddings will be generated from <code>prompt</code> input argument.`,name:"prompt_embeds"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.negative_prompt_embeds",description:`<strong>negative_prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt
weighting. If not provided, negative_prompt_embeds will be generated from <code>negative_prompt</code> input
argument.`,name:"negative_prompt_embeds"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/pr_2813/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput">StableDiffusionPipelineOutput</a> instead of a
plain tuple.`,name:"return_dict"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.callback",description:`<strong>callback</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
A function that will be called every <code>callback_steps</code> steps during inference. The function will be
called with the following arguments: <code>callback(step: int, timestep: int, latents: torch.FloatTensor)</code>.`,name:"callback"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.callback_steps",description:`<strong>callback_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The frequency at which the <code>callback</code> function will be called. If not specified, the callback will be
called at every step.`,name:"callback_steps"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_img2img.py#L561",returnDescription:`
<p><a
  href="/docs/diffusers/pr_2813/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> if <code>return_dict</code> is True, otherwise a <code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/pr_2813/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> or <code>tuple</code></p>
`}}),B=new Bn({props:{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.example",$$slots:{default:[Fs]},$$scope:{ctx:G}}}),ce=new O({props:{name:"enable_attention_slicing",anchor:"diffusers.StableDiffusionImg2ImgPipeline.enable_attention_slicing",parameters:[{name:"slice_size",val:": typing.Union[str, int, NoneType] = 'auto'"}],parametersDescription:[{anchor:"diffusers.StableDiffusionImg2ImgPipeline.enable_attention_slicing.slice_size",description:`<strong>slice_size</strong> (<code>str</code> or <code>int</code>, <em>optional</em>, defaults to <code>&quot;auto&quot;</code>) &#x2014;
When <code>&quot;auto&quot;</code>, halves the input to the attention heads, so attention will be computed in two steps. If
<code>&quot;max&quot;</code>, maximum amount of memory will be saved by running only one slice at a time. If a number is
provided, uses as many slices as <code>attention_head_dim // slice_size</code>. In this case, <code>attention_head_dim</code>
must be a multiple of <code>slice_size</code>.`,name:"slice_size"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/pipelines/pipeline_utils.py#L1349"}}),de=new O({props:{name:"disable_attention_slicing",anchor:"diffusers.StableDiffusionImg2ImgPipeline.disable_attention_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/pipelines/pipeline_utils.py#L1365"}}),fe=new O({props:{name:"enable_xformers_memory_efficient_attention",anchor:"diffusers.StableDiffusionImg2ImgPipeline.enable_xformers_memory_efficient_attention",parameters:[{name:"attention_op",val:": typing.Optional[typing.Callable] = None"}],parametersDescription:[{anchor:"diffusers.StableDiffusionImg2ImgPipeline.enable_xformers_memory_efficient_attention.attention_op",description:`<strong>attention_op</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
Override the default <code>None</code> operator for use as <code>op</code> argument to the
<a href="https://facebookresearch.github.io/xformers/components/ops.html#xformers.ops.memory_efficient_attention" rel="nofollow"><code>memory_efficient_attention()</code></a>
function of xFormers.`,name:"attention_op"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/pipelines/pipeline_utils.py#L1292"}}),R=new Bn({props:{anchor:"diffusers.StableDiffusionImg2ImgPipeline.enable_xformers_memory_efficient_attention.example",$$slots:{default:[Ts]},$$scope:{ctx:G}}}),ge=new O({props:{name:"disable_xformers_memory_efficient_attention",anchor:"diffusers.StableDiffusionImg2ImgPipeline.disable_xformers_memory_efficient_attention",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/pipelines/pipeline_utils.py#L1324"}}),ue=new O({props:{name:"enable_model_cpu_offload",anchor:"diffusers.StableDiffusionImg2ImgPipeline.enable_model_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_img2img.py#L242"}}),he=new O({props:{name:"enable_sequential_cpu_offload",anchor:"diffusers.StableDiffusionImg2ImgPipeline.enable_sequential_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_img2img.py#L216"}}),_e=new O({props:{name:"class diffusers.FlaxStableDiffusionImg2ImgPipeline",anchor:"diffusers.FlaxStableDiffusionImg2ImgPipeline",parameters:[{name:"vae",val:": FlaxAutoencoderKL"},{name:"text_encoder",val:": FlaxCLIPTextModel"},{name:"tokenizer",val:": CLIPTokenizer"},{name:"unet",val:": FlaxUNet2DConditionModel"},{name:"scheduler",val:": typing.Union[diffusers.schedulers.scheduling_ddim_flax.FlaxDDIMScheduler, diffusers.schedulers.scheduling_pndm_flax.FlaxPNDMScheduler, diffusers.schedulers.scheduling_lms_discrete_flax.FlaxLMSDiscreteScheduler, diffusers.schedulers.scheduling_dpmsolver_multistep_flax.FlaxDPMSolverMultistepScheduler]"},{name:"safety_checker",val:": FlaxStableDiffusionSafetyChecker"},{name:"feature_extractor",val:": CLIPImageProcessor"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"}],parametersDescription:[{anchor:"diffusers.FlaxStableDiffusionImg2ImgPipeline.vae",description:`<strong>vae</strong> (<a href="/docs/diffusers/pr_2813/en/api/models#diffusers.FlaxAutoencoderKL">FlaxAutoencoderKL</a>) &#x2014;
Variational Auto-Encoder (VAE) Model to encode and decode images to and from latent representations.`,name:"vae"},{anchor:"diffusers.FlaxStableDiffusionImg2ImgPipeline.text_encoder",description:`<strong>text_encoder</strong> (<code>FlaxCLIPTextModel</code>) &#x2014;
Frozen text-encoder. Stable Diffusion uses the text portion of
<a href="https://huggingface.co/docs/transformers/model_doc/clip#transformers.FlaxCLIPTextModel" rel="nofollow">CLIP</a>,
specifically the <a href="https://huggingface.co/openai/clip-vit-large-patch14" rel="nofollow">clip-vit-large-patch14</a> variant.`,name:"text_encoder"},{anchor:"diffusers.FlaxStableDiffusionImg2ImgPipeline.tokenizer",description:`<strong>tokenizer</strong> (<code>CLIPTokenizer</code>) &#x2014;
Tokenizer of class
<a href="https://huggingface.co/docs/transformers/v4.21.0/en/model_doc/clip#transformers.CLIPTokenizer" rel="nofollow">CLIPTokenizer</a>.`,name:"tokenizer"},{anchor:"diffusers.FlaxStableDiffusionImg2ImgPipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/pr_2813/en/api/models#diffusers.FlaxUNet2DConditionModel">FlaxUNet2DConditionModel</a>) &#x2014; Conditional U-Net architecture to denoise the encoded image latents.',name:"unet"},{anchor:"diffusers.FlaxStableDiffusionImg2ImgPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/pr_2813/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image latents. Can be one of
<code>FlaxDDIMScheduler</code>, <code>FlaxLMSDiscreteScheduler</code>, <code>FlaxPNDMScheduler</code>, or
<code>FlaxDPMSolverMultistepScheduler</code>.`,name:"scheduler"},{anchor:"diffusers.FlaxStableDiffusionImg2ImgPipeline.safety_checker",description:`<strong>safety_checker</strong> (<code>FlaxStableDiffusionSafetyChecker</code>) &#x2014;
Classification module that estimates whether generated images could be considered offensive or harmful.
Please, refer to the <a href="https://huggingface.co/runwayml/stable-diffusion-v1-5" rel="nofollow">model card</a> for details.`,name:"safety_checker"},{anchor:"diffusers.FlaxStableDiffusionImg2ImgPipeline.feature_extractor",description:`<strong>feature_extractor</strong> (<code>CLIPImageProcessor</code>) &#x2014;
Model that extracts features from generated images to be used as inputs for the <code>safety_checker</code>.`,name:"feature_extractor"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/pipelines/stable_diffusion/pipeline_flax_stable_diffusion_img2img.py#L105"}}),ve=new O({props:{name:"__call__",anchor:"diffusers.FlaxStableDiffusionImg2ImgPipeline.__call__",parameters:[{name:"prompt_ids",val:": array"},{name:"image",val:": array"},{name:"params",val:": typing.Union[typing.Dict, flax.core.frozen_dict.FrozenDict]"},{name:"prng_seed",val:": PRNGKeyArray"},{name:"strength",val:": float = 0.8"},{name:"num_inference_steps",val:": int = 50"},{name:"height",val:": typing.Optional[int] = None"},{name:"width",val:": typing.Optional[int] = None"},{name:"guidance_scale",val:": typing.Union[float, array] = 7.5"},{name:"noise",val:": array = None"},{name:"neg_prompt_ids",val:": array = None"},{name:"return_dict",val:": bool = True"},{name:"jit",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.FlaxStableDiffusionImg2ImgPipeline.__call__.prompt_ids",description:`<strong>prompt_ids</strong> (<code>jnp.array</code>) &#x2014;
The prompt or prompts to guide the image generation.`,name:"prompt_ids"},{anchor:"diffusers.FlaxStableDiffusionImg2ImgPipeline.__call__.image",description:`<strong>image</strong> (<code>jnp.array</code>) &#x2014;
Array representing an image batch, that will be used as the starting point for the process.`,name:"image"},{anchor:"diffusers.FlaxStableDiffusionImg2ImgPipeline.__call__.params",description:"<strong>params</strong> (<code>Dict</code> or <code>FrozenDict</code>) &#x2014; Dictionary containing the model parameters/weights",name:"params"},{anchor:"diffusers.FlaxStableDiffusionImg2ImgPipeline.__call__.prng_seed",description:"<strong>prng_seed</strong> (<code>jax.random.KeyArray</code> or <code>jax.Array</code>) &#x2014; Array containing random number generator key",name:"prng_seed"},{anchor:"diffusers.FlaxStableDiffusionImg2ImgPipeline.__call__.strength",description:`<strong>strength</strong> (<code>float</code>, <em>optional</em>, defaults to 0.8) &#x2014;
Conceptually, indicates how much to transform the reference <code>image</code>. Must be between 0 and 1. <code>image</code>
will be used as a starting point, adding more noise to it the larger the <code>strength</code>. The number of
denoising steps depends on the amount of noise initially added. When <code>strength</code> is 1, added noise will
be maximum and the denoising process will run for the full number of iterations specified in`,name:"strength"},{anchor:"diffusers.FlaxStableDiffusionImg2ImgPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.FlaxStableDiffusionImg2ImgPipeline.__call__.height",description:`<strong>height</strong> (<code>int</code>, <em>optional</em>, defaults to self.unet.config.sample_size * self.vae_scale_factor) &#x2014;
The height in pixels of the generated image.`,name:"height"},{anchor:"diffusers.FlaxStableDiffusionImg2ImgPipeline.__call__.width",description:`<strong>width</strong> (<code>int</code>, <em>optional</em>, defaults to self.unet.config.sample_size * self.vae_scale_factor) &#x2014;
The width in pixels of the generated image.`,name:"width"},{anchor:"diffusers.FlaxStableDiffusionImg2ImgPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.FlaxStableDiffusionImg2ImgPipeline.__call__.noise",description:`<strong>noise</strong> (<code>jnp.array</code>, <em>optional</em>) &#x2014;
Pre-generated noisy latents, sampled from a Gaussian distribution, to be used as inputs for image
generation. Can be used to tweak the same generation with different prompts. tensor will ge generated
by sampling using the supplied random <code>generator</code>.`,name:"noise"},{anchor:"diffusers.FlaxStableDiffusionImg2ImgPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <code>FlaxStableDiffusionPipelineOutput</code> instead of
a plain tuple.`,name:"return_dict"},{anchor:"diffusers.FlaxStableDiffusionImg2ImgPipeline.__call__.jit",description:`<strong>jit</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to run <code>pmap</code> versions of the generation and safety scoring functions. NOTE: This argument
exists because <code>__call__</code> is not yet end-to-end pmap-able. It will be removed in a future release.`,name:"jit"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/pipelines/stable_diffusion/pipeline_flax_stable_diffusion_img2img.py#L338",returnDescription:`
<p><code>FlaxStableDiffusionPipelineOutput</code> if <code>return_dict</code> is True, otherwise a
<code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><code>FlaxStableDiffusionPipelineOutput</code> or <code>tuple</code></p>
`}}),Z=new Bn({props:{anchor:"diffusers.FlaxStableDiffusionImg2ImgPipeline.__call__.example",$$slots:{default:[qs]},$$scope:{ctx:G}}}),{c(){f=s("meta"),$=p(),h=s("h1"),m=s("a"),v=s("span"),I(l.$$.fragment),_=p(),ke=s("span"),ht=o("Image-to-Image Generation"),Qe=p(),N=s("h2"),U=s("a"),Ee=s("span"),I(X.$$.fragment),_t=p(),Ce=s("span"),bt=o("StableDiffusionImg2ImgPipeline"),Xe=p(),S=s("p"),vt=o("The Stable Diffusion model was created by the researchers and engineers from "),ee=s("a"),yt=o("CompVis"),It=o(", "),te=s("a"),xt=o("Stability AI"),wt=o(", "),ne=s("a"),Pt=o("runway"),Dt=o(", and "),se=s("a"),jt=o("LAION"),$t=o(". The "),Ie=s("a"),St=o("StableDiffusionImg2ImgPipeline"),kt=o(" lets you pass a text prompt and an initial image to condition the generation of new images using Stable Diffusion."),et=p(),ae=s("p"),Et=o("The original codebase can be found here: "),ie=s("a"),Ct=o("CampVis/stable-diffusion"),tt=p(),V=s("p"),xe=s("a"),Ft=o("StableDiffusionImg2ImgPipeline"),Tt=o(" is compatible with all Stable Diffusion checkpoints for "),we=s("a"),qt=o("Text-to-Image"),nt=p(),W=s("p"),At=o("The pipeline uses the diffusion-denoising mechanism proposed by SDEdit ("),oe=s("a"),Mt=o("SDEdit: Guided Image Synthesis and Editing with Stochastic Differential Equations"),Lt=o(`
proposed by Chenlin Meng, Yutong He, Yang Song, Jiaming Song, Jiajun Wu, Jun-Yan Zhu, Stefano Ermon).`),st=p(),u=s("div"),I(re.$$.fragment),Ot=p(),Fe=s("p"),Nt=o("Pipeline for text-guided image to image generation using Stable Diffusion."),zt=p(),le=s("p"),Gt=o("This model inherits from "),Pe=s("a"),Ut=o("DiffusionPipeline"),Vt=o(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),Wt=p(),T=s("div"),I(pe.$$.fragment),Bt=p(),Te=s("p"),Kt=o("Function invoked when calling the pipeline for generation."),Rt=p(),I(B.$$.fragment),Jt=p(),q=s("div"),I(ce.$$.fragment),Ht=p(),qe=s("p"),Yt=o("Enable sliced attention computation."),Zt=p(),Ae=s("p"),Qt=o(`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),Xt=p(),K=s("div"),I(de.$$.fragment),en=p(),me=s("p"),tn=o("Disable sliced attention computation. If "),Me=s("code"),nn=o("enable_attention_slicing"),sn=o(` was previously invoked, this method will go
back to computing attention in one step.`),an=p(),k=s("div"),I(fe.$$.fragment),on=p(),Le=s("p"),rn=o("Enable memory efficient attention as implemented in xformers."),ln=p(),Oe=s("p"),pn=o(`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),cn=p(),Ne=s("p"),dn=o(`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),mn=p(),I(R.$$.fragment),fn=p(),J=s("div"),I(ge.$$.fragment),gn=p(),ze=s("p"),un=o("Disable memory efficient attention as implemented in xformers."),hn=p(),H=s("div"),I(ue.$$.fragment),_n=p(),E=s("p"),bn=o(`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),Ge=s("code"),vn=o("enable_sequential_cpu_offload"),yn=o(", this method moves one whole model at a time to the GPU when its "),Ue=s("code"),In=o("forward"),xn=o(`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),Ve=s("code"),wn=o("enable_sequential_cpu_offload"),Pn=o(", but performance is much better due to the iterative execution of the "),We=s("code"),Dn=o("unet"),jn=o("."),$n=p(),Y=s("div"),I(he.$$.fragment),Sn=p(),z=s("p"),kn=o(`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae and safety checker have their state dicts saved to CPU and then are moved to a
`),Be=s("code"),En=o("torch.device('meta') and loaded to GPU only when their specific submodule has its "),Cn=o("forward"),Ke=s("code"),Fn=o("method called. Note that offloading happens on a submodule basis. Memory savings are higher than with"),Tn=o("enable_model_cpu_offload`, but performance is lower."),at=p(),C=s("div"),I(_e.$$.fragment),qn=p(),Re=s("p"),An=o("Pipeline for image-to-image generation using Stable Diffusion."),Mn=p(),be=s("p"),Ln=o("This model inherits from "),Je=s("code"),On=o("FlaxDiffusionPipeline"),Nn=o(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),zn=p(),A=s("div"),I(ve.$$.fragment),Gn=p(),He=s("p"),Un=o("Function invoked when calling the pipeline for generation."),Vn=p(),I(Z.$$.fragment),this.h()},l(t){const g=Es('[data-svelte="svelte-1phssyn"]',document.head);f=a(g,"META",{name:!0,content:!0}),g.forEach(n),$=c(t),h=a(t,"H1",{class:!0});var ye=i(h);m=a(ye,"A",{id:!0,class:!0,href:!0});var Ye=i(m);v=a(Ye,"SPAN",{});var Ze=i(v);x(l.$$.fragment,Ze),Ze.forEach(n),Ye.forEach(n),_=c(ye),ke=a(ye,"SPAN",{});var Jn=i(ke);ht=r(Jn,"Image-to-Image Generation"),Jn.forEach(n),ye.forEach(n),Qe=c(t),N=a(t,"H2",{class:!0});var ot=i(N);U=a(ot,"A",{id:!0,class:!0,href:!0});var Hn=i(U);Ee=a(Hn,"SPAN",{});var Yn=i(Ee);x(X.$$.fragment,Yn),Yn.forEach(n),Hn.forEach(n),_t=c(ot),Ce=a(ot,"SPAN",{});var Zn=i(Ce);bt=r(Zn,"StableDiffusionImg2ImgPipeline"),Zn.forEach(n),ot.forEach(n),Xe=c(t),S=a(t,"P",{});var F=i(S);vt=r(F,"The Stable Diffusion model was created by the researchers and engineers from "),ee=a(F,"A",{href:!0,rel:!0});var Qn=i(ee);yt=r(Qn,"CompVis"),Qn.forEach(n),It=r(F,", "),te=a(F,"A",{href:!0,rel:!0});var Xn=i(te);xt=r(Xn,"Stability AI"),Xn.forEach(n),wt=r(F,", "),ne=a(F,"A",{href:!0,rel:!0});var es=i(ne);Pt=r(es,"runway"),es.forEach(n),Dt=r(F,", and "),se=a(F,"A",{href:!0,rel:!0});var ts=i(se);jt=r(ts,"LAION"),ts.forEach(n),$t=r(F,". The "),Ie=a(F,"A",{href:!0});var ns=i(Ie);St=r(ns,"StableDiffusionImg2ImgPipeline"),ns.forEach(n),kt=r(F," lets you pass a text prompt and an initial image to condition the generation of new images using Stable Diffusion."),F.forEach(n),et=c(t),ae=a(t,"P",{});var Wn=i(ae);Et=r(Wn,"The original codebase can be found here: "),ie=a(Wn,"A",{href:!0,rel:!0});var ss=i(ie);Ct=r(ss,"CampVis/stable-diffusion"),ss.forEach(n),Wn.forEach(n),tt=c(t),V=a(t,"P",{});var rt=i(V);xe=a(rt,"A",{href:!0});var as=i(xe);Ft=r(as,"StableDiffusionImg2ImgPipeline"),as.forEach(n),Tt=r(rt," is compatible with all Stable Diffusion checkpoints for "),we=a(rt,"A",{href:!0});var is=i(we);qt=r(is,"Text-to-Image"),is.forEach(n),rt.forEach(n),nt=c(t),W=a(t,"P",{});var lt=i(W);At=r(lt,"The pipeline uses the diffusion-denoising mechanism proposed by SDEdit ("),oe=a(lt,"A",{href:!0,rel:!0});var os=i(oe);Mt=r(os,"SDEdit: Guided Image Synthesis and Editing with Stochastic Differential Equations"),os.forEach(n),Lt=r(lt,`
proposed by Chenlin Meng, Yutong He, Yang Song, Jiaming Song, Jiajun Wu, Jun-Yan Zhu, Stefano Ermon).`),lt.forEach(n),st=c(t),u=a(t,"DIV",{class:!0});var y=i(u);x(re.$$.fragment,y),Ot=c(y),Fe=a(y,"P",{});var rs=i(Fe);Nt=r(rs,"Pipeline for text-guided image to image generation using Stable Diffusion."),rs.forEach(n),zt=c(y),le=a(y,"P",{});var pt=i(le);Gt=r(pt,"This model inherits from "),Pe=a(pt,"A",{href:!0});var ls=i(Pe);Ut=r(ls,"DiffusionPipeline"),ls.forEach(n),Vt=r(pt,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),pt.forEach(n),Wt=c(y),T=a(y,"DIV",{class:!0});var De=i(T);x(pe.$$.fragment,De),Bt=c(De),Te=a(De,"P",{});var ps=i(Te);Kt=r(ps,"Function invoked when calling the pipeline for generation."),ps.forEach(n),Rt=c(De),x(B.$$.fragment,De),De.forEach(n),Jt=c(y),q=a(y,"DIV",{class:!0});var je=i(q);x(ce.$$.fragment,je),Ht=c(je),qe=a(je,"P",{});var cs=i(qe);Yt=r(cs,"Enable sliced attention computation."),cs.forEach(n),Zt=c(je),Ae=a(je,"P",{});var ds=i(Ae);Qt=r(ds,`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),ds.forEach(n),je.forEach(n),Xt=c(y),K=a(y,"DIV",{class:!0});var ct=i(K);x(de.$$.fragment,ct),en=c(ct),me=a(ct,"P",{});var dt=i(me);tn=r(dt,"Disable sliced attention computation. If "),Me=a(dt,"CODE",{});var ms=i(Me);nn=r(ms,"enable_attention_slicing"),ms.forEach(n),sn=r(dt,` was previously invoked, this method will go
back to computing attention in one step.`),dt.forEach(n),ct.forEach(n),an=c(y),k=a(y,"DIV",{class:!0});var M=i(k);x(fe.$$.fragment,M),on=c(M),Le=a(M,"P",{});var fs=i(Le);rn=r(fs,"Enable memory efficient attention as implemented in xformers."),fs.forEach(n),ln=c(M),Oe=a(M,"P",{});var gs=i(Oe);pn=r(gs,`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),gs.forEach(n),cn=c(M),Ne=a(M,"P",{});var us=i(Ne);dn=r(us,`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),us.forEach(n),mn=c(M),x(R.$$.fragment,M),M.forEach(n),fn=c(y),J=a(y,"DIV",{class:!0});var mt=i(J);x(ge.$$.fragment,mt),gn=c(mt),ze=a(mt,"P",{});var hs=i(ze);un=r(hs,"Disable memory efficient attention as implemented in xformers."),hs.forEach(n),mt.forEach(n),hn=c(y),H=a(y,"DIV",{class:!0});var ft=i(H);x(ue.$$.fragment,ft),_n=c(ft),E=a(ft,"P",{});var L=i(E);bn=r(L,`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),Ge=a(L,"CODE",{});var _s=i(Ge);vn=r(_s,"enable_sequential_cpu_offload"),_s.forEach(n),yn=r(L,", this method moves one whole model at a time to the GPU when its "),Ue=a(L,"CODE",{});var bs=i(Ue);In=r(bs,"forward"),bs.forEach(n),xn=r(L,`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),Ve=a(L,"CODE",{});var vs=i(Ve);wn=r(vs,"enable_sequential_cpu_offload"),vs.forEach(n),Pn=r(L,", but performance is much better due to the iterative execution of the "),We=a(L,"CODE",{});var ys=i(We);Dn=r(ys,"unet"),ys.forEach(n),jn=r(L,"."),L.forEach(n),ft.forEach(n),$n=c(y),Y=a(y,"DIV",{class:!0});var gt=i(Y);x(he.$$.fragment,gt),Sn=c(gt),z=a(gt,"P",{});var $e=i(z);kn=r($e,`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae and safety checker have their state dicts saved to CPU and then are moved to a
`),Be=a($e,"CODE",{});var Is=i(Be);En=r(Is,"torch.device('meta') and loaded to GPU only when their specific submodule has its "),Is.forEach(n),Cn=r($e,"forward"),Ke=a($e,"CODE",{});var xs=i(Ke);Fn=r(xs,"method called. Note that offloading happens on a submodule basis. Memory savings are higher than with"),xs.forEach(n),Tn=r($e,"enable_model_cpu_offload`, but performance is lower."),$e.forEach(n),gt.forEach(n),y.forEach(n),at=c(t),C=a(t,"DIV",{class:!0});var Q=i(C);x(_e.$$.fragment,Q),qn=c(Q),Re=a(Q,"P",{});var ws=i(Re);An=r(ws,"Pipeline for image-to-image generation using Stable Diffusion."),ws.forEach(n),Mn=c(Q),be=a(Q,"P",{});var ut=i(be);Ln=r(ut,"This model inherits from "),Je=a(ut,"CODE",{});var Ps=i(Je);On=r(Ps,"FlaxDiffusionPipeline"),Ps.forEach(n),Nn=r(ut,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),ut.forEach(n),zn=c(Q),A=a(Q,"DIV",{class:!0});var Se=i(A);x(ve.$$.fragment,Se),Gn=c(Se),He=a(Se,"P",{});var Ds=i(He);Un=r(Ds,"Function invoked when calling the pipeline for generation."),Ds.forEach(n),Vn=c(Se),x(Z.$$.fragment,Se),Se.forEach(n),Q.forEach(n),this.h()},h(){d(f,"name","hf:doc:metadata"),d(f,"content",JSON.stringify(Ms)),d(m,"id","imagetoimage-generation"),d(m,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(m,"href","#imagetoimage-generation"),d(h,"class","relative group"),d(U,"id","diffusers.StableDiffusionImg2ImgPipeline"),d(U,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(U,"href","#diffusers.StableDiffusionImg2ImgPipeline"),d(N,"class","relative group"),d(ee,"href","https://github.com/CompVis"),d(ee,"rel","nofollow"),d(te,"href","https://stability.ai/"),d(te,"rel","nofollow"),d(ne,"href","https://github.com/runwayml"),d(ne,"rel","nofollow"),d(se,"href","https://laion.ai/"),d(se,"rel","nofollow"),d(Ie,"href","/docs/diffusers/pr_2813/en/api/pipelines/stable_diffusion/img2img#diffusers.StableDiffusionImg2ImgPipeline"),d(ie,"href","https://github.com/CompVis/stable-diffusion/blob/main/scripts/img2img.py"),d(ie,"rel","nofollow"),d(xe,"href","/docs/diffusers/pr_2813/en/api/pipelines/stable_diffusion/img2img#diffusers.StableDiffusionImg2ImgPipeline"),d(we,"href","./text2img"),d(oe,"href","https://arxiv.org/abs/2108.01073"),d(oe,"rel","nofollow"),d(Pe,"href","/docs/diffusers/pr_2813/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),d(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(K,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(k,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(J,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(H,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(u,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,g){e(document.head,f),b(t,$,g),b(t,h,g),e(h,m),e(m,v),w(l,v,null),e(h,_),e(h,ke),e(ke,ht),b(t,Qe,g),b(t,N,g),e(N,U),e(U,Ee),w(X,Ee,null),e(N,_t),e(N,Ce),e(Ce,bt),b(t,Xe,g),b(t,S,g),e(S,vt),e(S,ee),e(ee,yt),e(S,It),e(S,te),e(te,xt),e(S,wt),e(S,ne),e(ne,Pt),e(S,Dt),e(S,se),e(se,jt),e(S,$t),e(S,Ie),e(Ie,St),e(S,kt),b(t,et,g),b(t,ae,g),e(ae,Et),e(ae,ie),e(ie,Ct),b(t,tt,g),b(t,V,g),e(V,xe),e(xe,Ft),e(V,Tt),e(V,we),e(we,qt),b(t,nt,g),b(t,W,g),e(W,At),e(W,oe),e(oe,Mt),e(W,Lt),b(t,st,g),b(t,u,g),w(re,u,null),e(u,Ot),e(u,Fe),e(Fe,Nt),e(u,zt),e(u,le),e(le,Gt),e(le,Pe),e(Pe,Ut),e(le,Vt),e(u,Wt),e(u,T),w(pe,T,null),e(T,Bt),e(T,Te),e(Te,Kt),e(T,Rt),w(B,T,null),e(u,Jt),e(u,q),w(ce,q,null),e(q,Ht),e(q,qe),e(qe,Yt),e(q,Zt),e(q,Ae),e(Ae,Qt),e(u,Xt),e(u,K),w(de,K,null),e(K,en),e(K,me),e(me,tn),e(me,Me),e(Me,nn),e(me,sn),e(u,an),e(u,k),w(fe,k,null),e(k,on),e(k,Le),e(Le,rn),e(k,ln),e(k,Oe),e(Oe,pn),e(k,cn),e(k,Ne),e(Ne,dn),e(k,mn),w(R,k,null),e(u,fn),e(u,J),w(ge,J,null),e(J,gn),e(J,ze),e(ze,un),e(u,hn),e(u,H),w(ue,H,null),e(H,_n),e(H,E),e(E,bn),e(E,Ge),e(Ge,vn),e(E,yn),e(E,Ue),e(Ue,In),e(E,xn),e(E,Ve),e(Ve,wn),e(E,Pn),e(E,We),e(We,Dn),e(E,jn),e(u,$n),e(u,Y),w(he,Y,null),e(Y,Sn),e(Y,z),e(z,kn),e(z,Be),e(Be,En),e(z,Cn),e(z,Ke),e(Ke,Fn),e(z,Tn),b(t,at,g),b(t,C,g),w(_e,C,null),e(C,qn),e(C,Re),e(Re,An),e(C,Mn),e(C,be),e(be,Ln),e(be,Je),e(Je,On),e(be,Nn),e(C,zn),e(C,A),w(ve,A,null),e(A,Gn),e(A,He),e(He,Un),e(A,Vn),w(Z,A,null),it=!0},p(t,[g]){const ye={};g&2&&(ye.$$scope={dirty:g,ctx:t}),B.$set(ye);const Ye={};g&2&&(Ye.$$scope={dirty:g,ctx:t}),R.$set(Ye);const Ze={};g&2&&(Ze.$$scope={dirty:g,ctx:t}),Z.$set(Ze)},i(t){it||(P(l.$$.fragment,t),P(X.$$.fragment,t),P(re.$$.fragment,t),P(pe.$$.fragment,t),P(B.$$.fragment,t),P(ce.$$.fragment,t),P(de.$$.fragment,t),P(fe.$$.fragment,t),P(R.$$.fragment,t),P(ge.$$.fragment,t),P(ue.$$.fragment,t),P(he.$$.fragment,t),P(_e.$$.fragment,t),P(ve.$$.fragment,t),P(Z.$$.fragment,t),it=!0)},o(t){D(l.$$.fragment,t),D(X.$$.fragment,t),D(re.$$.fragment,t),D(pe.$$.fragment,t),D(B.$$.fragment,t),D(ce.$$.fragment,t),D(de.$$.fragment,t),D(fe.$$.fragment,t),D(R.$$.fragment,t),D(ge.$$.fragment,t),D(ue.$$.fragment,t),D(he.$$.fragment,t),D(_e.$$.fragment,t),D(ve.$$.fragment,t),D(Z.$$.fragment,t),it=!1},d(t){n(f),t&&n($),t&&n(h),j(l),t&&n(Qe),t&&n(N),j(X),t&&n(Xe),t&&n(S),t&&n(et),t&&n(ae),t&&n(tt),t&&n(V),t&&n(nt),t&&n(W),t&&n(st),t&&n(u),j(re),j(pe),j(B),j(ce),j(de),j(fe),j(R),j(ge),j(ue),j(he),t&&n(at),t&&n(C),j(_e),j(ve),j(Z)}}}const Ms={local:"imagetoimage-generation",sections:[{local:"diffusers.StableDiffusionImg2ImgPipeline",title:"StableDiffusionImg2ImgPipeline"}],title:"Image-to-Image Generation"};function Ls(G){return Cs(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Vs extends $s{constructor(f){super();Ss(this,f,Ls,As,ks,{})}}export{Vs as default,Ms as metadata};
