import{S as My,i as Ny,s as Ey,e as n,k as i,w as f,t as d,M as Ay,c as s,d as t,m as l,a as r,x as u,h as c,b as a,G as e,g as p,y as h,q as _,o as g,B as b,v as Uy,L as zl}from"../../chunks/vendor-hf-doc-builder.js";import{T as Ty}from"../../chunks/Tip-hf-doc-builder.js";import{D as y}from"../../chunks/Docstring-hf-doc-builder.js";import{C as Vl}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as M}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as Il}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function Cy(I){let x,T,D,$,k;return $=new Vl({props:{code:`import torch
from diffusers import UNet2DConditionModel
from xformers.ops import MemoryEfficientAttentionFlashAttentionOp

model = UNet2DConditionModel.from_pretrained(
    "stabilityai/stable-diffusion-2-1", subfolder="unet", torch_dtype=torch.float16
)
model = model.to("cuda")
model.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> UNet2DConditionModel
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> xformers.ops <span class="hljs-keyword">import</span> MemoryEfficientAttentionFlashAttentionOp

<span class="hljs-meta">&gt;&gt;&gt; </span>model = UNet2DConditionModel.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;stabilityai/stable-diffusion-2-1&quot;</span>, subfolder=<span class="hljs-string">&quot;unet&quot;</span>, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = model.to(<span class="hljs-string">&quot;cuda&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)`}}),{c(){x=n("p"),T=d("Examples:"),D=i(),f($.$$.fragment)},l(v){x=s(v,"P",{});var w=r(x);T=c(w,"Examples:"),w.forEach(t),D=l(v),u($.$$.fragment,v)},m(v,w){p(v,x,w),e(x,T),p(v,D,w),h($,v,w),k=!0},p:zl,i(v){k||(_($.$$.fragment,v),k=!0)},o(v){g($.$$.fragment,v),k=!1},d(v){v&&t(x),v&&t(D),b($,v)}}}function Fy(I){let x,T,D,$,k,v,w,oe;return{c(){x=n("p"),T=d("It is required to be logged in ("),D=n("code"),$=d("huggingface-cli login"),k=d(") when you want to use private or "),v=n("a"),w=d(`gated
models`),oe=d("."),this.h()},l(Ee){x=s(Ee,"P",{});var X=r(x);T=c(X,"It is required to be logged in ("),D=s(X,"CODE",{});var H=r(D);$=c(H,"huggingface-cli login"),H.forEach(t),k=c(X,") when you want to use private or "),v=s(X,"A",{href:!0,rel:!0});var ir=r(v);w=c(ir,`gated
models`),ir.forEach(t),oe=c(X,"."),X.forEach(t),this.h()},h(){a(v,"href","https://huggingface.co/docs/hub/models-gated#gated-models"),a(v,"rel","nofollow")},m(Ee,X){p(Ee,x,X),e(x,T),e(x,D),e(D,$),e(x,k),e(x,v),e(v,w),e(x,oe)},d(Ee){Ee&&t(x)}}}function Py(I){let x,T,D,$,k;return{c(){x=n("p"),T=d("Activate the special "),D=n("a"),$=d("\u201Coffline-mode\u201D"),k=d(` to use
this method in a firewalled environment.`),this.h()},l(v){x=s(v,"P",{});var w=r(x);T=c(w,"Activate the special "),D=s(w,"A",{href:!0,rel:!0});var oe=r(D);$=c(oe,"\u201Coffline-mode\u201D"),oe.forEach(t),k=c(w,` to use
this method in a firewalled environment.`),w.forEach(t),this.h()},h(){a(D,"href","https://huggingface.co/diffusers/installation.html#offline-mode"),a(D,"rel","nofollow")},m(v,w){p(v,x,w),e(x,T),e(x,D),e(D,$),e(x,k)},d(v){v&&t(x)}}}function Oy(I){let x,T,D,$,k;return $=new Vl({props:{code:`from diffusers import FlaxUNet2DConditionModel

# Download model and configuration from huggingface.co and cache.
model, params = FlaxUNet2DConditionModel.from_pretrained("runwayml/stable-diffusion-v1-5")
# Model was saved using *save_pretrained('./test/saved_model/')* (for example purposes, not runnable).
model, params = FlaxUNet2DConditionModel.from_pretrained("./test/saved_model/")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> FlaxUNet2DConditionModel

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Download model and configuration from huggingface.co and cache.</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model, params = FlaxUNet2DConditionModel.from_pretrained(<span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Model was saved using *save_pretrained(&#x27;./test/saved_model/&#x27;)* (for example purposes, not runnable).</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model, params = FlaxUNet2DConditionModel.from_pretrained(<span class="hljs-string">&quot;./test/saved_model/&quot;</span>)`}}),{c(){x=n("p"),T=d("Examples:"),D=i(),f($.$$.fragment)},l(v){x=s(v,"P",{});var w=r(x);T=c(w,"Examples:"),w.forEach(t),D=l(v),u($.$$.fragment,v)},m(v,w){p(v,x,w),e(x,T),p(v,D,w),h($,v,w),k=!0},p:zl,i(v){k||(_($.$$.fragment,v),k=!0)},o(v){g($.$$.fragment,v),k=!1},d(v){v&&t(x),v&&t(D),b($,v)}}}function qy(I){let x,T,D,$,k;return $=new Vl({props:{code:`from diffusers import FlaxUNet2DConditionModel

# load model
model, params = FlaxUNet2DConditionModel.from_pretrained("runwayml/stable-diffusion-v1-5")
# By default, the model parameters will be in fp32 precision, to cast these to bfloat16 precision
params = model.to_bf16(params)
# If you don't want to cast certain parameters (for example layer norm bias and scale)
# then pass the mask as follows
from flax import traverse_util

model, params = FlaxUNet2DConditionModel.from_pretrained("runwayml/stable-diffusion-v1-5")
flat_params = traverse_util.flatten_dict(params)
mask = {
    path: (path[-2] != ("LayerNorm", "bias") and path[-2:] != ("LayerNorm", "scale"))
    for path in flat_params
}
mask = traverse_util.unflatten_dict(mask)
params = model.to_bf16(params, mask)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> FlaxUNet2DConditionModel

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># load model</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model, params = FlaxUNet2DConditionModel.from_pretrained(<span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># By default, the model parameters will be in fp32 precision, to cast these to bfloat16 precision</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>params = model.to_bf16(params)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># If you don&#x27;t want to cast certain parameters (for example layer norm bias and scale)</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># then pass the mask as follows</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> flax <span class="hljs-keyword">import</span> traverse_util

<span class="hljs-meta">&gt;&gt;&gt; </span>model, params = FlaxUNet2DConditionModel.from_pretrained(<span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>flat_params = traverse_util.flatten_dict(params)
<span class="hljs-meta">&gt;&gt;&gt; </span>mask = {
<span class="hljs-meta">... </span>    path: (path[-<span class="hljs-number">2</span>] != (<span class="hljs-string">&quot;LayerNorm&quot;</span>, <span class="hljs-string">&quot;bias&quot;</span>) <span class="hljs-keyword">and</span> path[-<span class="hljs-number">2</span>:] != (<span class="hljs-string">&quot;LayerNorm&quot;</span>, <span class="hljs-string">&quot;scale&quot;</span>))
<span class="hljs-meta">... </span>    <span class="hljs-keyword">for</span> path <span class="hljs-keyword">in</span> flat_params
<span class="hljs-meta">... </span>}
<span class="hljs-meta">&gt;&gt;&gt; </span>mask = traverse_util.unflatten_dict(mask)
<span class="hljs-meta">&gt;&gt;&gt; </span>params = model.to_bf16(params, mask)`}}),{c(){x=n("p"),T=d("Examples:"),D=i(),f($.$$.fragment)},l(v){x=s(v,"P",{});var w=r(x);T=c(w,"Examples:"),w.forEach(t),D=l(v),u($.$$.fragment,v)},m(v,w){p(v,x,w),e(x,T),p(v,D,w),h($,v,w),k=!0},p:zl,i(v){k||(_($.$$.fragment,v),k=!0)},o(v){g($.$$.fragment,v),k=!1},d(v){v&&t(x),v&&t(D),b($,v)}}}function Ly(I){let x,T,D,$,k;return $=new Vl({props:{code:`from diffusers import FlaxUNet2DConditionModel

# load model
model, params = FlaxUNet2DConditionModel.from_pretrained("runwayml/stable-diffusion-v1-5")
# By default, the model params will be in fp32, to cast these to float16
params = model.to_fp16(params)
# If you want don't want to cast certain parameters (for example layer norm bias and scale)
# then pass the mask as follows
from flax import traverse_util

model, params = FlaxUNet2DConditionModel.from_pretrained("runwayml/stable-diffusion-v1-5")
flat_params = traverse_util.flatten_dict(params)
mask = {
    path: (path[-2] != ("LayerNorm", "bias") and path[-2:] != ("LayerNorm", "scale"))
    for path in flat_params
}
mask = traverse_util.unflatten_dict(mask)
params = model.to_fp16(params, mask)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> FlaxUNet2DConditionModel

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># load model</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model, params = FlaxUNet2DConditionModel.from_pretrained(<span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># By default, the model params will be in fp32, to cast these to float16</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>params = model.to_fp16(params)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># If you want don&#x27;t want to cast certain parameters (for example layer norm bias and scale)</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># then pass the mask as follows</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> flax <span class="hljs-keyword">import</span> traverse_util

<span class="hljs-meta">&gt;&gt;&gt; </span>model, params = FlaxUNet2DConditionModel.from_pretrained(<span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>flat_params = traverse_util.flatten_dict(params)
<span class="hljs-meta">&gt;&gt;&gt; </span>mask = {
<span class="hljs-meta">... </span>    path: (path[-<span class="hljs-number">2</span>] != (<span class="hljs-string">&quot;LayerNorm&quot;</span>, <span class="hljs-string">&quot;bias&quot;</span>) <span class="hljs-keyword">and</span> path[-<span class="hljs-number">2</span>:] != (<span class="hljs-string">&quot;LayerNorm&quot;</span>, <span class="hljs-string">&quot;scale&quot;</span>))
<span class="hljs-meta">... </span>    <span class="hljs-keyword">for</span> path <span class="hljs-keyword">in</span> flat_params
<span class="hljs-meta">... </span>}
<span class="hljs-meta">&gt;&gt;&gt; </span>mask = traverse_util.unflatten_dict(mask)
<span class="hljs-meta">&gt;&gt;&gt; </span>params = model.to_fp16(params, mask)`}}),{c(){x=n("p"),T=d("Examples:"),D=i(),f($.$$.fragment)},l(v){x=s(v,"P",{});var w=r(x);T=c(w,"Examples:"),w.forEach(t),D=l(v),u($.$$.fragment,v)},m(v,w){p(v,x,w),e(x,T),p(v,D,w),h($,v,w),k=!0},p:zl,i(v){k||(_($.$$.fragment,v),k=!0)},o(v){g($.$$.fragment,v),k=!1},d(v){v&&t(x),v&&t(D),b($,v)}}}function jy(I){let x,T,D,$,k;return $=new Vl({props:{code:`from diffusers import FlaxUNet2DConditionModel

# Download model and configuration from huggingface.co
model, params = FlaxUNet2DConditionModel.from_pretrained("runwayml/stable-diffusion-v1-5")
# By default, the model params will be in fp32, to illustrate the use of this method,
# we'll first cast to fp16 and back to fp32
params = model.to_f16(params)
# now cast back to fp32
params = model.to_fp32(params)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> FlaxUNet2DConditionModel

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Download model and configuration from huggingface.co</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model, params = FlaxUNet2DConditionModel.from_pretrained(<span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># By default, the model params will be in fp32, to illustrate the use of this method,</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># we&#x27;ll first cast to fp16 and back to fp32</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>params = model.to_f16(params)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># now cast back to fp32</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>params = model.to_fp32(params)`}}),{c(){x=n("p"),T=d("Examples:"),D=i(),f($.$$.fragment)},l(v){x=s(v,"P",{});var w=r(x);T=c(w,"Examples:"),w.forEach(t),D=l(v),u($.$$.fragment,v)},m(v,w){p(v,x,w),e(x,T),p(v,D,w),h($,v,w),k=!0},p:zl,i(v){k||(_($.$$.fragment,v),k=!0)},o(v){g($.$$.fragment,v),k=!1},d(v){v&&t(x),v&&t(D),b($,v)}}}function Iy(I){let x,T,D,$,k,v,w,oe,Ee,X,H,ir,Wr,fm,um,Xr,hm,_m,Bl,Ae,uo,Hr,xt,gm,Qr,bm,Sl,N,$t,vm,Rr,ym,xm,lr,dr,$m,wm,Dm,Yr,he,Gr,km,Tm,Jr,Mm,Nm,cr,Em,Am,Um,_e,wt,Cm,Zr,Fm,Pm,ea,Om,qm,ho,Dt,Lm,oa,jm,Im,ge,kt,zm,ta,Vm,Bm,na,Sm,Km,S,Tt,Wm,sa,Xm,Hm,ra,Qm,Rm,aa,Ym,Gm,_o,Jm,F,Mt,Zm,ia,ep,op,Ue,tp,la,np,sp,da,rp,ap,ip,Nt,lp,ca,dp,cp,mp,Et,pp,ma,fp,up,hp,go,_p,bo,gp,vo,At,bp,pa,vp,yp,yo,Ut,xp,Ct,$p,fa,wp,Dp,Kl,Ce,xo,ua,Ft,kp,ha,Tp,Wl,Pt,Ot,Xl,Fe,$o,_a,qt,Mp,ga,Np,Hl,Q,Lt,Ep,ba,Ap,Up,jt,Cp,mr,Fp,Pp,Op,pr,It,Ql,Pe,wo,va,zt,qp,ya,Lp,Rl,Vt,Bt,Yl,Oe,Do,xa,St,jp,$a,Ip,Gl,R,Kt,zp,wa,Vp,Bp,Wt,Sp,fr,Kp,Wp,Xp,ur,Xt,Jl,qe,ko,Da,Ht,Hp,ka,Qp,Zl,Qt,Rt,ed,Le,To,Ta,Yt,Rp,Ma,Yp,od,P,Gt,Gp,Na,Jp,Zp,Jt,ef,hr,of,tf,nf,_r,Zt,sf,be,en,rf,Ea,af,lf,Aa,df,cf,gr,on,td,je,Mo,Ua,tn,mf,Ca,pf,nd,nn,sn,sd,Ie,No,Fa,rn,ff,Pa,uf,rd,O,an,hf,Oa,_f,gf,ln,bf,br,vf,yf,xf,vr,dn,$f,ve,cn,wf,qa,Df,kf,La,Tf,Mf,yr,mn,ad,ze,Eo,ja,pn,Nf,Ia,Ef,id,Ve,fn,Af,za,Uf,ld,Be,Ao,Va,un,Cf,Ba,Ff,dd,Se,hn,Pf,Sa,Of,cd,Ke,Uo,Ka,_n,qf,Wa,Lf,md,Y,gn,jf,Xa,If,zf,bn,Vf,xr,Bf,Sf,Kf,$r,vn,pd,We,Co,Ha,yn,Wf,Qa,Xf,fd,Xe,xn,Hf,Ra,Qf,ud,He,Fo,Ya,$n,Rf,Ga,Yf,hd,E,wn,Gf,Ja,Jf,Zf,Dn,eu,wr,ou,tu,nu,Po,kn,su,Tn,ru,Za,au,iu,lu,Oo,Mn,du,Nn,cu,ei,mu,pu,fu,qo,En,uu,oi,hu,_u,Lo,An,gu,ti,bu,vu,Dr,Un,yu,jo,Cn,xu,ni,$u,wu,Io,Fn,Du,si,ku,_d,Qe,zo,ri,Pn,Tu,ai,Mu,gd,q,On,Nu,ii,Eu,Au,li,Uu,Cu,qn,Fu,di,Pu,Ou,qu,ci,Lu,ju,kr,Ln,bd,Re,Vo,mi,jn,Iu,pi,zu,vd,In,zn,yd,Ye,Bo,fi,Vn,Vu,ui,Bu,xd,de,Bn,Su,hi,Ku,Wu,Tr,Sn,$d,Ge,So,_i,Kn,Xu,gi,Hu,wd,Wn,Xn,Dd,Je,Ko,bi,Hn,Qu,vi,Ru,kd,V,Qn,Yu,yi,Gu,Ju,Rn,Zu,Mr,eh,oh,th,Nr,nh,Yn,sh,rh,Er,Gn,Td,Ze,Wo,xi,Jn,ah,$i,ih,Md,Zn,es,Nd,eo,Xo,wi,os,lh,Di,dh,Ed,ts,ns,Ad,oo,Ho,ki,ss,ch,Ti,mh,Ud,G,rs,ph,Qo,as,fh,Mi,uh,hh,ye,is,_h,Ni,gh,bh,Ei,vh,yh,Ar,ls,Cd,to,Ro,Ai,ds,xh,Ui,$h,Fd,U,cs,wh,Ci,Dh,kh,Ur,Cr,Th,Mh,Nh,K,ms,Eh,Fi,Ah,Uh,ps,Ch,Pi,Fh,Ph,Oh,fs,qh,Oi,Lh,jh,Ih,Yo,zh,Go,us,Vh,hs,Bh,qi,Sh,Kh,Wh,te,_s,Xh,J,Hh,Li,Qh,Rh,ji,Yh,Gh,Ii,Jh,Zh,zi,e_,o_,t_,Vi,n_,s_,Jo,r_,ne,gs,a_,Z,i_,Bi,l_,d_,Si,c_,m_,Ki,p_,f_,Wi,u_,h_,__,Xi,g_,b_,Zo,v_,xe,bs,y_,ee,x_,Hi,$_,w_,Qi,D_,k_,Ri,T_,M_,Yi,N_,E_,A_,et,Pd,no,ot,Gi,vs,U_,Ji,C_,Od,so,ys,F_,tt,xs,P_,Zi,O_,qd,ro,nt,el,$s,q_,ol,L_,Ld,L,ws,j_,tl,I_,z_,Ds,V_,Fr,B_,S_,K_,ks,W_,Ts,X_,H_,Q_,nl,R_,Y_,ce,sl,Ms,G_,J_,rl,Ns,Z_,eg,al,Es,og,tg,il,As,ng,jd,ao,st,ll,Us,sg,dl,rg,Id,me,Cs,ag,cl,ig,lg,rt,Fs,dg,ml,cg,zd,io,at,pl,Ps,mg,fl,pg,Vd,pe,Os,fg,ul,ug,hg,it,qs,_g,hl,gg,Bd,lo,lt,_l,Ls,bg,gl,vg,Sd,B,js,yg,bl,xg,$g,Is,wg,zs,Dg,kg,Tg,vl,Mg,Ng,fe,yl,Vs,Eg,Ag,xl,Bs,Ug,Cg,$l,Ss,Fg,Pg,wl,Ks,Og,Kd,co,dt,Dl,Ws,qg,kl,Lg,Wd,mo,Xs,jg,ct,Hs,Ig,Tl,zg,Xd,po,mt,Ml,Qs,Vg,Nl,Bg,Hd,j,Rs,Sg,Ys,Kg,Gs,Wg,Xg,Hg,Js,Qg,Pr,Rg,Yg,Gg,Zs,Jg,er,Zg,e2,o2,El,t2,n2,ue,Al,or,s2,r2,Ul,tr,a2,i2,Cl,nr,l2,d2,Fl,sr,c2,Qd;return v=new M({}),xt=new M({}),$t=new y({props:{name:"class diffusers.ModelMixin",anchor:"diffusers.ModelMixin",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/modeling_utils.py#L156"}}),wt=new y({props:{name:"disable_gradient_checkpointing",anchor:"diffusers.ModelMixin.disable_gradient_checkpointing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/modeling_utils.py#L194"}}),Dt=new y({props:{name:"disable_xformers_memory_efficient_attention",anchor:"diffusers.ModelMixin.disable_xformers_memory_efficient_attention",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/modeling_utils.py#L253"}}),kt=new y({props:{name:"enable_gradient_checkpointing",anchor:"diffusers.ModelMixin.enable_gradient_checkpointing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/modeling_utils.py#L183"}}),Tt=new y({props:{name:"enable_xformers_memory_efficient_attention",anchor:"diffusers.ModelMixin.enable_xformers_memory_efficient_attention",parameters:[{name:"attention_op",val:": typing.Optional[typing.Callable] = None"}],parametersDescription:[{anchor:"diffusers.ModelMixin.enable_xformers_memory_efficient_attention.attention_op",description:`<strong>attention_op</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
Override the default <code>None</code> operator for use as <code>op</code> argument to the
<a href="https://facebookresearch.github.io/xformers/components/ops.html#xformers.ops.memory_efficient_attention" rel="nofollow"><code>memory_efficient_attention()</code></a>
function of xFormers.`,name:"attention_op"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/modeling_utils.py#L221"}}),_o=new Il({props:{anchor:"diffusers.ModelMixin.enable_xformers_memory_efficient_attention.example",$$slots:{default:[Cy]},$$scope:{ctx:I}}}),Mt=new y({props:{name:"from_pretrained",anchor:"diffusers.ModelMixin.from_pretrained",parameters:[{name:"pretrained_model_name_or_path",val:": typing.Union[str, os.PathLike, NoneType]"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.ModelMixin.from_pretrained.pretrained_model_name_or_path",description:`<strong>pretrained_model_name_or_path</strong> (<code>str</code> or <code>os.PathLike</code>, <em>optional</em>) &#x2014;
Can be either:</p>
<ul>
<li>A string, the <em>model id</em> of a pretrained model hosted inside a model repo on huggingface.co.
Valid model ids should have an organization name, like <code>google/ddpm-celebahq-256</code>.</li>
<li>A path to a <em>directory</em> containing model weights saved using <code>~ModelMixin.save_config</code>, e.g.,
<code>./my_model_directory/</code>.</li>
</ul>`,name:"pretrained_model_name_or_path"},{anchor:"diffusers.ModelMixin.from_pretrained.cache_dir",description:`<strong>cache_dir</strong> (<code>Union[str, os.PathLike]</code>, <em>optional</em>) &#x2014;
Path to a directory in which a downloaded pretrained model configuration should be cached if the
standard cache should not be used.`,name:"cache_dir"},{anchor:"diffusers.ModelMixin.from_pretrained.torch_dtype",description:`<strong>torch_dtype</strong> (<code>str</code> or <code>torch.dtype</code>, <em>optional</em>) &#x2014;
Override the default <code>torch.dtype</code> and load the model under this dtype. If <code>&quot;auto&quot;</code> is passed the dtype
will be automatically derived from the model&#x2019;s weights.`,name:"torch_dtype"},{anchor:"diffusers.ModelMixin.from_pretrained.force_download",description:`<strong>force_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to force the (re-)download of the model weights and configuration files, overriding the
cached versions if they exist.`,name:"force_download"},{anchor:"diffusers.ModelMixin.from_pretrained.resume_download",description:`<strong>resume_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to delete incompletely received files. Will attempt to resume the download if such a
file exists.`,name:"resume_download"},{anchor:"diffusers.ModelMixin.from_pretrained.proxies",description:`<strong>proxies</strong> (<code>Dict[str, str]</code>, <em>optional</em>) &#x2014;
A dictionary of proxy servers to use by protocol or endpoint, e.g., <code>{&apos;http&apos;: &apos;foo.bar:3128&apos;, &apos;http://hostname&apos;: &apos;foo.bar:4012&apos;}</code>. The proxies are used on each request.`,name:"proxies"},{anchor:"diffusers.ModelMixin.from_pretrained.output_loading_info(bool,",description:`<strong>output_loading_info(<code>bool</code>,</strong> <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to also return a dictionary containing missing keys, unexpected keys and error messages.`,name:"output_loading_info(bool,"},{anchor:"diffusers.ModelMixin.from_pretrained.local_files_only(bool,",description:`<strong>local_files_only(<code>bool</code>,</strong> <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to only look at local files (i.e., do not try to download the model).`,name:"local_files_only(bool,"},{anchor:"diffusers.ModelMixin.from_pretrained.use_auth_token",description:`<strong>use_auth_token</strong> (<code>str</code> or <em>bool</em>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files. If <code>True</code>, will use the token generated
when running <code>diffusers-cli login</code> (stored in <code>~/.huggingface</code>).`,name:"use_auth_token"},{anchor:"diffusers.ModelMixin.from_pretrained.revision",description:`<strong>revision</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;main&quot;</code>) &#x2014;
The specific model version to use. It can be a branch name, a tag name, or a commit id, since we use a
git-based system for storing models and other artifacts on huggingface.co, so <code>revision</code> can be any
identifier allowed by git.`,name:"revision"},{anchor:"diffusers.ModelMixin.from_pretrained.from_flax",description:`<strong>from_flax</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Load the model weights from a Flax checkpoint save file.`,name:"from_flax"},{anchor:"diffusers.ModelMixin.from_pretrained.subfolder",description:`<strong>subfolder</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&quot;</code>) &#x2014;
In case the relevant files are located inside a subfolder of the model repo (either remote in
huggingface.co or downloaded locally), you can specify the folder name here.`,name:"subfolder"},{anchor:"diffusers.ModelMixin.from_pretrained.mirror",description:`<strong>mirror</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Mirror source to accelerate downloads in China. If you are from China and have an accessibility
problem, you can set this option to resolve it. Note that we do not guarantee the timeliness or safety.
Please refer to the mirror site for more information.`,name:"mirror"},{anchor:"diffusers.ModelMixin.from_pretrained.device_map",description:`<strong>device_map</strong> (<code>str</code> or <code>Dict[str, Union[int, str, torch.device]]</code>, <em>optional</em>) &#x2014;
A map that specifies where each submodule should go. It doesn&#x2019;t need to be refined to each
parameter/buffer name, once a given module name is inside, every submodule of it will be sent to the
same device.</p>
<p>To have Accelerate compute the most optimized <code>device_map</code> automatically, set <code>device_map=&quot;auto&quot;</code>. For
more information about each option see <a href="https://hf.co/docs/accelerate/main/en/usage_guides/big_modeling#designing-a-device-map" rel="nofollow">designing a device
map</a>.`,name:"device_map"},{anchor:"diffusers.ModelMixin.from_pretrained.low_cpu_mem_usage",description:`<strong>low_cpu_mem_usage</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code> if torch version &gt;= 1.9.0 else <code>False</code>) &#x2014;
Speed up model loading by not initializing the weights and only loading the pre-trained weights. This
also tries to not use more than 1x model size in CPU memory (including peak memory) while loading the
model. This is only supported when torch version &gt;= 1.9.0. If you are using an older version of torch,
setting this argument to <code>True</code> will raise an error.`,name:"low_cpu_mem_usage"},{anchor:"diffusers.ModelMixin.from_pretrained.variant",description:`<strong>variant</strong> (<code>str</code>, <em>optional</em>) &#x2014;
If specified load weights from <code>variant</code> filename, <em>e.g.</em> pytorch_model.<variant>.bin. <code>variant</code> is
ignored when using <code>from_flax</code>.</variant>`,name:"variant"},{anchor:"diffusers.ModelMixin.from_pretrained.use_safetensors",description:`<strong>use_safetensors</strong> (<code>bool</code>, <em>optional</em> ) &#x2014;
If set to <code>True</code>, the pipeline will forcibly load the models from <code>safetensors</code> weights. If set to
<code>None</code> (the default). The pipeline will load using <code>safetensors</code> if safetensors weights are available
<em>and</em> if <code>safetensors</code> is installed. If the to <code>False</code> the pipeline will <em>not</em> use <code>safetensors</code>.`,name:"use_safetensors"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/modeling_utils.py#L319"}}),go=new Ty({props:{$$slots:{default:[Fy]},$$scope:{ctx:I}}}),bo=new Ty({props:{$$slots:{default:[Py]},$$scope:{ctx:I}}}),At=new y({props:{name:"num_parameters",anchor:"diffusers.ModelMixin.num_parameters",parameters:[{name:"only_trainable",val:": bool = False"},{name:"exclude_embeddings",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.ModelMixin.num_parameters.only_trainable",description:`<strong>only_trainable</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to return only the number of trainable parameters`,name:"only_trainable"},{anchor:"diffusers.ModelMixin.num_parameters.exclude_embeddings",description:`<strong>exclude_embeddings</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to return only the number of non-embeddings parameters`,name:"exclude_embeddings"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/modeling_utils.py#L758",returnDescription:`
<p>The number of parameters.</p>
`,returnType:`
<p><code>int</code></p>
`}}),Ut=new y({props:{name:"save_pretrained",anchor:"diffusers.ModelMixin.save_pretrained",parameters:[{name:"save_directory",val:": typing.Union[str, os.PathLike]"},{name:"is_main_process",val:": bool = True"},{name:"save_function",val:": typing.Callable = None"},{name:"safe_serialization",val:": bool = False"},{name:"variant",val:": typing.Optional[str] = None"}],parametersDescription:[{anchor:"diffusers.ModelMixin.save_pretrained.save_directory",description:`<strong>save_directory</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Directory to which to save. Will be created if it doesn&#x2019;t exist.`,name:"save_directory"},{anchor:"diffusers.ModelMixin.save_pretrained.is_main_process",description:`<strong>is_main_process</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether the process calling this is the main process or not. Useful when in distributed training like
TPUs and need to call this function on all processes. In this case, set <code>is_main_process=True</code> only on
the main process to avoid race conditions.`,name:"is_main_process"},{anchor:"diffusers.ModelMixin.save_pretrained.save_function",description:`<strong>save_function</strong> (<code>Callable</code>) &#x2014;
The function to use to save the state dictionary. Useful on distributed training like TPUs when one
need to replace <code>torch.save</code> by another method. Can be configured with the environment variable
<code>DIFFUSERS_SAVE_MODE</code>.`,name:"save_function"},{anchor:"diffusers.ModelMixin.save_pretrained.safe_serialization",description:`<strong>safe_serialization</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to save the model using <code>safetensors</code> or the traditional PyTorch way (that uses <code>pickle</code>).`,name:"safe_serialization"},{anchor:"diffusers.ModelMixin.save_pretrained.variant",description:`<strong>variant</strong> (<code>str</code>, <em>optional</em>) &#x2014;
If specified, weights are saved in the format pytorch_model.<variant>.bin.</variant>`,name:"variant"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/modeling_utils.py#L259"}}),Ft=new M({}),Ot=new y({props:{name:"class diffusers.models.unet_2d.UNet2DOutput",anchor:"diffusers.models.unet_2d.UNet2DOutput",parameters:[{name:"sample",val:": FloatTensor"}],parametersDescription:[{anchor:"diffusers.models.unet_2d.UNet2DOutput.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Hidden states output. Output of last layer of model.`,name:"sample"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/unet_2d.py#L28"}}),qt=new M({}),Lt=new y({props:{name:"class diffusers.UNet2DModel",anchor:"diffusers.UNet2DModel",parameters:[{name:"sample_size",val:": typing.Union[int, typing.Tuple[int, int], NoneType] = None"},{name:"in_channels",val:": int = 3"},{name:"out_channels",val:": int = 3"},{name:"center_input_sample",val:": bool = False"},{name:"time_embedding_type",val:": str = 'positional'"},{name:"freq_shift",val:": int = 0"},{name:"flip_sin_to_cos",val:": bool = True"},{name:"down_block_types",val:": typing.Tuple[str] = ('DownBlock2D', 'AttnDownBlock2D', 'AttnDownBlock2D', 'AttnDownBlock2D')"},{name:"up_block_types",val:": typing.Tuple[str] = ('AttnUpBlock2D', 'AttnUpBlock2D', 'AttnUpBlock2D', 'UpBlock2D')"},{name:"block_out_channels",val:": typing.Tuple[int] = (224, 448, 672, 896)"},{name:"layers_per_block",val:": int = 2"},{name:"mid_block_scale_factor",val:": float = 1"},{name:"downsample_padding",val:": int = 1"},{name:"act_fn",val:": str = 'silu'"},{name:"attention_head_dim",val:": typing.Optional[int] = 8"},{name:"norm_num_groups",val:": int = 32"},{name:"norm_eps",val:": float = 1e-05"},{name:"resnet_time_scale_shift",val:": str = 'default'"},{name:"add_attention",val:": bool = True"},{name:"class_embed_type",val:": typing.Optional[str] = None"},{name:"num_class_embeds",val:": typing.Optional[int] = None"}],parametersDescription:[{anchor:"diffusers.UNet2DModel.sample_size",description:`<strong>sample_size</strong> (<code>int</code> or <code>Tuple[int, int]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Height and width of input/output sample.`,name:"sample_size"},{anchor:"diffusers.UNet2DModel.in_channels",description:"<strong>in_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014; Number of channels in the input image.",name:"in_channels"},{anchor:"diffusers.UNet2DModel.out_channels",description:"<strong>out_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014; Number of channels in the output.",name:"out_channels"},{anchor:"diffusers.UNet2DModel.center_input_sample",description:"<strong>center_input_sample</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014; Whether to center the input sample.",name:"center_input_sample"},{anchor:"diffusers.UNet2DModel.time_embedding_type",description:"<strong>time_embedding_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;positional&quot;</code>) &#x2014; Type of time embedding to use.",name:"time_embedding_type"},{anchor:"diffusers.UNet2DModel.freq_shift",description:"<strong>freq_shift</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014; Frequency shift for fourier time embedding.",name:"freq_shift"},{anchor:"diffusers.UNet2DModel.flip_sin_to_cos",description:`<strong>flip_sin_to_cos</strong> (<code>bool</code>, <em>optional</em>, defaults to  &#x2014;
obj:<code>True</code>): Whether to flip sin to cos for fourier time embedding.`,name:"flip_sin_to_cos"},{anchor:"diffusers.UNet2DModel.down_block_types",description:`<strong>down_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to  &#x2014;
obj:<code>(&quot;DownBlock2D&quot;, &quot;AttnDownBlock2D&quot;, &quot;AttnDownBlock2D&quot;, &quot;AttnDownBlock2D&quot;)</code>): Tuple of downsample block
types.`,name:"down_block_types"},{anchor:"diffusers.UNet2DModel.mid_block_type",description:`<strong>mid_block_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;UNetMidBlock2D&quot;</code>) &#x2014;
The mid block type. Choose from <code>UNetMidBlock2D</code> or <code>UnCLIPUNetMidBlock2D</code>.`,name:"mid_block_type"},{anchor:"diffusers.UNet2DModel.up_block_types",description:`<strong>up_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to  &#x2014;
obj:<code>(&quot;AttnUpBlock2D&quot;, &quot;AttnUpBlock2D&quot;, &quot;AttnUpBlock2D&quot;, &quot;UpBlock2D&quot;)</code>): Tuple of upsample block types.`,name:"up_block_types"},{anchor:"diffusers.UNet2DModel.block_out_channels",description:`<strong>block_out_channels</strong> (<code>Tuple[int]</code>, <em>optional</em>, defaults to  &#x2014;
obj:<code>(224, 448, 672, 896)</code>): Tuple of block output channels.`,name:"block_out_channels"},{anchor:"diffusers.UNet2DModel.layers_per_block",description:"<strong>layers_per_block</strong> (<code>int</code>, <em>optional</em>, defaults to <code>2</code>) &#x2014; The number of layers per block.",name:"layers_per_block"},{anchor:"diffusers.UNet2DModel.mid_block_scale_factor",description:"<strong>mid_block_scale_factor</strong> (<code>float</code>, <em>optional</em>, defaults to <code>1</code>) &#x2014; The scale factor for the mid block.",name:"mid_block_scale_factor"},{anchor:"diffusers.UNet2DModel.downsample_padding",description:"<strong>downsample_padding</strong> (<code>int</code>, <em>optional</em>, defaults to <code>1</code>) &#x2014; The padding for the downsample convolution.",name:"downsample_padding"},{anchor:"diffusers.UNet2DModel.act_fn",description:"<strong>act_fn</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;silu&quot;</code>) &#x2014; The activation function to use.",name:"act_fn"},{anchor:"diffusers.UNet2DModel.attention_head_dim",description:"<strong>attention_head_dim</strong> (<code>int</code>, <em>optional</em>, defaults to <code>8</code>) &#x2014; The attention head dimension.",name:"attention_head_dim"},{anchor:"diffusers.UNet2DModel.norm_num_groups",description:"<strong>norm_num_groups</strong> (<code>int</code>, <em>optional</em>, defaults to <code>32</code>) &#x2014; The number of groups for the normalization.",name:"norm_num_groups"},{anchor:"diffusers.UNet2DModel.norm_eps",description:"<strong>norm_eps</strong> (<code>float</code>, <em>optional</em>, defaults to <code>1e-5</code>) &#x2014; The epsilon for the normalization.",name:"norm_eps"},{anchor:"diffusers.UNet2DModel.resnet_time_scale_shift",description:`<strong>resnet_time_scale_shift</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;default&quot;</code>) &#x2014; Time scale shift config
for resnet blocks, see <code>ResnetBlock2D</code>. Choose from <code>default</code> or <code>scale_shift</code>.`,name:"resnet_time_scale_shift"},{anchor:"diffusers.UNet2DModel.class_embed_type",description:`<strong>class_embed_type</strong> (<code>str</code>, <em>optional</em>, defaults to None) &#x2014;
The type of class embedding to use which is ultimately summed with the time embeddings. Choose from <code>None</code>,
<code>&quot;timestep&quot;</code>, or <code>&quot;identity&quot;</code>.`,name:"class_embed_type"},{anchor:"diffusers.UNet2DModel.num_class_embeds",description:`<strong>num_class_embeds</strong> (<code>int</code>, <em>optional</em>, defaults to None) &#x2014;
Input dimension of the learnable embedding matrix to be projected to <code>time_embed_dim</code>, when performing
class conditioning with <code>class_embed_type</code> equal to <code>None</code>.`,name:"num_class_embeds"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/unet_2d.py#L38"}}),It=new y({props:{name:"forward",anchor:"diffusers.UNet2DModel.forward",parameters:[{name:"sample",val:": FloatTensor"},{name:"timestep",val:": typing.Union[torch.Tensor, float, int]"},{name:"class_labels",val:": typing.Optional[torch.Tensor] = None"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.UNet2DModel.forward.sample",description:"<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014; (batch, channel, height, width) noisy inputs tensor",name:"sample"},{anchor:"diffusers.UNet2DModel.forward.timestep",description:"<strong>timestep</strong> (<code>torch.FloatTensor</code> or <code>float</code> or `int) &#x2014; (batch) timesteps",name:"timestep"},{anchor:"diffusers.UNet2DModel.forward.class_labels",description:`<strong>class_labels</strong> (<code>torch.FloatTensor</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Optional class labels for conditioning. Their embeddings will be summed with the timestep embeddings.`,name:"class_labels"},{anchor:"diffusers.UNet2DModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/pr_2813/en/api/models#diffusers.models.unet_2d.UNet2DOutput">UNet2DOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/unet_2d.py#L218",returnDescription:`
<p><a
  href="/docs/diffusers/pr_2813/en/api/models#diffusers.models.unet_2d.UNet2DOutput"
>UNet2DOutput</a> if <code>return_dict</code> is True,
otherwise a <code>tuple</code>. When returning a tuple, the first element is the sample tensor.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/pr_2813/en/api/models#diffusers.models.unet_2d.UNet2DOutput"
>UNet2DOutput</a> or <code>tuple</code></p>
`}}),zt=new M({}),Bt=new y({props:{name:"class diffusers.models.unet_1d.UNet1DOutput",anchor:"diffusers.models.unet_1d.UNet1DOutput",parameters:[{name:"sample",val:": FloatTensor"}],parametersDescription:[{anchor:"diffusers.models.unet_1d.UNet1DOutput.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, sample_size)</code>) &#x2014;
Hidden states output. Output of last layer of model.`,name:"sample"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/unet_1d.py#L29"}}),St=new M({}),Kt=new y({props:{name:"class diffusers.UNet1DModel",anchor:"diffusers.UNet1DModel",parameters:[{name:"sample_size",val:": int = 65536"},{name:"sample_rate",val:": typing.Optional[int] = None"},{name:"in_channels",val:": int = 2"},{name:"out_channels",val:": int = 2"},{name:"extra_in_channels",val:": int = 0"},{name:"time_embedding_type",val:": str = 'fourier'"},{name:"flip_sin_to_cos",val:": bool = True"},{name:"use_timestep_embedding",val:": bool = False"},{name:"freq_shift",val:": float = 0.0"},{name:"down_block_types",val:": typing.Tuple[str] = ('DownBlock1DNoSkip', 'DownBlock1D', 'AttnDownBlock1D')"},{name:"up_block_types",val:": typing.Tuple[str] = ('AttnUpBlock1D', 'UpBlock1D', 'UpBlock1DNoSkip')"},{name:"mid_block_type",val:": typing.Tuple[str] = 'UNetMidBlock1D'"},{name:"out_block_type",val:": str = None"},{name:"block_out_channels",val:": typing.Tuple[int] = (32, 32, 64)"},{name:"act_fn",val:": str = None"},{name:"norm_num_groups",val:": int = 8"},{name:"layers_per_block",val:": int = 1"},{name:"downsample_each_block",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.UNet1DModel.sample_size",description:"<strong>sample_size</strong> (<code>int</code>, <em>optional</em>) &#x2014; Default length of sample. Should be adaptable at runtime.",name:"sample_size"},{anchor:"diffusers.UNet1DModel.in_channels",description:"<strong>in_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 2) &#x2014; Number of channels in the input sample.",name:"in_channels"},{anchor:"diffusers.UNet1DModel.out_channels",description:"<strong>out_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 2) &#x2014; Number of channels in the output.",name:"out_channels"},{anchor:"diffusers.UNet1DModel.time_embedding_type",description:"<strong>time_embedding_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;fourier&quot;</code>) &#x2014; Type of time embedding to use.",name:"time_embedding_type"},{anchor:"diffusers.UNet1DModel.freq_shift",description:"<strong>freq_shift</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014; Frequency shift for fourier time embedding.",name:"freq_shift"},{anchor:"diffusers.UNet1DModel.flip_sin_to_cos",description:`<strong>flip_sin_to_cos</strong> (<code>bool</code>, <em>optional</em>, defaults to  &#x2014;
obj:<code>False</code>): Whether to flip sin to cos for fourier time embedding.`,name:"flip_sin_to_cos"},{anchor:"diffusers.UNet1DModel.down_block_types",description:`<strong>down_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to  &#x2014;
obj:<code>(&quot;DownBlock1D&quot;, &quot;DownBlock1DNoSkip&quot;, &quot;AttnDownBlock1D&quot;)</code>): Tuple of downsample block types.`,name:"down_block_types"},{anchor:"diffusers.UNet1DModel.up_block_types",description:`<strong>up_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to  &#x2014;
obj:<code>(&quot;UpBlock1D&quot;, &quot;UpBlock1DNoSkip&quot;, &quot;AttnUpBlock1D&quot;)</code>): Tuple of upsample block types.`,name:"up_block_types"},{anchor:"diffusers.UNet1DModel.block_out_channels",description:`<strong>block_out_channels</strong> (<code>Tuple[int]</code>, <em>optional</em>, defaults to  &#x2014;
obj:<code>(32, 32, 64)</code>): Tuple of block output channels.`,name:"block_out_channels"},{anchor:"diffusers.UNet1DModel.mid_block_type",description:"<strong>mid_block_type</strong> (<code>str</code>, <em>optional</em>, defaults to &#x201C;UNetMidBlock1D&#x201D;) &#x2014; block type for middle of UNet.",name:"mid_block_type"},{anchor:"diffusers.UNet1DModel.out_block_type",description:"<strong>out_block_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014; optional output processing of UNet.",name:"out_block_type"},{anchor:"diffusers.UNet1DModel.act_fn",description:"<strong>act_fn</strong> (<code>str</code>, <em>optional</em>, defaults to None) &#x2014; optional activation function in UNet blocks.",name:"act_fn"},{anchor:"diffusers.UNet1DModel.norm_num_groups",description:"<strong>norm_num_groups</strong> (<code>int</code>, <em>optional</em>, defaults to 8) &#x2014; group norm member count in UNet blocks.",name:"norm_num_groups"},{anchor:"diffusers.UNet1DModel.layers_per_block",description:"<strong>layers_per_block</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014; added number of layers in a UNet block.",name:"layers_per_block"},{anchor:"diffusers.UNet1DModel.downsample_each_block",description:`<strong>downsample_each_block</strong> (<code>int</code>, <em>optional</em>, defaults to False &#x2014;
experimental feature for using a UNet without upsampling.`,name:"downsample_each_block"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/unet_1d.py#L39"}}),Xt=new y({props:{name:"forward",anchor:"diffusers.UNet1DModel.forward",parameters:[{name:"sample",val:": FloatTensor"},{name:"timestep",val:": typing.Union[torch.Tensor, float, int]"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.UNet1DModel.forward.sample",description:"<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014; <code>(batch_size, num_channels, sample_size)</code> noisy inputs tensor",name:"sample"},{anchor:"diffusers.UNet1DModel.forward.timestep",description:"<strong>timestep</strong> (<code>torch.FloatTensor</code> or <code>float</code> or `int) &#x2014; (batch) timesteps",name:"timestep"},{anchor:"diffusers.UNet1DModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/pr_2813/en/api/models#diffusers.models.unet_1d.UNet1DOutput">UNet1DOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/unet_1d.py#L190",returnDescription:`
<p><a
  href="/docs/diffusers/pr_2813/en/api/models#diffusers.models.unet_1d.UNet1DOutput"
>UNet1DOutput</a> if <code>return_dict</code> is True,
otherwise a <code>tuple</code>. When returning a tuple, the first element is the sample tensor.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/pr_2813/en/api/models#diffusers.models.unet_1d.UNet1DOutput"
>UNet1DOutput</a> or <code>tuple</code></p>
`}}),Ht=new M({}),Rt=new y({props:{name:"class diffusers.models.unet_2d_condition.UNet2DConditionOutput",anchor:"diffusers.models.unet_2d_condition.UNet2DConditionOutput",parameters:[{name:"sample",val:": FloatTensor"}],parametersDescription:[{anchor:"diffusers.models.unet_2d_condition.UNet2DConditionOutput.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Hidden states conditioned on <code>encoder_hidden_states</code> input. Output of last layer of model.`,name:"sample"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/unet_2d_condition.py#L43"}}),Yt=new M({}),Gt=new y({props:{name:"class diffusers.UNet2DConditionModel",anchor:"diffusers.UNet2DConditionModel",parameters:[{name:"sample_size",val:": typing.Optional[int] = None"},{name:"in_channels",val:": int = 4"},{name:"out_channels",val:": int = 4"},{name:"center_input_sample",val:": bool = False"},{name:"flip_sin_to_cos",val:": bool = True"},{name:"freq_shift",val:": int = 0"},{name:"down_block_types",val:": typing.Tuple[str] = ('CrossAttnDownBlock2D', 'CrossAttnDownBlock2D', 'CrossAttnDownBlock2D', 'DownBlock2D')"},{name:"mid_block_type",val:": typing.Optional[str] = 'UNetMidBlock2DCrossAttn'"},{name:"up_block_types",val:": typing.Tuple[str] = ('UpBlock2D', 'CrossAttnUpBlock2D', 'CrossAttnUpBlock2D', 'CrossAttnUpBlock2D')"},{name:"only_cross_attention",val:": typing.Union[bool, typing.Tuple[bool]] = False"},{name:"block_out_channels",val:": typing.Tuple[int] = (320, 640, 1280, 1280)"},{name:"layers_per_block",val:": int = 2"},{name:"downsample_padding",val:": int = 1"},{name:"mid_block_scale_factor",val:": float = 1"},{name:"act_fn",val:": str = 'silu'"},{name:"norm_num_groups",val:": typing.Optional[int] = 32"},{name:"norm_eps",val:": float = 1e-05"},{name:"cross_attention_dim",val:": typing.Union[int, typing.Tuple[int]] = 1280"},{name:"attention_head_dim",val:": typing.Union[int, typing.Tuple[int]] = 8"},{name:"dual_cross_attention",val:": bool = False"},{name:"use_linear_projection",val:": bool = False"},{name:"class_embed_type",val:": typing.Optional[str] = None"},{name:"num_class_embeds",val:": typing.Optional[int] = None"},{name:"upcast_attention",val:": bool = False"},{name:"resnet_time_scale_shift",val:": str = 'default'"},{name:"time_embedding_type",val:": str = 'positional'"},{name:"timestep_post_act",val:": typing.Optional[str] = None"},{name:"time_cond_proj_dim",val:": typing.Optional[int] = None"},{name:"conv_in_kernel",val:": int = 3"},{name:"conv_out_kernel",val:": int = 3"},{name:"projection_class_embeddings_input_dim",val:": typing.Optional[int] = None"},{name:"class_embeddings_concat",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.UNet2DConditionModel.sample_size",description:`<strong>sample_size</strong> (<code>int</code> or <code>Tuple[int, int]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Height and width of input/output sample.`,name:"sample_size"},{anchor:"diffusers.UNet2DConditionModel.in_channels",description:"<strong>in_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 4) &#x2014; The number of channels in the input sample.",name:"in_channels"},{anchor:"diffusers.UNet2DConditionModel.out_channels",description:"<strong>out_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 4) &#x2014; The number of channels in the output.",name:"out_channels"},{anchor:"diffusers.UNet2DConditionModel.center_input_sample",description:"<strong>center_input_sample</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014; Whether to center the input sample.",name:"center_input_sample"},{anchor:"diffusers.UNet2DConditionModel.flip_sin_to_cos",description:`<strong>flip_sin_to_cos</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to flip the sin to cos in the time embedding.`,name:"flip_sin_to_cos"},{anchor:"diffusers.UNet2DConditionModel.freq_shift",description:"<strong>freq_shift</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014; The frequency shift to apply to the time embedding.",name:"freq_shift"},{anchor:"diffusers.UNet2DConditionModel.down_block_types",description:`<strong>down_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to <code>(&quot;CrossAttnDownBlock2D&quot;, &quot;CrossAttnDownBlock2D&quot;, &quot;CrossAttnDownBlock2D&quot;, &quot;DownBlock2D&quot;)</code>) &#x2014;
The tuple of downsample blocks to use.`,name:"down_block_types"},{anchor:"diffusers.UNet2DConditionModel.mid_block_type",description:`<strong>mid_block_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;UNetMidBlock2DCrossAttn&quot;</code>) &#x2014;
The mid block type. Choose from <code>UNetMidBlock2DCrossAttn</code> or <code>UNetMidBlock2DSimpleCrossAttn</code>, will skip the
mid block layer if <code>None</code>.`,name:"mid_block_type"},{anchor:"diffusers.UNet2DConditionModel.up_block_types",description:`<strong>up_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to <code>(&quot;UpBlock2D&quot;, &quot;CrossAttnUpBlock2D&quot;, &quot;CrossAttnUpBlock2D&quot;, &quot;CrossAttnUpBlock2D&quot;,)</code>) &#x2014;
The tuple of upsample blocks to use.`,name:"up_block_types"},{anchor:"diffusers.UNet2DConditionModel.only_cross_attention(bool",description:`<strong>only_cross_attention(<code>bool</code></strong> or <code>Tuple[bool]</code>, <em>optional</em>, default to <code>False</code>) &#x2014;
Whether to include self-attention in the basic transformer blocks, see
<code>BasicTransformerBlock</code>.`,name:"only_cross_attention(bool"},{anchor:"diffusers.UNet2DConditionModel.block_out_channels",description:`<strong>block_out_channels</strong> (<code>Tuple[int]</code>, <em>optional</em>, defaults to <code>(320, 640, 1280, 1280)</code>) &#x2014;
The tuple of output channels for each block.`,name:"block_out_channels"},{anchor:"diffusers.UNet2DConditionModel.layers_per_block",description:"<strong>layers_per_block</strong> (<code>int</code>, <em>optional</em>, defaults to 2) &#x2014; The number of layers per block.",name:"layers_per_block"},{anchor:"diffusers.UNet2DConditionModel.downsample_padding",description:"<strong>downsample_padding</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014; The padding to use for the downsampling convolution.",name:"downsample_padding"},{anchor:"diffusers.UNet2DConditionModel.mid_block_scale_factor",description:"<strong>mid_block_scale_factor</strong> (<code>float</code>, <em>optional</em>, defaults to 1.0) &#x2014; The scale factor to use for the mid block.",name:"mid_block_scale_factor"},{anchor:"diffusers.UNet2DConditionModel.act_fn",description:"<strong>act_fn</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;silu&quot;</code>) &#x2014; The activation function to use.",name:"act_fn"},{anchor:"diffusers.UNet2DConditionModel.norm_num_groups",description:`<strong>norm_num_groups</strong> (<code>int</code>, <em>optional</em>, defaults to 32) &#x2014; The number of groups to use for the normalization.
If <code>None</code>, it will skip the normalization and activation layers in post-processing`,name:"norm_num_groups"},{anchor:"diffusers.UNet2DConditionModel.norm_eps",description:"<strong>norm_eps</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-5) &#x2014; The epsilon to use for the normalization.",name:"norm_eps"},{anchor:"diffusers.UNet2DConditionModel.cross_attention_dim",description:`<strong>cross_attention_dim</strong> (<code>int</code> or <code>Tuple[int]</code>, <em>optional</em>, defaults to 1280) &#x2014;
The dimension of the cross attention features.`,name:"cross_attention_dim"},{anchor:"diffusers.UNet2DConditionModel.attention_head_dim",description:"<strong>attention_head_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 8) &#x2014; The dimension of the attention heads.",name:"attention_head_dim"},{anchor:"diffusers.UNet2DConditionModel.resnet_time_scale_shift",description:`<strong>resnet_time_scale_shift</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;default&quot;</code>) &#x2014; Time scale shift config
for resnet blocks, see <code>ResnetBlock2D</code>. Choose from <code>default</code> or <code>scale_shift</code>.`,name:"resnet_time_scale_shift"},{anchor:"diffusers.UNet2DConditionModel.class_embed_type",description:`<strong>class_embed_type</strong> (<code>str</code>, <em>optional</em>, defaults to None) &#x2014;
The type of class embedding to use which is ultimately summed with the time embeddings. Choose from <code>None</code>,
<code>&quot;timestep&quot;</code>, <code>&quot;identity&quot;</code>, <code>&quot;projection&quot;</code>, or <code>&quot;simple_projection&quot;</code>.`,name:"class_embed_type"},{anchor:"diffusers.UNet2DConditionModel.num_class_embeds",description:`<strong>num_class_embeds</strong> (<code>int</code>, <em>optional</em>, defaults to None) &#x2014;
Input dimension of the learnable embedding matrix to be projected to <code>time_embed_dim</code>, when performing
class conditioning with <code>class_embed_type</code> equal to <code>None</code>.`,name:"num_class_embeds"},{anchor:"diffusers.UNet2DConditionModel.time_embedding_type",description:`<strong>time_embedding_type</strong> (<code>str</code>, <em>optional</em>, default to <code>positional</code>) &#x2014;
The type of position embedding to use for timesteps. Choose from <code>positional</code> or <code>fourier</code>.`,name:"time_embedding_type"},{anchor:"diffusers.UNet2DConditionModel.timestep_post_act",description:"<strong>timestep_post_act</strong> (<code>str, *optional*, default to </code>None<code>) -- The second activation function to use in timestep embedding. Choose from </code>silu<code>, </code>mish<code>and</code>gelu`.",name:"timestep_post_act"},{anchor:"diffusers.UNet2DConditionModel.time_cond_proj_dim",description:`<strong>time_cond_proj_dim</strong> (<code>int</code>, <em>optional</em>, default to <code>None</code>) &#x2014;
The dimension of <code>cond_proj</code> layer in timestep embedding.`,name:"time_cond_proj_dim"},{anchor:"diffusers.UNet2DConditionModel.conv_in_kernel",description:"<strong>conv_in_kernel</strong> (<code>int</code>, <em>optional</em>, default to <code>3</code>) &#x2014; The kernel size of <code>conv_in</code> layer.",name:"conv_in_kernel"},{anchor:"diffusers.UNet2DConditionModel.conv_out_kernel",description:"<strong>conv_out_kernel</strong> (<code>int</code>, <em>optional</em>, default to <code>3</code>) &#x2014; The kernel size of <code>conv_out</code> layer.",name:"conv_out_kernel"},{anchor:"diffusers.UNet2DConditionModel.projection_class_embeddings_input_dim",description:`<strong>projection_class_embeddings_input_dim</strong> (<code>int</code>, <em>optional</em>) &#x2014; The dimension of the <code>class_labels</code> input when
using the &#x201C;projection&#x201D; <code>class_embed_type</code>. Required when using the &#x201C;projection&#x201D; <code>class_embed_type</code>.`,name:"projection_class_embeddings_input_dim"},{anchor:"diffusers.UNet2DConditionModel.class_embeddings_concat",description:"<strong>class_embeddings_concat</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014; Whether to concatenate the time",name:"class_embeddings_concat"},{anchor:"diffusers.UNet2DConditionModel.embeddings",description:"<strong>embeddings</strong> with the class embeddings. &#x2014;",name:"embeddings"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/unet_2d_condition.py#L53"}}),Zt=new y({props:{name:"forward",anchor:"diffusers.UNet2DConditionModel.forward",parameters:[{name:"sample",val:": FloatTensor"},{name:"timestep",val:": typing.Union[torch.Tensor, float, int]"},{name:"encoder_hidden_states",val:": Tensor"},{name:"class_labels",val:": typing.Optional[torch.Tensor] = None"},{name:"timestep_cond",val:": typing.Optional[torch.Tensor] = None"},{name:"attention_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"cross_attention_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"},{name:"down_block_additional_residuals",val:": typing.Optional[typing.Tuple[torch.Tensor]] = None"},{name:"mid_block_additional_residual",val:": typing.Optional[torch.Tensor] = None"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.UNet2DConditionModel.forward.sample",description:"<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014; (batch, channel, height, width) noisy inputs tensor",name:"sample"},{anchor:"diffusers.UNet2DConditionModel.forward.timestep",description:"<strong>timestep</strong> (<code>torch.FloatTensor</code> or <code>float</code> or <code>int</code>) &#x2014; (batch) timesteps",name:"timestep"},{anchor:"diffusers.UNet2DConditionModel.forward.encoder_hidden_states",description:"<strong>encoder_hidden_states</strong> (<code>torch.FloatTensor</code>) &#x2014; (batch, sequence_length, feature_dim) encoder hidden states",name:"encoder_hidden_states"},{anchor:"diffusers.UNet2DConditionModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/pr_2813/en/api/models#diffusers.models.unet_2d_condition.UNet2DConditionOutput">models.unet_2d_condition.UNet2DConditionOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"diffusers.UNet2DConditionModel.forward.cross_attention_kwargs",description:`<strong>cross_attention_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
A kwargs dictionary that if specified is passed along to the <code>AttentionProcessor</code> as defined under
<code>self.processor</code> in
<a href="https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/cross_attention.py" rel="nofollow">diffusers.cross_attention</a>.`,name:"cross_attention_kwargs"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/unet_2d_condition.py#L514",returnDescription:`
<p><a
  href="/docs/diffusers/pr_2813/en/api/models#diffusers.models.unet_2d_condition.UNet2DConditionOutput"
>UNet2DConditionOutput</a> if <code>return_dict</code> is True, otherwise a <code>tuple</code>. When
returning a tuple, the first element is the sample tensor.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/pr_2813/en/api/models#diffusers.models.unet_2d_condition.UNet2DConditionOutput"
>UNet2DConditionOutput</a> or <code>tuple</code></p>
`}}),en=new y({props:{name:"set_attention_slice",anchor:"diffusers.UNet2DConditionModel.set_attention_slice",parameters:[{name:"slice_size",val:""}],parametersDescription:[{anchor:"diffusers.UNet2DConditionModel.set_attention_slice.slice_size",description:`<strong>slice_size</strong> (<code>str</code> or <code>int</code> or <code>list(int)</code>, <em>optional</em>, defaults to <code>&quot;auto&quot;</code>) &#x2014;
When <code>&quot;auto&quot;</code>, halves the input to the attention heads, so attention will be computed in two steps. If
<code>&quot;max&quot;</code>, maximum amount of memory will be saved by running only one slice at a time. If a number is
provided, uses as many slices as <code>attention_head_dim // slice_size</code>. In this case, <code>attention_head_dim</code>
must be a multiple of <code>slice_size</code>.`,name:"slice_size"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/unet_2d_condition.py#L445"}}),on=new y({props:{name:"set_attn_processor",anchor:"diffusers.UNet2DConditionModel.set_attn_processor",parameters:[{name:"processor",val:": typing.Union[diffusers.models.attention_processor.AttnProcessor, diffusers.models.attention_processor.XFormersAttnProcessor, diffusers.models.attention_processor.SlicedAttnProcessor, diffusers.models.attention_processor.AttnAddedKVProcessor, diffusers.models.attention_processor.SlicedAttnAddedKVProcessor, diffusers.models.attention_processor.LoRAAttnProcessor, diffusers.models.attention_processor.LoRAXFormersAttnProcessor, typing.Dict[str, typing.Union[diffusers.models.attention_processor.AttnProcessor, diffusers.models.attention_processor.XFormersAttnProcessor, diffusers.models.attention_processor.SlicedAttnProcessor, diffusers.models.attention_processor.AttnAddedKVProcessor, diffusers.models.attention_processor.SlicedAttnAddedKVProcessor, diffusers.models.attention_processor.LoRAAttnProcessor, diffusers.models.attention_processor.LoRAXFormersAttnProcessor]]]"}],parametersDescription:[{anchor:"diffusers.UNet2DConditionModel.set_attn_processor.`processor",description:`<strong>\`processor</strong> (<code>dict</code> of <code>AttentionProcessor</code> or <code>AttentionProcessor</code>) &#x2014;
The instantiated processor class or a dictionary of processor classes that will be set as the processor
of <strong>all</strong> <code>Attention</code> layers.`,name:"`processor"},{anchor:"diffusers.UNet2DConditionModel.set_attn_processor.In",description:"<strong>In</strong> case <code>processor</code> is a dict, the key needs to define the path to the corresponding cross attention processor. This is strongly recommended when setting trainable attention processors. &#x2014;",name:"In"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/unet_2d_condition.py#L415"}}),tn=new M({}),sn=new y({props:{name:"class diffusers.models.unet_3d_condition.UNet3DConditionOutput",anchor:"diffusers.models.unet_3d_condition.UNet3DConditionOutput",parameters:[{name:"sample",val:": FloatTensor"}],parametersDescription:[{anchor:"diffusers.models.unet_3d_condition.UNet3DConditionOutput.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_frames, num_channels, height, width)</code>) &#x2014;
Hidden states conditioned on <code>encoder_hidden_states</code> input. Output of last layer of model.`,name:"sample"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/unet_3d_condition.py#L43"}}),rn=new M({}),an=new y({props:{name:"class diffusers.UNet3DConditionModel",anchor:"diffusers.UNet3DConditionModel",parameters:[{name:"sample_size",val:": typing.Optional[int] = None"},{name:"in_channels",val:": int = 4"},{name:"out_channels",val:": int = 4"},{name:"down_block_types",val:": typing.Tuple[str] = ('CrossAttnDownBlock3D', 'CrossAttnDownBlock3D', 'CrossAttnDownBlock3D', 'DownBlock3D')"},{name:"up_block_types",val:": typing.Tuple[str] = ('UpBlock3D', 'CrossAttnUpBlock3D', 'CrossAttnUpBlock3D', 'CrossAttnUpBlock3D')"},{name:"block_out_channels",val:": typing.Tuple[int] = (320, 640, 1280, 1280)"},{name:"layers_per_block",val:": int = 2"},{name:"downsample_padding",val:": int = 1"},{name:"mid_block_scale_factor",val:": float = 1"},{name:"act_fn",val:": str = 'silu'"},{name:"norm_num_groups",val:": typing.Optional[int] = 32"},{name:"norm_eps",val:": float = 1e-05"},{name:"cross_attention_dim",val:": int = 1024"},{name:"attention_head_dim",val:": typing.Union[int, typing.Tuple[int]] = 64"}],parametersDescription:[{anchor:"diffusers.UNet3DConditionModel.sample_size",description:`<strong>sample_size</strong> (<code>int</code> or <code>Tuple[int, int]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Height and width of input/output sample.`,name:"sample_size"},{anchor:"diffusers.UNet3DConditionModel.in_channels",description:"<strong>in_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 4) &#x2014; The number of channels in the input sample.",name:"in_channels"},{anchor:"diffusers.UNet3DConditionModel.out_channels",description:"<strong>out_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 4) &#x2014; The number of channels in the output.",name:"out_channels"},{anchor:"diffusers.UNet3DConditionModel.down_block_types",description:`<strong>down_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to <code>(&quot;CrossAttnDownBlock2D&quot;, &quot;CrossAttnDownBlock2D&quot;, &quot;CrossAttnDownBlock2D&quot;, &quot;DownBlock2D&quot;)</code>) &#x2014;
The tuple of downsample blocks to use.`,name:"down_block_types"},{anchor:"diffusers.UNet3DConditionModel.up_block_types",description:`<strong>up_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to <code>(&quot;UpBlock2D&quot;, &quot;CrossAttnUpBlock2D&quot;, &quot;CrossAttnUpBlock2D&quot;, &quot;CrossAttnUpBlock2D&quot;,)</code>) &#x2014;
The tuple of upsample blocks to use.`,name:"up_block_types"},{anchor:"diffusers.UNet3DConditionModel.block_out_channels",description:`<strong>block_out_channels</strong> (<code>Tuple[int]</code>, <em>optional</em>, defaults to <code>(320, 640, 1280, 1280)</code>) &#x2014;
The tuple of output channels for each block.`,name:"block_out_channels"},{anchor:"diffusers.UNet3DConditionModel.layers_per_block",description:"<strong>layers_per_block</strong> (<code>int</code>, <em>optional</em>, defaults to 2) &#x2014; The number of layers per block.",name:"layers_per_block"},{anchor:"diffusers.UNet3DConditionModel.downsample_padding",description:"<strong>downsample_padding</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014; The padding to use for the downsampling convolution.",name:"downsample_padding"},{anchor:"diffusers.UNet3DConditionModel.mid_block_scale_factor",description:"<strong>mid_block_scale_factor</strong> (<code>float</code>, <em>optional</em>, defaults to 1.0) &#x2014; The scale factor to use for the mid block.",name:"mid_block_scale_factor"},{anchor:"diffusers.UNet3DConditionModel.act_fn",description:"<strong>act_fn</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;silu&quot;</code>) &#x2014; The activation function to use.",name:"act_fn"},{anchor:"diffusers.UNet3DConditionModel.norm_num_groups",description:`<strong>norm_num_groups</strong> (<code>int</code>, <em>optional</em>, defaults to 32) &#x2014; The number of groups to use for the normalization.
If <code>None</code>, it will skip the normalization and activation layers in post-processing`,name:"norm_num_groups"},{anchor:"diffusers.UNet3DConditionModel.norm_eps",description:"<strong>norm_eps</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-5) &#x2014; The epsilon to use for the normalization.",name:"norm_eps"},{anchor:"diffusers.UNet3DConditionModel.cross_attention_dim",description:"<strong>cross_attention_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 1280) &#x2014; The dimension of the cross attention features.",name:"cross_attention_dim"},{anchor:"diffusers.UNet3DConditionModel.attention_head_dim",description:"<strong>attention_head_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 8) &#x2014; The dimension of the attention heads.",name:"attention_head_dim"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/unet_3d_condition.py#L53"}}),dn=new y({props:{name:"forward",anchor:"diffusers.UNet3DConditionModel.forward",parameters:[{name:"sample",val:": FloatTensor"},{name:"timestep",val:": typing.Union[torch.Tensor, float, int]"},{name:"encoder_hidden_states",val:": Tensor"},{name:"class_labels",val:": typing.Optional[torch.Tensor] = None"},{name:"timestep_cond",val:": typing.Optional[torch.Tensor] = None"},{name:"attention_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"cross_attention_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"},{name:"down_block_additional_residuals",val:": typing.Optional[typing.Tuple[torch.Tensor]] = None"},{name:"mid_block_additional_residual",val:": typing.Optional[torch.Tensor] = None"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.UNet3DConditionModel.forward.sample",description:"<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014; (batch, num_frames, channel, height, width) noisy inputs tensor",name:"sample"},{anchor:"diffusers.UNet3DConditionModel.forward.timestep",description:"<strong>timestep</strong> (<code>torch.FloatTensor</code> or <code>float</code> or <code>int</code>) &#x2014; (batch) timesteps",name:"timestep"},{anchor:"diffusers.UNet3DConditionModel.forward.encoder_hidden_states",description:"<strong>encoder_hidden_states</strong> (<code>torch.FloatTensor</code>) &#x2014; (batch, sequence_length, feature_dim) encoder hidden states",name:"encoder_hidden_states"},{anchor:"diffusers.UNet3DConditionModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <code>models.unet_2d_condition.UNet3DConditionOutput</code> instead of a plain tuple.`,name:"return_dict"},{anchor:"diffusers.UNet3DConditionModel.forward.cross_attention_kwargs",description:`<strong>cross_attention_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
A kwargs dictionary that if specified is passed along to the <code>AttentionProcessor</code> as defined under
<code>self.processor</code> in
<a href="https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/cross_attention.py" rel="nofollow">diffusers.cross_attention</a>.`,name:"cross_attention_kwargs"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/unet_3d_condition.py#L379",returnDescription:`
<p><code>~models.unet_2d_condition.UNet3DConditionOutput</code> if <code>return_dict</code> is True, otherwise a <code>tuple</code>. When
returning a tuple, the first element is the sample tensor.</p>
`,returnType:`
<p><code>~models.unet_2d_condition.UNet3DConditionOutput</code> or <code>tuple</code></p>
`}}),cn=new y({props:{name:"set_attention_slice",anchor:"diffusers.UNet3DConditionModel.set_attention_slice",parameters:[{name:"slice_size",val:""}],parametersDescription:[{anchor:"diffusers.UNet3DConditionModel.set_attention_slice.slice_size",description:`<strong>slice_size</strong> (<code>str</code> or <code>int</code> or <code>list(int)</code>, <em>optional</em>, defaults to <code>&quot;auto&quot;</code>) &#x2014;
When <code>&quot;auto&quot;</code>, halves the input to the attention heads, so attention will be computed in two steps. If
<code>&quot;max&quot;</code>, maximum amount of memory will be saved by running only one slice at a time. If a number is
provided, uses as many slices as <code>attention_head_dim // slice_size</code>. In this case, <code>attention_head_dim</code>
must be a multiple of <code>slice_size</code>.`,name:"slice_size"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/unet_3d_condition.py#L279"}}),mn=new y({props:{name:"set_attn_processor",anchor:"diffusers.UNet3DConditionModel.set_attn_processor",parameters:[{name:"processor",val:": typing.Union[diffusers.models.attention_processor.AttnProcessor, diffusers.models.attention_processor.XFormersAttnProcessor, diffusers.models.attention_processor.SlicedAttnProcessor, diffusers.models.attention_processor.AttnAddedKVProcessor, diffusers.models.attention_processor.SlicedAttnAddedKVProcessor, diffusers.models.attention_processor.LoRAAttnProcessor, diffusers.models.attention_processor.LoRAXFormersAttnProcessor, typing.Dict[str, typing.Union[diffusers.models.attention_processor.AttnProcessor, diffusers.models.attention_processor.XFormersAttnProcessor, diffusers.models.attention_processor.SlicedAttnProcessor, diffusers.models.attention_processor.AttnAddedKVProcessor, diffusers.models.attention_processor.SlicedAttnAddedKVProcessor, diffusers.models.attention_processor.LoRAAttnProcessor, diffusers.models.attention_processor.LoRAXFormersAttnProcessor]]]"}],parametersDescription:[{anchor:"diffusers.UNet3DConditionModel.set_attn_processor.`processor",description:`<strong>\`processor</strong> (<code>dict</code> of <code>AttentionProcessor</code> or <code>AttentionProcessor</code>) &#x2014;
The instantiated processor class or a dictionary of processor classes that will be set as the processor
of <strong>all</strong> <code>Attention</code> layers.`,name:"`processor"},{anchor:"diffusers.UNet3DConditionModel.set_attn_processor.In",description:"<strong>In</strong> case <code>processor</code> is a dict, the key needs to define the path to the corresponding cross attention processor. This is strongly recommended when setting trainable attention processors. &#x2014;",name:"In"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/unet_3d_condition.py#L345"}}),pn=new M({}),fn=new y({props:{name:"class diffusers.models.vae.DecoderOutput",anchor:"diffusers.models.vae.DecoderOutput",parameters:[{name:"sample",val:": FloatTensor"}],parametersDescription:[{anchor:"diffusers.models.vae.DecoderOutput.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Decoded output sample of the model. Output of the last layer of the model.`,name:"sample"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/vae.py#L26"}}),un=new M({}),hn=new y({props:{name:"class diffusers.models.vq_model.VQEncoderOutput",anchor:"diffusers.models.vq_model.VQEncoderOutput",parameters:[{name:"latents",val:": FloatTensor"}],parametersDescription:[{anchor:"diffusers.models.vq_model.VQEncoderOutput.latents",description:`<strong>latents</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Encoded output sample of the model. Output of the last layer of the model.`,name:"latents"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/vq_model.py#L27"}}),_n=new M({}),gn=new y({props:{name:"class diffusers.VQModel",anchor:"diffusers.VQModel",parameters:[{name:"in_channels",val:": int = 3"},{name:"out_channels",val:": int = 3"},{name:"down_block_types",val:": typing.Tuple[str] = ('DownEncoderBlock2D',)"},{name:"up_block_types",val:": typing.Tuple[str] = ('UpDecoderBlock2D',)"},{name:"block_out_channels",val:": typing.Tuple[int] = (64,)"},{name:"layers_per_block",val:": int = 1"},{name:"act_fn",val:": str = 'silu'"},{name:"latent_channels",val:": int = 3"},{name:"sample_size",val:": int = 32"},{name:"num_vq_embeddings",val:": int = 256"},{name:"norm_num_groups",val:": int = 32"},{name:"vq_embed_dim",val:": typing.Optional[int] = None"},{name:"scaling_factor",val:": float = 0.18215"}],parametersDescription:[{anchor:"diffusers.VQModel.in_channels",description:"<strong>in_channels</strong> (int, <em>optional</em>, defaults to 3) &#x2014; Number of channels in the input image.",name:"in_channels"},{anchor:"diffusers.VQModel.out_channels",description:"<strong>out_channels</strong> (int,  <em>optional</em>, defaults to 3) &#x2014; Number of channels in the output.",name:"out_channels"},{anchor:"diffusers.VQModel.down_block_types",description:`<strong>down_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to  &#x2014;
obj:<code>(&quot;DownEncoderBlock2D&quot;,)</code>): Tuple of downsample block types.`,name:"down_block_types"},{anchor:"diffusers.VQModel.up_block_types",description:`<strong>up_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to  &#x2014;
obj:<code>(&quot;UpDecoderBlock2D&quot;,)</code>): Tuple of upsample block types.`,name:"up_block_types"},{anchor:"diffusers.VQModel.block_out_channels",description:`<strong>block_out_channels</strong> (<code>Tuple[int]</code>, <em>optional</em>, defaults to  &#x2014;
obj:<code>(64,)</code>): Tuple of block output channels.`,name:"block_out_channels"},{anchor:"diffusers.VQModel.act_fn",description:"<strong>act_fn</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;silu&quot;</code>) &#x2014; The activation function to use.",name:"act_fn"},{anchor:"diffusers.VQModel.latent_channels",description:"<strong>latent_channels</strong> (<code>int</code>, <em>optional</em>, defaults to <code>3</code>) &#x2014; Number of channels in the latent space.",name:"latent_channels"},{anchor:"diffusers.VQModel.sample_size",description:"<strong>sample_size</strong> (<code>int</code>, <em>optional</em>, defaults to <code>32</code>) &#x2014; TODO",name:"sample_size"},{anchor:"diffusers.VQModel.num_vq_embeddings",description:"<strong>num_vq_embeddings</strong> (<code>int</code>, <em>optional</em>, defaults to <code>256</code>) &#x2014; Number of codebook vectors in the VQ-VAE.",name:"num_vq_embeddings"},{anchor:"diffusers.VQModel.vq_embed_dim",description:"<strong>vq_embed_dim</strong> (<code>int</code>, <em>optional</em>) &#x2014; Hidden dim of codebook vectors in the VQ-VAE.",name:"vq_embed_dim"},{anchor:"diffusers.VQModel.scaling_factor",description:`<strong>scaling_factor</strong> (<code>float</code>, <em>optional</em>, defaults to <code>0.18215</code>) &#x2014;
The component-wise standard deviation of the trained latent space computed using the first batch of the
training set. This is used to scale the latent space to have unit variance when training the diffusion
model. The latents are scaled with the formula <code>z = z * scaling_factor</code> before being passed to the
diffusion model. When decoding, the latents are scaled back to the original scale with the formula: <code>z = 1 / scaling_factor * z</code>. For more details, refer to sections 4.3.2 and D.1 of the <a href="https://arxiv.org/abs/2112.10752" rel="nofollow">High-Resolution Image
Synthesis with Latent Diffusion Models</a> paper.`,name:"scaling_factor"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/vq_model.py#L39"}}),vn=new y({props:{name:"forward",anchor:"diffusers.VQModel.forward",parameters:[{name:"sample",val:": FloatTensor"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.VQModel.forward.sample",description:"<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014; Input sample.",name:"sample"},{anchor:"diffusers.VQModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <code>DecoderOutput</code> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/vq_model.py#L142"}}),yn=new M({}),xn=new y({props:{name:"class diffusers.models.autoencoder_kl.AutoencoderKLOutput",anchor:"diffusers.models.autoencoder_kl.AutoencoderKLOutput",parameters:[{name:"latent_dist",val:": DiagonalGaussianDistribution"}],parametersDescription:[{anchor:"diffusers.models.autoencoder_kl.AutoencoderKLOutput.latent_dist",description:`<strong>latent_dist</strong> (<code>DiagonalGaussianDistribution</code>) &#x2014;
Encoded outputs of <code>Encoder</code> represented as the mean and logvar of <code>DiagonalGaussianDistribution</code>.
<code>DiagonalGaussianDistribution</code> allows for sampling latents from the distribution.`,name:"latent_dist"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/autoencoder_kl.py#L27"}}),$n=new M({}),wn=new y({props:{name:"class diffusers.AutoencoderKL",anchor:"diffusers.AutoencoderKL",parameters:[{name:"in_channels",val:": int = 3"},{name:"out_channels",val:": int = 3"},{name:"down_block_types",val:": typing.Tuple[str] = ('DownEncoderBlock2D',)"},{name:"up_block_types",val:": typing.Tuple[str] = ('UpDecoderBlock2D',)"},{name:"block_out_channels",val:": typing.Tuple[int] = (64,)"},{name:"layers_per_block",val:": int = 1"},{name:"act_fn",val:": str = 'silu'"},{name:"latent_channels",val:": int = 4"},{name:"norm_num_groups",val:": int = 32"},{name:"sample_size",val:": int = 32"},{name:"scaling_factor",val:": float = 0.18215"}],parametersDescription:[{anchor:"diffusers.AutoencoderKL.in_channels",description:"<strong>in_channels</strong> (int, <em>optional</em>, defaults to 3) &#x2014; Number of channels in the input image.",name:"in_channels"},{anchor:"diffusers.AutoencoderKL.out_channels",description:"<strong>out_channels</strong> (int,  <em>optional</em>, defaults to 3) &#x2014; Number of channels in the output.",name:"out_channels"},{anchor:"diffusers.AutoencoderKL.down_block_types",description:`<strong>down_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to  &#x2014;
obj:<code>(&quot;DownEncoderBlock2D&quot;,)</code>): Tuple of downsample block types.`,name:"down_block_types"},{anchor:"diffusers.AutoencoderKL.up_block_types",description:`<strong>up_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to  &#x2014;
obj:<code>(&quot;UpDecoderBlock2D&quot;,)</code>): Tuple of upsample block types.`,name:"up_block_types"},{anchor:"diffusers.AutoencoderKL.block_out_channels",description:`<strong>block_out_channels</strong> (<code>Tuple[int]</code>, <em>optional</em>, defaults to  &#x2014;
obj:<code>(64,)</code>): Tuple of block output channels.`,name:"block_out_channels"},{anchor:"diffusers.AutoencoderKL.act_fn",description:"<strong>act_fn</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;silu&quot;</code>) &#x2014; The activation function to use.",name:"act_fn"},{anchor:"diffusers.AutoencoderKL.latent_channels",description:"<strong>latent_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 4) &#x2014; Number of channels in the latent space.",name:"latent_channels"},{anchor:"diffusers.AutoencoderKL.sample_size",description:"<strong>sample_size</strong> (<code>int</code>, <em>optional</em>, defaults to <code>32</code>) &#x2014; TODO",name:"sample_size"},{anchor:"diffusers.AutoencoderKL.scaling_factor",description:`<strong>scaling_factor</strong> (<code>float</code>, <em>optional</em>, defaults to 0.18215) &#x2014;
The component-wise standard deviation of the trained latent space computed using the first batch of the
training set. This is used to scale the latent space to have unit variance when training the diffusion
model. The latents are scaled with the formula <code>z = z * scaling_factor</code> before being passed to the
diffusion model. When decoding, the latents are scaled back to the original scale with the formula: <code>z = 1 / scaling_factor * z</code>. For more details, refer to sections 4.3.2 and D.1 of the <a href="https://arxiv.org/abs/2112.10752" rel="nofollow">High-Resolution Image
Synthesis with Latent Diffusion Models</a> paper.`,name:"scaling_factor"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/autoencoder_kl.py#L40"}}),kn=new y({props:{name:"disable_slicing",anchor:"diffusers.AutoencoderKL.disable_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/autoencoder_kl.py#L152"}}),Mn=new y({props:{name:"disable_tiling",anchor:"diffusers.AutoencoderKL.disable_tiling",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/autoencoder_kl.py#L138"}}),En=new y({props:{name:"enable_slicing",anchor:"diffusers.AutoencoderKL.enable_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/autoencoder_kl.py#L145"}}),An=new y({props:{name:"enable_tiling",anchor:"diffusers.AutoencoderKL.enable_tiling",parameters:[{name:"use_tiling",val:": bool = True"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/autoencoder_kl.py#L130"}}),Un=new y({props:{name:"forward",anchor:"diffusers.AutoencoderKL.forward",parameters:[{name:"sample",val:": FloatTensor"},{name:"sample_posterior",val:": bool = False"},{name:"return_dict",val:": bool = True"},{name:"generator",val:": typing.Optional[torch._C.Generator] = None"}],parametersDescription:[{anchor:"diffusers.AutoencoderKL.forward.sample",description:"<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014; Input sample.",name:"sample"},{anchor:"diffusers.AutoencoderKL.forward.sample_posterior",description:`<strong>sample_posterior</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to sample from the posterior.`,name:"sample_posterior"},{anchor:"diffusers.AutoencoderKL.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <code>DecoderOutput</code> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/autoencoder_kl.py#L302"}}),Cn=new y({props:{name:"tiled_decode",anchor:"diffusers.AutoencoderKL.tiled_decode",parameters:[{name:"z",val:": FloatTensor"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.AutoencoderKL.tiled_decode.When",description:"<strong>When</strong> this option is enabled, the VAE will split the input tensor into tiles to compute decoding in several &#x2014;",name:"When"},{anchor:"diffusers.AutoencoderKL.tiled_decode.steps.",description:"<strong>steps.</strong> This is useful to keep memory use constant regardless of image size. The end result of tiled decoding is &#x2014;",name:"steps."},{anchor:"diffusers.AutoencoderKL.tiled_decode.different",description:"<strong>different</strong> from non-tiled decoding due to each tile using a different decoder. To avoid tiling artifacts, the &#x2014;",name:"different"},{anchor:"diffusers.AutoencoderKL.tiled_decode.tiles",description:"<strong>tiles</strong> overlap and are blended together to form a smooth output. You may still see tile-sized changes in the &#x2014;",name:"tiles"},{anchor:"diffusers.AutoencoderKL.tiled_decode.look",description:`<strong>look</strong> of the output, but they should be much less noticeable. &#x2014;
z (<code>torch.FloatTensor</code>): Input batch of latent vectors. return_dict (<code>bool</code>, <em>optional</em>, defaults to
<code>True</code>):
Whether or not to return a <code>DecoderOutput</code> instead of a plain tuple.`,name:"look"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/autoencoder_kl.py#L255"}}),Fn=new y({props:{name:"tiled_encode",anchor:"diffusers.AutoencoderKL.tiled_encode",parameters:[{name:"x",val:": FloatTensor"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.AutoencoderKL.tiled_encode.When",description:"<strong>When</strong> this option is enabled, the VAE will split the input tensor into tiles to compute encoding in several &#x2014;",name:"When"},{anchor:"diffusers.AutoencoderKL.tiled_encode.steps.",description:"<strong>steps.</strong> This is useful to keep memory use constant regardless of image size. The end result of tiled encoding is &#x2014;",name:"steps."},{anchor:"diffusers.AutoencoderKL.tiled_encode.different",description:"<strong>different</strong> from non-tiled encoding due to each tile using a different encoder. To avoid tiling artifacts, the &#x2014;",name:"different"},{anchor:"diffusers.AutoencoderKL.tiled_encode.tiles",description:"<strong>tiles</strong> overlap and are blended together to form a smooth output. You may still see tile-sized changes in the &#x2014;",name:"tiles"},{anchor:"diffusers.AutoencoderKL.tiled_encode.look",description:`<strong>look</strong> of the output, but they should be much less noticeable. &#x2014;
x (<code>torch.FloatTensor</code>): Input batch of images. return_dict (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>):
Whether or not to return a <code>AutoencoderKLOutput</code> instead of a plain tuple.`,name:"look"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/autoencoder_kl.py#L208"}}),Pn=new M({}),On=new y({props:{name:"class diffusers.Transformer2DModel",anchor:"diffusers.Transformer2DModel",parameters:[{name:"num_attention_heads",val:": int = 16"},{name:"attention_head_dim",val:": int = 88"},{name:"in_channels",val:": typing.Optional[int] = None"},{name:"out_channels",val:": typing.Optional[int] = None"},{name:"num_layers",val:": int = 1"},{name:"dropout",val:": float = 0.0"},{name:"norm_num_groups",val:": int = 32"},{name:"cross_attention_dim",val:": typing.Optional[int] = None"},{name:"attention_bias",val:": bool = False"},{name:"sample_size",val:": typing.Optional[int] = None"},{name:"num_vector_embeds",val:": typing.Optional[int] = None"},{name:"patch_size",val:": typing.Optional[int] = None"},{name:"activation_fn",val:": str = 'geglu'"},{name:"num_embeds_ada_norm",val:": typing.Optional[int] = None"},{name:"use_linear_projection",val:": bool = False"},{name:"only_cross_attention",val:": bool = False"},{name:"upcast_attention",val:": bool = False"},{name:"norm_type",val:": str = 'layer_norm'"},{name:"norm_elementwise_affine",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.Transformer2DModel.num_attention_heads",description:"<strong>num_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 16) &#x2014; The number of heads to use for multi-head attention.",name:"num_attention_heads"},{anchor:"diffusers.Transformer2DModel.attention_head_dim",description:"<strong>attention_head_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 88) &#x2014; The number of channels in each head.",name:"attention_head_dim"},{anchor:"diffusers.Transformer2DModel.in_channels",description:`<strong>in_channels</strong> (<code>int</code>, <em>optional</em>) &#x2014;
Pass if the input is continuous. The number of channels in the input and output.`,name:"in_channels"},{anchor:"diffusers.Transformer2DModel.num_layers",description:"<strong>num_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014; The number of layers of Transformer blocks to use.",name:"num_layers"},{anchor:"diffusers.Transformer2DModel.dropout",description:"<strong>dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014; The dropout probability to use.",name:"dropout"},{anchor:"diffusers.Transformer2DModel.cross_attention_dim",description:"<strong>cross_attention_dim</strong> (<code>int</code>, <em>optional</em>) &#x2014; The number of encoder_hidden_states dimensions to use.",name:"cross_attention_dim"},{anchor:"diffusers.Transformer2DModel.sample_size",description:`<strong>sample_size</strong> (<code>int</code>, <em>optional</em>) &#x2014; Pass if the input is discrete. The width of the latent images.
Note that this is fixed at training time as it is used for learning a number of position embeddings. See
<code>ImagePositionalEmbeddings</code>.`,name:"sample_size"},{anchor:"diffusers.Transformer2DModel.num_vector_embeds",description:`<strong>num_vector_embeds</strong> (<code>int</code>, <em>optional</em>) &#x2014;
Pass if the input is discrete. The number of classes of the vector embeddings of the latent pixels.
Includes the class for the masked latent pixel.`,name:"num_vector_embeds"},{anchor:"diffusers.Transformer2DModel.activation_fn",description:"<strong>activation_fn</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;geglu&quot;</code>) &#x2014; Activation function to be used in feed-forward.",name:"activation_fn"},{anchor:"diffusers.Transformer2DModel.num_embeds_ada_norm",description:`<strong>num_embeds_ada_norm</strong> ( <code>int</code>, <em>optional</em>) &#x2014; Pass if at least one of the norm_layers is <code>AdaLayerNorm</code>.
The number of diffusion steps used during training. Note that this is fixed at training time as it is used
to learn a number of embeddings that are added to the hidden states. During inference, you can denoise for
up to but not more than steps than <code>num_embeds_ada_norm</code>.`,name:"num_embeds_ada_norm"},{anchor:"diffusers.Transformer2DModel.attention_bias",description:`<strong>attention_bias</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Configure if the TransformerBlocks&#x2019; attention should contain a bias parameter.`,name:"attention_bias"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/transformer_2d.py#L41"}}),Ln=new y({props:{name:"forward",anchor:"diffusers.Transformer2DModel.forward",parameters:[{name:"hidden_states",val:""},{name:"encoder_hidden_states",val:" = None"},{name:"timestep",val:" = None"},{name:"class_labels",val:" = None"},{name:"cross_attention_kwargs",val:" = None"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.Transformer2DModel.forward.hidden_states",description:`<strong>hidden_states</strong> ( When discrete, <code>torch.LongTensor</code> of shape <code>(batch size, num latent pixels)</code>. &#x2014;
When continuous, <code>torch.FloatTensor</code> of shape <code>(batch size, channel, height, width)</code>): Input
hidden_states`,name:"hidden_states"},{anchor:"diffusers.Transformer2DModel.forward.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong> ( <code>torch.LongTensor</code> of shape <code>(batch size, encoder_hidden_states dim)</code>, <em>optional</em>) &#x2014;
Conditional embeddings for cross attention layer. If not given, cross-attention defaults to
self-attention.`,name:"encoder_hidden_states"},{anchor:"diffusers.Transformer2DModel.forward.timestep",description:`<strong>timestep</strong> ( <code>torch.long</code>, <em>optional</em>) &#x2014;
Optional timestep to be applied as an embedding in AdaLayerNorm&#x2019;s. Used to indicate denoising step.`,name:"timestep"},{anchor:"diffusers.Transformer2DModel.forward.class_labels",description:`<strong>class_labels</strong> ( <code>torch.LongTensor</code> of shape <code>(batch size, num classes)</code>, <em>optional</em>) &#x2014;
Optional class labels to be applied as an embedding in AdaLayerZeroNorm. Used to indicate class labels
conditioning.`,name:"class_labels"},{anchor:"diffusers.Transformer2DModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/pr_2813/en/api/models#diffusers.models.unet_2d_condition.UNet2DConditionOutput">models.unet_2d_condition.UNet2DConditionOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/transformer_2d.py#L214",returnDescription:`
<p><a
  href="/docs/diffusers/pr_2813/en/api/models#diffusers.models.transformer_2d.Transformer2DModelOutput"
>Transformer2DModelOutput</a> if <code>return_dict</code> is True, otherwise a <code>tuple</code>. When
returning a tuple, the first element is the sample tensor.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/pr_2813/en/api/models#diffusers.models.transformer_2d.Transformer2DModelOutput"
>Transformer2DModelOutput</a> or <code>tuple</code></p>
`}}),jn=new M({}),zn=new y({props:{name:"class diffusers.models.transformer_2d.Transformer2DModelOutput",anchor:"diffusers.models.transformer_2d.Transformer2DModelOutput",parameters:[{name:"sample",val:": FloatTensor"}],parametersDescription:[{anchor:"diffusers.models.transformer_2d.Transformer2DModelOutput.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code> or <code>(batch size, num_vector_embeds - 1, num_latent_pixels)</code> if <a href="/docs/diffusers/pr_2813/en/api/models#diffusers.Transformer2DModel">Transformer2DModel</a> is discrete) &#x2014;
Hidden states conditioned on <code>encoder_hidden_states</code> input. If discrete, returns probability distributions
for the unnoised latent pixels.`,name:"sample"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/transformer_2d.py#L30"}}),Vn=new M({}),Bn=new y({props:{name:"class diffusers.models.transformer_temporal.TransformerTemporalModel",anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel",parameters:[{name:"num_attention_heads",val:": int = 16"},{name:"attention_head_dim",val:": int = 88"},{name:"in_channels",val:": typing.Optional[int] = None"},{name:"out_channels",val:": typing.Optional[int] = None"},{name:"num_layers",val:": int = 1"},{name:"dropout",val:": float = 0.0"},{name:"norm_num_groups",val:": int = 32"},{name:"cross_attention_dim",val:": typing.Optional[int] = None"},{name:"attention_bias",val:": bool = False"},{name:"sample_size",val:": typing.Optional[int] = None"},{name:"activation_fn",val:": str = 'geglu'"},{name:"norm_elementwise_affine",val:": bool = True"},{name:"double_self_attention",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.num_attention_heads",description:"<strong>num_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 16) &#x2014; The number of heads to use for multi-head attention.",name:"num_attention_heads"},{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.attention_head_dim",description:"<strong>attention_head_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 88) &#x2014; The number of channels in each head.",name:"attention_head_dim"},{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.in_channels",description:`<strong>in_channels</strong> (<code>int</code>, <em>optional</em>) &#x2014;
Pass if the input is continuous. The number of channels in the input and output.`,name:"in_channels"},{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.num_layers",description:"<strong>num_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014; The number of layers of Transformer blocks to use.",name:"num_layers"},{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.dropout",description:"<strong>dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014; The dropout probability to use.",name:"dropout"},{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.cross_attention_dim",description:"<strong>cross_attention_dim</strong> (<code>int</code>, <em>optional</em>) &#x2014; The number of encoder_hidden_states dimensions to use.",name:"cross_attention_dim"},{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.sample_size",description:`<strong>sample_size</strong> (<code>int</code>, <em>optional</em>) &#x2014; Pass if the input is discrete. The width of the latent images.
Note that this is fixed at training time as it is used for learning a number of position embeddings. See
<code>ImagePositionalEmbeddings</code>.`,name:"sample_size"},{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.activation_fn",description:"<strong>activation_fn</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;geglu&quot;</code>) &#x2014; Activation function to be used in feed-forward.",name:"activation_fn"},{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.attention_bias",description:`<strong>attention_bias</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Configure if the TransformerBlocks&#x2019; attention should contain a bias parameter.`,name:"attention_bias"},{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.double_self_attention",description:`<strong>double_self_attention</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Configure if each TransformerBlock should contain two self-attention layers`,name:"double_self_attention"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/transformer_temporal.py#L37"}}),Sn=new y({props:{name:"forward",anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.forward",parameters:[{name:"hidden_states",val:""},{name:"encoder_hidden_states",val:" = None"},{name:"timestep",val:" = None"},{name:"class_labels",val:" = None"},{name:"num_frames",val:" = 1"},{name:"cross_attention_kwargs",val:" = None"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.forward.hidden_states",description:`<strong>hidden_states</strong> ( When discrete, <code>torch.LongTensor</code> of shape <code>(batch size, num latent pixels)</code>. &#x2014;
When continous, <code>torch.FloatTensor</code> of shape <code>(batch size, channel, height, width)</code>): Input
hidden_states`,name:"hidden_states"},{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.forward.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong> ( <code>torch.LongTensor</code> of shape <code>(batch size, encoder_hidden_states dim)</code>, <em>optional</em>) &#x2014;
Conditional embeddings for cross attention layer. If not given, cross-attention defaults to
self-attention.`,name:"encoder_hidden_states"},{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.forward.timestep",description:`<strong>timestep</strong> ( <code>torch.long</code>, <em>optional</em>) &#x2014;
Optional timestep to be applied as an embedding in AdaLayerNorm&#x2019;s. Used to indicate denoising step.`,name:"timestep"},{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.forward.class_labels",description:`<strong>class_labels</strong> ( <code>torch.LongTensor</code> of shape <code>(batch size, num classes)</code>, <em>optional</em>) &#x2014;
Optional class labels to be applied as an embedding in AdaLayerZeroNorm. Used to indicate class labels
conditioning.`,name:"class_labels"},{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/pr_2813/en/api/models#diffusers.models.unet_2d_condition.UNet2DConditionOutput">models.unet_2d_condition.UNet2DConditionOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/transformer_temporal.py#L106",returnDescription:`
<p><code>~models.transformer_2d.TransformerTemporalModelOutput</code> if <code>return_dict</code> is True, otherwise a <code>tuple</code>.
When returning a tuple, the first element is the sample tensor.</p>
`,returnType:`
<p><code>~models.transformer_2d.TransformerTemporalModelOutput</code> or <code>tuple</code></p>
`}}),Kn=new M({}),Xn=new y({props:{name:"class diffusers.models.transformer_temporal.TransformerTemporalModelOutput",anchor:"diffusers.models.transformer_temporal.TransformerTemporalModelOutput",parameters:[{name:"sample",val:": FloatTensor"}],parametersDescription:[{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModelOutput.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size x num_frames, num_channels, height, width)</code>) &#x2014;
Hidden states conditioned on <code>encoder_hidden_states</code> input.`,name:"sample"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/transformer_temporal.py#L27"}}),Hn=new M({}),Qn=new y({props:{name:"class diffusers.PriorTransformer",anchor:"diffusers.PriorTransformer",parameters:[{name:"num_attention_heads",val:": int = 32"},{name:"attention_head_dim",val:": int = 64"},{name:"num_layers",val:": int = 20"},{name:"embedding_dim",val:": int = 768"},{name:"num_embeddings",val:" = 77"},{name:"additional_embeddings",val:" = 4"},{name:"dropout",val:": float = 0.0"}],parametersDescription:[{anchor:"diffusers.PriorTransformer.num_attention_heads",description:"<strong>num_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 32) &#x2014; The number of heads to use for multi-head attention.",name:"num_attention_heads"},{anchor:"diffusers.PriorTransformer.attention_head_dim",description:"<strong>attention_head_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 64) &#x2014; The number of channels in each head.",name:"attention_head_dim"},{anchor:"diffusers.PriorTransformer.num_layers",description:"<strong>num_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 20) &#x2014; The number of layers of Transformer blocks to use.",name:"num_layers"},{anchor:"diffusers.PriorTransformer.embedding_dim",description:`<strong>embedding_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 768) &#x2014; The dimension of the CLIP embeddings. Note that CLIP
image embeddings and text embeddings are both the same dimension.`,name:"embedding_dim"},{anchor:"diffusers.PriorTransformer.num_embeddings",description:`<strong>num_embeddings</strong> (<code>int</code>, <em>optional</em>, defaults to 77) &#x2014; The max number of clip embeddings allowed. I.e. the
length of the prompt after it has been tokenized.`,name:"num_embeddings"},{anchor:"diffusers.PriorTransformer.additional_embeddings",description:`<strong>additional_embeddings</strong> (<code>int</code>, <em>optional</em>, defaults to 4) &#x2014; The number of additional tokens appended to the
projected hidden_states. The actual length of the used hidden_states is <code>num_embeddings + additional_embeddings</code>.`,name:"additional_embeddings"},{anchor:"diffusers.PriorTransformer.dropout",description:"<strong>dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014; The dropout probability to use.",name:"dropout"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/prior_transformer.py#L26"}}),Gn=new y({props:{name:"forward",anchor:"diffusers.PriorTransformer.forward",parameters:[{name:"hidden_states",val:""},{name:"timestep",val:": typing.Union[torch.Tensor, float, int]"},{name:"proj_embedding",val:": FloatTensor"},{name:"encoder_hidden_states",val:": FloatTensor"},{name:"attention_mask",val:": typing.Optional[torch.BoolTensor] = None"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.PriorTransformer.forward.hidden_states",description:`<strong>hidden_states</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, embedding_dim)</code>) &#x2014;
x_t, the currently predicted image embeddings.`,name:"hidden_states"},{anchor:"diffusers.PriorTransformer.forward.timestep",description:`<strong>timestep</strong> (<code>torch.long</code>) &#x2014;
Current denoising step.`,name:"timestep"},{anchor:"diffusers.PriorTransformer.forward.proj_embedding",description:`<strong>proj_embedding</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, embedding_dim)</code>) &#x2014;
Projected embedding vector the denoising process is conditioned on.`,name:"proj_embedding"},{anchor:"diffusers.PriorTransformer.forward.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_embeddings, embedding_dim)</code>) &#x2014;
Hidden states of the text embeddings the denoising process is conditioned on.`,name:"encoder_hidden_states"},{anchor:"diffusers.PriorTransformer.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.BoolTensor</code> of shape <code>(batch_size, num_embeddings)</code>) &#x2014;
Text mask for the text embeddings.`,name:"attention_mask"},{anchor:"diffusers.PriorTransformer.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/pr_2813/en/api/models#diffusers.models.prior_transformer.PriorTransformerOutput">models.prior_transformer.PriorTransformerOutput</a> instead of a plain
tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/prior_transformer.py#L107",returnDescription:`
<p><a
  href="/docs/diffusers/pr_2813/en/api/models#diffusers.models.prior_transformer.PriorTransformerOutput"
>PriorTransformerOutput</a> if <code>return_dict</code> is True, otherwise a <code>tuple</code>. When
returning a tuple, the first element is the sample tensor.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/pr_2813/en/api/models#diffusers.models.prior_transformer.PriorTransformerOutput"
>PriorTransformerOutput</a> or <code>tuple</code></p>
`}}),Jn=new M({}),es=new y({props:{name:"class diffusers.models.prior_transformer.PriorTransformerOutput",anchor:"diffusers.models.prior_transformer.PriorTransformerOutput",parameters:[{name:"predicted_image_embedding",val:": FloatTensor"}],parametersDescription:[{anchor:"diffusers.models.prior_transformer.PriorTransformerOutput.predicted_image_embedding",description:`<strong>predicted_image_embedding</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, embedding_dim)</code>) &#x2014;
The predicted CLIP image embedding conditioned on the CLIP text embedding input.`,name:"predicted_image_embedding"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/prior_transformer.py#L16"}}),os=new M({}),ns=new y({props:{name:"class diffusers.models.controlnet.ControlNetOutput",anchor:"diffusers.models.controlnet.ControlNetOutput",parameters:[{name:"down_block_res_samples",val:": typing.Tuple[torch.Tensor]"},{name:"mid_block_res_sample",val:": Tensor"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/controlnet.py#L39"}}),ss=new M({}),rs=new y({props:{name:"class diffusers.ControlNetModel",anchor:"diffusers.ControlNetModel",parameters:[{name:"in_channels",val:": int = 4"},{name:"flip_sin_to_cos",val:": bool = True"},{name:"freq_shift",val:": int = 0"},{name:"down_block_types",val:": typing.Tuple[str] = ('CrossAttnDownBlock2D', 'CrossAttnDownBlock2D', 'CrossAttnDownBlock2D', 'DownBlock2D')"},{name:"only_cross_attention",val:": typing.Union[bool, typing.Tuple[bool]] = False"},{name:"block_out_channels",val:": typing.Tuple[int] = (320, 640, 1280, 1280)"},{name:"layers_per_block",val:": int = 2"},{name:"downsample_padding",val:": int = 1"},{name:"mid_block_scale_factor",val:": float = 1"},{name:"act_fn",val:": str = 'silu'"},{name:"norm_num_groups",val:": typing.Optional[int] = 32"},{name:"norm_eps",val:": float = 1e-05"},{name:"cross_attention_dim",val:": int = 1280"},{name:"attention_head_dim",val:": typing.Union[int, typing.Tuple[int]] = 8"},{name:"use_linear_projection",val:": bool = False"},{name:"class_embed_type",val:": typing.Optional[str] = None"},{name:"num_class_embeds",val:": typing.Optional[int] = None"},{name:"upcast_attention",val:": bool = False"},{name:"resnet_time_scale_shift",val:": str = 'default'"},{name:"projection_class_embeddings_input_dim",val:": typing.Optional[int] = None"},{name:"controlnet_conditioning_channel_order",val:": str = 'rgb'"},{name:"conditioning_embedding_out_channels",val:": typing.Optional[typing.Tuple[int]] = (16, 32, 96, 256)"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/controlnet.py#L89"}}),as=new y({props:{name:"from_unet",anchor:"diffusers.ControlNetModel.from_unet",parameters:[{name:"unet",val:": UNet2DConditionModel"},{name:"controlnet_conditioning_channel_order",val:": str = 'rgb'"},{name:"conditioning_embedding_out_channels",val:": typing.Optional[typing.Tuple[int]] = (16, 32, 96, 256)"},{name:"load_weights_from_unet",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.ControlNetModel.from_unet.unet",description:`<strong>unet</strong> (<code>UNet2DConditionModel</code>) &#x2014;
UNet model which weights are copied to the ControlNet. Note that all configuration options are also
copied where applicable.`,name:"unet"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/controlnet.py#L261"}}),is=new y({props:{name:"set_attention_slice",anchor:"diffusers.ControlNetModel.set_attention_slice",parameters:[{name:"slice_size",val:""}],parametersDescription:[{anchor:"diffusers.ControlNetModel.set_attention_slice.slice_size",description:`<strong>slice_size</strong> (<code>str</code> or <code>int</code> or <code>list(int)</code>, <em>optional</em>, defaults to <code>&quot;auto&quot;</code>) &#x2014;
When <code>&quot;auto&quot;</code>, halves the input to the attention heads, so attention will be computed in two steps. If
<code>&quot;max&quot;</code>, maximum amount of memory will be saved by running only one slice at a time. If a number is
provided, uses as many slices as <code>attention_head_dim // slice_size</code>. In this case, <code>attention_head_dim</code>
must be a multiple of <code>slice_size</code>.`,name:"slice_size"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/controlnet.py#L372"}}),ls=new y({props:{name:"set_attn_processor",anchor:"diffusers.ControlNetModel.set_attn_processor",parameters:[{name:"processor",val:": typing.Union[diffusers.models.attention_processor.AttnProcessor, diffusers.models.attention_processor.XFormersAttnProcessor, diffusers.models.attention_processor.SlicedAttnProcessor, diffusers.models.attention_processor.AttnAddedKVProcessor, diffusers.models.attention_processor.SlicedAttnAddedKVProcessor, diffusers.models.attention_processor.LoRAAttnProcessor, diffusers.models.attention_processor.LoRAXFormersAttnProcessor, typing.Dict[str, typing.Union[diffusers.models.attention_processor.AttnProcessor, diffusers.models.attention_processor.XFormersAttnProcessor, diffusers.models.attention_processor.SlicedAttnProcessor, diffusers.models.attention_processor.AttnAddedKVProcessor, diffusers.models.attention_processor.SlicedAttnAddedKVProcessor, diffusers.models.attention_processor.LoRAAttnProcessor, diffusers.models.attention_processor.LoRAXFormersAttnProcessor]]]"}],parametersDescription:[{anchor:"diffusers.ControlNetModel.set_attn_processor.`processor",description:`<strong>\`processor</strong> (<code>dict</code> of <code>AttentionProcessor</code> or <code>AttentionProcessor</code>) &#x2014;
The instantiated processor class or a dictionary of processor classes that will be set as the processor
of <strong>all</strong> <code>Attention</code> layers.`,name:"`processor"},{anchor:"diffusers.ControlNetModel.set_attn_processor.In",description:"<strong>In</strong> case <code>processor</code> is a dict, the key needs to define the path to the corresponding cross attention processor. This is strongly recommended when setting trainable attention processors. &#x2014;",name:"In"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/controlnet.py#L341"}}),ds=new M({}),cs=new y({props:{name:"class diffusers.FlaxModelMixin",anchor:"diffusers.FlaxModelMixin",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/modeling_flax_utils.py#L45"}}),ms=new y({props:{name:"from_pretrained",anchor:"diffusers.FlaxModelMixin.from_pretrained",parameters:[{name:"pretrained_model_name_or_path",val:": typing.Union[str, os.PathLike]"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"},{name:"*model_args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.FlaxModelMixin.from_pretrained.pretrained_model_name_or_path",description:`<strong>pretrained_model_name_or_path</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Can be either:</p>
<ul>
<li>A string, the <em>model id</em> of a pretrained model hosted inside a model repo on huggingface.co.
Valid model ids are namespaced under a user or organization name, like
<code>runwayml/stable-diffusion-v1-5</code>.</li>
<li>A path to a <em>directory</em> containing model weights saved using <a href="/docs/diffusers/pr_2813/en/api/models#diffusers.ModelMixin.save_pretrained">save_pretrained()</a>,
e.g., <code>./my_model_directory/</code>.</li>
</ul>`,name:"pretrained_model_name_or_path"},{anchor:"diffusers.FlaxModelMixin.from_pretrained.dtype",description:`<strong>dtype</strong> (<code>jax.numpy.dtype</code>, <em>optional</em>, defaults to <code>jax.numpy.float32</code>) &#x2014;
The data type of the computation. Can be one of <code>jax.numpy.float32</code>, <code>jax.numpy.float16</code> (on GPUs) and
<code>jax.numpy.bfloat16</code> (on TPUs).</p>
<p>This can be used to enable mixed-precision training or half-precision inference on GPUs or TPUs. If
specified all the computation will be performed with the given <code>dtype</code>.</p>
<p><strong>Note that this only specifies the dtype of the computation and does not influence the dtype of model
parameters.</strong></p>
<p>If you wish to change the dtype of the model parameters, see <code>~ModelMixin.to_fp16</code> and
<code>~ModelMixin.to_bf16</code>.`,name:"dtype"},{anchor:"diffusers.FlaxModelMixin.from_pretrained.model_args",description:`<strong>model_args</strong> (sequence of positional arguments, <em>optional</em>) &#x2014;
All remaining positional arguments will be passed to the underlying model&#x2019;s <code>__init__</code> method.`,name:"model_args"},{anchor:"diffusers.FlaxModelMixin.from_pretrained.cache_dir",description:`<strong>cache_dir</strong> (<code>Union[str, os.PathLike]</code>, <em>optional</em>) &#x2014;
Path to a directory in which a downloaded pretrained model configuration should be cached if the
standard cache should not be used.`,name:"cache_dir"},{anchor:"diffusers.FlaxModelMixin.from_pretrained.force_download",description:`<strong>force_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to force the (re-)download of the model weights and configuration files, overriding the
cached versions if they exist.`,name:"force_download"},{anchor:"diffusers.FlaxModelMixin.from_pretrained.resume_download",description:`<strong>resume_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to delete incompletely received files. Will attempt to resume the download if such a
file exists.`,name:"resume_download"},{anchor:"diffusers.FlaxModelMixin.from_pretrained.proxies",description:`<strong>proxies</strong> (<code>Dict[str, str]</code>, <em>optional</em>) &#x2014;
A dictionary of proxy servers to use by protocol or endpoint, e.g., <code>{&apos;http&apos;: &apos;foo.bar:3128&apos;, &apos;http://hostname&apos;: &apos;foo.bar:4012&apos;}</code>. The proxies are used on each request.`,name:"proxies"},{anchor:"diffusers.FlaxModelMixin.from_pretrained.local_files_only(bool,",description:`<strong>local_files_only(<code>bool</code>,</strong> <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to only look at local files (i.e., do not try to download the model).`,name:"local_files_only(bool,"},{anchor:"diffusers.FlaxModelMixin.from_pretrained.revision",description:`<strong>revision</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;main&quot;</code>) &#x2014;
The specific model version to use. It can be a branch name, a tag name, or a commit id, since we use a
git-based system for storing models and other artifacts on huggingface.co, so <code>revision</code> can be any
identifier allowed by git.`,name:"revision"},{anchor:"diffusers.FlaxModelMixin.from_pretrained.from_pt",description:`<strong>from_pt</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Load the model weights from a PyTorch checkpoint save file.`,name:"from_pt"},{anchor:"diffusers.FlaxModelMixin.from_pretrained.kwargs",description:`<strong>kwargs</strong> (remaining dictionary of keyword arguments, <em>optional</em>) &#x2014;
Can be used to update the configuration object (after it being loaded) and initiate the model (e.g.,
<code>output_attentions=True</code>). Behaves differently depending on whether a <code>config</code> is provided or
automatically loaded:</p>
<ul>
<li>If a configuration is provided with <code>config</code>, <code>**kwargs</code> will be directly passed to the
underlying model&#x2019;s <code>__init__</code> method (we assume all relevant updates to the configuration have
already been done)</li>
<li>If a configuration is not provided, <code>kwargs</code> will be first passed to the configuration class
initialization function (<a href="/docs/diffusers/pr_2813/en/api/configuration#diffusers.ConfigMixin.from_config">from_config()</a>). Each key of <code>kwargs</code> that corresponds to
a configuration attribute will be used to override said attribute with the supplied <code>kwargs</code>
value. Remaining keys that do not correspond to any configuration attribute will be passed to the
underlying model&#x2019;s <code>__init__</code> function.</li>
</ul>`,name:"kwargs"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/modeling_flax_utils.py#L195"}}),Yo=new Il({props:{anchor:"diffusers.FlaxModelMixin.from_pretrained.example",$$slots:{default:[Oy]},$$scope:{ctx:I}}}),us=new y({props:{name:"save_pretrained",anchor:"diffusers.FlaxModelMixin.save_pretrained",parameters:[{name:"save_directory",val:": typing.Union[str, os.PathLike]"},{name:"params",val:": typing.Union[typing.Dict, flax.core.frozen_dict.FrozenDict]"},{name:"is_main_process",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.FlaxModelMixin.save_pretrained.save_directory",description:`<strong>save_directory</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Directory to which to save. Will be created if it doesn&#x2019;t exist.`,name:"save_directory"},{anchor:"diffusers.FlaxModelMixin.save_pretrained.params",description:`<strong>params</strong> (<code>Union[Dict, FrozenDict]</code>) &#x2014;
A <code>PyTree</code> of model parameters.`,name:"params"},{anchor:"diffusers.FlaxModelMixin.save_pretrained.is_main_process",description:`<strong>is_main_process</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether the process calling this is the main process or not. Useful when in distributed training like
TPUs and need to call this function on all processes. In this case, set <code>is_main_process=True</code> only on
the main process to avoid race conditions.`,name:"is_main_process"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/modeling_flax_utils.py#L487"}}),_s=new y({props:{name:"to_bf16",anchor:"diffusers.FlaxModelMixin.to_bf16",parameters:[{name:"params",val:": typing.Union[typing.Dict, flax.core.frozen_dict.FrozenDict]"},{name:"mask",val:": typing.Any = None"}],parametersDescription:[{anchor:"diffusers.FlaxModelMixin.to_bf16.params",description:`<strong>params</strong> (<code>Union[Dict, FrozenDict]</code>) &#x2014;
A <code>PyTree</code> of model parameters.`,name:"params"},{anchor:"diffusers.FlaxModelMixin.to_bf16.mask",description:`<strong>mask</strong> (<code>Union[Dict, FrozenDict]</code>) &#x2014;
A <code>PyTree</code> with same structure as the <code>params</code> tree. The leaves should be booleans, <code>True</code> for params
you want to cast, and should be <code>False</code> for those you want to skip.`,name:"mask"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/modeling_flax_utils.py#L87"}}),Jo=new Il({props:{anchor:"diffusers.FlaxModelMixin.to_bf16.example",$$slots:{default:[qy]},$$scope:{ctx:I}}}),gs=new y({props:{name:"to_fp16",anchor:"diffusers.FlaxModelMixin.to_fp16",parameters:[{name:"params",val:": typing.Union[typing.Dict, flax.core.frozen_dict.FrozenDict]"},{name:"mask",val:": typing.Any = None"}],parametersDescription:[{anchor:"diffusers.FlaxModelMixin.to_fp16.params",description:`<strong>params</strong> (<code>Union[Dict, FrozenDict]</code>) &#x2014;
A <code>PyTree</code> of model parameters.`,name:"params"},{anchor:"diffusers.FlaxModelMixin.to_fp16.mask",description:`<strong>mask</strong> (<code>Union[Dict, FrozenDict]</code>) &#x2014;
A <code>PyTree</code> with same structure as the <code>params</code> tree. The leaves should be booleans, <code>True</code> for params
you want to cast, and should be <code>False</code> for those you want to skip`,name:"mask"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/modeling_flax_utils.py#L153"}}),Zo=new Il({props:{anchor:"diffusers.FlaxModelMixin.to_fp16.example",$$slots:{default:[Ly]},$$scope:{ctx:I}}}),bs=new y({props:{name:"to_fp32",anchor:"diffusers.FlaxModelMixin.to_fp32",parameters:[{name:"params",val:": typing.Union[typing.Dict, flax.core.frozen_dict.FrozenDict]"},{name:"mask",val:": typing.Any = None"}],parametersDescription:[{anchor:"diffusers.FlaxModelMixin.to_fp32.params",description:`<strong>params</strong> (<code>Union[Dict, FrozenDict]</code>) &#x2014;
A <code>PyTree</code> of model parameters.`,name:"params"},{anchor:"diffusers.FlaxModelMixin.to_fp32.mask",description:`<strong>mask</strong> (<code>Union[Dict, FrozenDict]</code>) &#x2014;
A <code>PyTree</code> with same structure as the <code>params</code> tree. The leaves should be booleans, <code>True</code> for params
you want to cast, and should be <code>False</code> for those you want to skip`,name:"mask"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/modeling_flax_utils.py#L126"}}),et=new Il({props:{anchor:"diffusers.FlaxModelMixin.to_fp32.example",$$slots:{default:[jy]},$$scope:{ctx:I}}}),vs=new M({}),ys=new y({props:{name:"class diffusers.models.unet_2d_condition_flax.FlaxUNet2DConditionOutput",anchor:"diffusers.models.unet_2d_condition_flax.FlaxUNet2DConditionOutput",parameters:[{name:"sample",val:": ndarray"}],parametersDescription:[{anchor:"diffusers.models.unet_2d_condition_flax.FlaxUNet2DConditionOutput.sample",description:`<strong>sample</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Hidden states conditioned on <code>encoder_hidden_states</code> input. Output of last layer of model.`,name:"sample"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/unet_2d_condition_flax.py#L36"}}),xs=new y({props:{name:"replace",anchor:"diffusers.models.unet_2d_condition_flax.FlaxUNet2DConditionOutput.replace",parameters:[{name:"**updates",val:""}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/flax/struct.py#L108"}}),$s=new M({}),ws=new y({props:{name:"class diffusers.FlaxUNet2DConditionModel",anchor:"diffusers.FlaxUNet2DConditionModel",parameters:[{name:"sample_size",val:": int = 32"},{name:"in_channels",val:": int = 4"},{name:"out_channels",val:": int = 4"},{name:"down_block_types",val:": typing.Tuple[str] = ('CrossAttnDownBlock2D', 'CrossAttnDownBlock2D', 'CrossAttnDownBlock2D', 'DownBlock2D')"},{name:"up_block_types",val:": typing.Tuple[str] = ('UpBlock2D', 'CrossAttnUpBlock2D', 'CrossAttnUpBlock2D', 'CrossAttnUpBlock2D')"},{name:"only_cross_attention",val:": typing.Union[bool, typing.Tuple[bool]] = False"},{name:"block_out_channels",val:": typing.Tuple[int] = (320, 640, 1280, 1280)"},{name:"layers_per_block",val:": int = 2"},{name:"attention_head_dim",val:": typing.Union[int, typing.Tuple[int]] = 8"},{name:"cross_attention_dim",val:": int = 1280"},{name:"dropout",val:": float = 0.0"},{name:"use_linear_projection",val:": bool = False"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"},{name:"flip_sin_to_cos",val:": bool = True"},{name:"freq_shift",val:": int = 0"},{name:"parent",val:": typing.Union[typing.Type[flax.linen.module.Module], typing.Type[flax.core.scope.Scope], typing.Type[flax.linen.module._Sentinel], NoneType] = <flax.linen.module._Sentinel object at 0x7fa21562eac0>"},{name:"name",val:": str = None"}],parametersDescription:[{anchor:"diffusers.FlaxUNet2DConditionModel.sample_size",description:`<strong>sample_size</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The size of the input sample.`,name:"sample_size"},{anchor:"diffusers.FlaxUNet2DConditionModel.in_channels",description:`<strong>in_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 4) &#x2014;
The number of channels in the input sample.`,name:"in_channels"},{anchor:"diffusers.FlaxUNet2DConditionModel.out_channels",description:`<strong>out_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 4) &#x2014;
The number of channels in the output.`,name:"out_channels"},{anchor:"diffusers.FlaxUNet2DConditionModel.down_block_types",description:`<strong>down_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to <code>(&quot;CrossAttnDownBlock2D&quot;, &quot;CrossAttnDownBlock2D&quot;, &quot;CrossAttnDownBlock2D&quot;, &quot;DownBlock2D&quot;)</code>) &#x2014;
The tuple of downsample blocks to use. The corresponding class names will be: &#x201C;FlaxCrossAttnDownBlock2D&#x201D;,
&#x201C;FlaxCrossAttnDownBlock2D&#x201D;, &#x201C;FlaxCrossAttnDownBlock2D&#x201D;, &#x201C;FlaxDownBlock2D&#x201D;`,name:"down_block_types"},{anchor:"diffusers.FlaxUNet2DConditionModel.up_block_types",description:`<strong>up_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to <code>(&quot;UpBlock2D&quot;, &quot;CrossAttnUpBlock2D&quot;, &quot;CrossAttnUpBlock2D&quot;, &quot;CrossAttnUpBlock2D&quot;,)</code>) &#x2014;
The tuple of upsample blocks to use. The corresponding class names will be: &#x201C;FlaxUpBlock2D&#x201D;,
&#x201C;FlaxCrossAttnUpBlock2D&#x201D;, &#x201C;FlaxCrossAttnUpBlock2D&#x201D;, &#x201C;FlaxCrossAttnUpBlock2D&#x201D;`,name:"up_block_types"},{anchor:"diffusers.FlaxUNet2DConditionModel.block_out_channels",description:`<strong>block_out_channels</strong> (<code>Tuple[int]</code>, <em>optional</em>, defaults to <code>(320, 640, 1280, 1280)</code>) &#x2014;
The tuple of output channels for each block.`,name:"block_out_channels"},{anchor:"diffusers.FlaxUNet2DConditionModel.layers_per_block",description:`<strong>layers_per_block</strong> (<code>int</code>, <em>optional</em>, defaults to 2) &#x2014;
The number of layers per block.`,name:"layers_per_block"},{anchor:"diffusers.FlaxUNet2DConditionModel.attention_head_dim",description:`<strong>attention_head_dim</strong> (<code>int</code> or <code>Tuple[int]</code>, <em>optional</em>, defaults to 8) &#x2014;
The dimension of the attention heads.`,name:"attention_head_dim"},{anchor:"diffusers.FlaxUNet2DConditionModel.cross_attention_dim",description:`<strong>cross_attention_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 768) &#x2014;
The dimension of the cross attention features.`,name:"cross_attention_dim"},{anchor:"diffusers.FlaxUNet2DConditionModel.dropout",description:`<strong>dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0) &#x2014;
Dropout probability for down, up and bottleneck blocks.`,name:"dropout"},{anchor:"diffusers.FlaxUNet2DConditionModel.flip_sin_to_cos",description:`<strong>flip_sin_to_cos</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to flip the sin to cos in the time embedding.`,name:"flip_sin_to_cos"},{anchor:"diffusers.FlaxUNet2DConditionModel.freq_shift",description:"<strong>freq_shift</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014; The frequency shift to apply to the time embedding.",name:"freq_shift"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/unet_2d_condition_flax.py#L47"}}),Us=new M({}),Cs=new y({props:{name:"class diffusers.models.vae_flax.FlaxDecoderOutput",anchor:"diffusers.models.vae_flax.FlaxDecoderOutput",parameters:[{name:"sample",val:": ndarray"}],parametersDescription:[{anchor:"diffusers.models.vae_flax.FlaxDecoderOutput.sample",description:`<strong>sample</strong> (<em>jnp.ndarray</em> of shape <em>(batch_size, num_channels, height, width)</em>) &#x2014;
Decoded output sample of the model. Output of the last layer of the model.`,name:"sample"},{anchor:"diffusers.models.vae_flax.FlaxDecoderOutput.dtype",description:`<strong>dtype</strong> (<code>jnp.dtype</code>, <em>optional</em>, defaults to jnp.float32) &#x2014;
Parameters <em>dtype</em>`,name:"dtype"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/vae_flax.py#L33"}}),Fs=new y({props:{name:"replace",anchor:"diffusers.models.vae_flax.FlaxDecoderOutput.replace",parameters:[{name:"**updates",val:""}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/flax/struct.py#L108"}}),Ps=new M({}),Os=new y({props:{name:"class diffusers.models.vae_flax.FlaxAutoencoderKLOutput",anchor:"diffusers.models.vae_flax.FlaxAutoencoderKLOutput",parameters:[{name:"latent_dist",val:": FlaxDiagonalGaussianDistribution"}],parametersDescription:[{anchor:"diffusers.models.vae_flax.FlaxAutoencoderKLOutput.latent_dist",description:`<strong>latent_dist</strong> (<code>FlaxDiagonalGaussianDistribution</code>) &#x2014;
Encoded outputs of <code>Encoder</code> represented as the mean and logvar of <code>FlaxDiagonalGaussianDistribution</code>.
<code>FlaxDiagonalGaussianDistribution</code> allows for sampling latents from the distribution.`,name:"latent_dist"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/vae_flax.py#L48"}}),qs=new y({props:{name:"replace",anchor:"diffusers.models.vae_flax.FlaxAutoencoderKLOutput.replace",parameters:[{name:"**updates",val:""}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/flax/struct.py#L108"}}),Ls=new M({}),js=new y({props:{name:"class diffusers.FlaxAutoencoderKL",anchor:"diffusers.FlaxAutoencoderKL",parameters:[{name:"in_channels",val:": int = 3"},{name:"out_channels",val:": int = 3"},{name:"down_block_types",val:": typing.Tuple[str] = ('DownEncoderBlock2D',)"},{name:"up_block_types",val:": typing.Tuple[str] = ('UpDecoderBlock2D',)"},{name:"block_out_channels",val:": typing.Tuple[int] = (64,)"},{name:"layers_per_block",val:": int = 1"},{name:"act_fn",val:": str = 'silu'"},{name:"latent_channels",val:": int = 4"},{name:"norm_num_groups",val:": int = 32"},{name:"sample_size",val:": int = 32"},{name:"scaling_factor",val:": float = 0.18215"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"},{name:"parent",val:": typing.Union[typing.Type[flax.linen.module.Module], typing.Type[flax.core.scope.Scope], typing.Type[flax.linen.module._Sentinel], NoneType] = <flax.linen.module._Sentinel object at 0x7fa21562eac0>"},{name:"name",val:": str = None"}],parametersDescription:[{anchor:"diffusers.FlaxAutoencoderKL.in_channels",description:`<strong>in_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014;
Input channels`,name:"in_channels"},{anchor:"diffusers.FlaxAutoencoderKL.out_channels",description:`<strong>out_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014;
Output channels`,name:"out_channels"},{anchor:"diffusers.FlaxAutoencoderKL.down_block_types",description:`<strong>down_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to <em>(DownEncoderBlock2D)</em>) &#x2014;
DownEncoder block type`,name:"down_block_types"},{anchor:"diffusers.FlaxAutoencoderKL.up_block_types",description:`<strong>up_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to <em>(UpDecoderBlock2D)</em>) &#x2014;
UpDecoder block type`,name:"up_block_types"},{anchor:"diffusers.FlaxAutoencoderKL.block_out_channels",description:`<strong>block_out_channels</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to <em>(64,)</em>) &#x2014;
Tuple containing the number of output channels for each block`,name:"block_out_channels"},{anchor:"diffusers.FlaxAutoencoderKL.layers_per_block",description:`<strong>layers_per_block</strong> (<code>int</code>, <em>optional</em>, defaults to <em>2</em>) &#x2014;
Number of Resnet layer for each block`,name:"layers_per_block"},{anchor:"diffusers.FlaxAutoencoderKL.act_fn",description:`<strong>act_fn</strong> (<code>str</code>, <em>optional</em>, defaults to <em>silu</em>) &#x2014;
Activation function`,name:"act_fn"},{anchor:"diffusers.FlaxAutoencoderKL.latent_channels",description:`<strong>latent_channels</strong> (<code>int</code>, <em>optional</em>, defaults to <em>4</em>) &#x2014;
Latent space channels`,name:"latent_channels"},{anchor:"diffusers.FlaxAutoencoderKL.norm_num_groups",description:`<strong>norm_num_groups</strong> (<code>int</code>, <em>optional</em>, defaults to <em>32</em>) &#x2014;
Norm num group`,name:"norm_num_groups"},{anchor:"diffusers.FlaxAutoencoderKL.sample_size",description:`<strong>sample_size</strong> (<code>int</code>, <em>optional</em>, defaults to 32) &#x2014;
Sample input size`,name:"sample_size"},{anchor:"diffusers.FlaxAutoencoderKL.scaling_factor",description:`<strong>scaling_factor</strong> (<em>float</em>, <em>optional</em>, defaults to 0.18215) &#x2014;
The component-wise standard deviation of the trained latent space computed using the first batch of the
training set. This is used to scale the latent space to have unit variance when training the diffusion
model. The latents are scaled with the formula <em>z = z </em> scaling_factor<em> before being passed to the
diffusion model. When decoding, the latents are scaled back to the original scale with the formula: </em>z = 1
/ scaling_factor <em> z</em>. For more details, refer to sections 4.3.2 and D.1 of the <a href="https://arxiv.org/abs/2112.10752" rel="nofollow">High-Resolution Image
Synthesis with Latent Diffusion Models</a> paper.`,name:"scaling_factor"},{anchor:"diffusers.FlaxAutoencoderKL.dtype",description:`<strong>dtype</strong> (<code>jnp.dtype</code>, <em>optional</em>, defaults to jnp.float32) &#x2014;
parameters <em>dtype</em>`,name:"dtype"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/vae_flax.py#L721"}}),Ws=new M({}),Xs=new y({props:{name:"class diffusers.models.controlnet_flax.FlaxControlNetOutput",anchor:"diffusers.models.controlnet_flax.FlaxControlNetOutput",parameters:[{name:"down_block_res_samples",val:": ndarray"},{name:"mid_block_res_sample",val:": ndarray"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/controlnet_flax.py#L34"}}),Hs=new y({props:{name:"replace",anchor:"diffusers.models.controlnet_flax.FlaxControlNetOutput.replace",parameters:[{name:"**updates",val:""}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/flax/struct.py#L108"}}),Qs=new M({}),Rs=new y({props:{name:"class diffusers.FlaxControlNetModel",anchor:"diffusers.FlaxControlNetModel",parameters:[{name:"sample_size",val:": int = 32"},{name:"in_channels",val:": int = 4"},{name:"down_block_types",val:": typing.Tuple[str] = ('CrossAttnDownBlock2D', 'CrossAttnDownBlock2D', 'CrossAttnDownBlock2D', 'DownBlock2D')"},{name:"only_cross_attention",val:": typing.Union[bool, typing.Tuple[bool]] = False"},{name:"block_out_channels",val:": typing.Tuple[int] = (320, 640, 1280, 1280)"},{name:"layers_per_block",val:": int = 2"},{name:"attention_head_dim",val:": typing.Union[int, typing.Tuple[int]] = 8"},{name:"cross_attention_dim",val:": int = 1280"},{name:"dropout",val:": float = 0.0"},{name:"use_linear_projection",val:": bool = False"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"},{name:"flip_sin_to_cos",val:": bool = True"},{name:"freq_shift",val:": int = 0"},{name:"controlnet_conditioning_channel_order",val:": str = 'rgb'"},{name:"conditioning_embedding_out_channels",val:": typing.Tuple[int] = (16, 32, 96, 256)"},{name:"parent",val:": typing.Union[typing.Type[flax.linen.module.Module], typing.Type[flax.core.scope.Scope], typing.Type[flax.linen.module._Sentinel], NoneType] = <flax.linen.module._Sentinel object at 0x7fa21562eac0>"},{name:"name",val:": str = None"}],parametersDescription:[{anchor:"diffusers.FlaxControlNetModel.sample_size",description:`<strong>sample_size</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The size of the input sample.`,name:"sample_size"},{anchor:"diffusers.FlaxControlNetModel.in_channels",description:`<strong>in_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 4) &#x2014;
The number of channels in the input sample.`,name:"in_channels"},{anchor:"diffusers.FlaxControlNetModel.down_block_types",description:`<strong>down_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to <code>(&quot;CrossAttnDownBlock2D&quot;, &quot;CrossAttnDownBlock2D&quot;, &quot;CrossAttnDownBlock2D&quot;, &quot;DownBlock2D&quot;)</code>) &#x2014;
The tuple of downsample blocks to use. The corresponding class names will be: &#x201C;FlaxCrossAttnDownBlock2D&#x201D;,
&#x201C;FlaxCrossAttnDownBlock2D&#x201D;, &#x201C;FlaxCrossAttnDownBlock2D&#x201D;, &#x201C;FlaxDownBlock2D&#x201D;`,name:"down_block_types"},{anchor:"diffusers.FlaxControlNetModel.block_out_channels",description:`<strong>block_out_channels</strong> (<code>Tuple[int]</code>, <em>optional</em>, defaults to <code>(320, 640, 1280, 1280)</code>) &#x2014;
The tuple of output channels for each block.`,name:"block_out_channels"},{anchor:"diffusers.FlaxControlNetModel.layers_per_block",description:`<strong>layers_per_block</strong> (<code>int</code>, <em>optional</em>, defaults to 2) &#x2014;
The number of layers per block.`,name:"layers_per_block"},{anchor:"diffusers.FlaxControlNetModel.attention_head_dim",description:`<strong>attention_head_dim</strong> (<code>int</code> or <code>Tuple[int]</code>, <em>optional</em>, defaults to 8) &#x2014;
The dimension of the attention heads.`,name:"attention_head_dim"},{anchor:"diffusers.FlaxControlNetModel.cross_attention_dim",description:`<strong>cross_attention_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 768) &#x2014;
The dimension of the cross attention features.`,name:"cross_attention_dim"},{anchor:"diffusers.FlaxControlNetModel.dropout",description:`<strong>dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0) &#x2014;
Dropout probability for down, up and bottleneck blocks.`,name:"dropout"},{anchor:"diffusers.FlaxControlNetModel.flip_sin_to_cos",description:`<strong>flip_sin_to_cos</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to flip the sin to cos in the time embedding.`,name:"flip_sin_to_cos"},{anchor:"diffusers.FlaxControlNetModel.freq_shift",description:"<strong>freq_shift</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014; The frequency shift to apply to the time embedding.",name:"freq_shift"},{anchor:"diffusers.FlaxControlNetModel.controlnet_conditioning_channel_order",description:`<strong>controlnet_conditioning_channel_order</strong> (<code>str</code>, <em>optional</em>, defaults to <code>rgb</code>) &#x2014;
The channel order of conditional image. Will convert it to <code>rgb</code> if it&#x2019;s <code>bgr</code>`,name:"controlnet_conditioning_channel_order"},{anchor:"diffusers.FlaxControlNetModel.conditioning_embedding_out_channels",description:`<strong>conditioning_embedding_out_channels</strong> (<code>tuple</code>, <em>optional</em>, defaults to <code>(16, 32, 96, 256)</code>) &#x2014;
The tuple of output channel for each block in conditioning_embedding layer`,name:"conditioning_embedding_out_channels"}],source:"https://github.com/huggingface/diffusers/blob/vr_2813/src/diffusers/models/controlnet_flax.py#L96"}}),{c(){x=n("meta"),T=i(),D=n("h1"),$=n("a"),k=n("span"),f(v.$$.fragment),w=i(),oe=n("span"),Ee=d("Models"),X=i(),H=n("p"),ir=d(`Diffusers contains pretrained models for popular algorithms and modules for creating the next set of diffusion models.
The primary function of these models is to denoise an input sample, by modeling the distribution $p`),Wr=n("em"),fm=d("\\theta(\\mathbf{x}"),um=d(`{t-1}|\\mathbf{x}_t)$.
The models are built on the base class [\u2018ModelMixin\u2019] that is a `),Xr=n("code"),hm=d("torch.nn.module"),_m=d(" with basic functionality for saving and loading models both locally and from the HuggingFace hub."),Bl=i(),Ae=n("h2"),uo=n("a"),Hr=n("span"),f(xt.$$.fragment),gm=i(),Qr=n("span"),bm=d("ModelMixin"),Sl=i(),N=n("div"),f($t.$$.fragment),vm=i(),Rr=n("p"),ym=d("Base class for all models."),xm=i(),lr=n("p"),dr=n("a"),$m=d("ModelMixin"),wm=d(` takes care of storing the configuration of the models and handles methods for loading, downloading
and saving models.`),Dm=i(),Yr=n("ul"),he=n("li"),Gr=n("strong"),km=d("config_name"),Tm=d(" ("),Jr=n("code"),Mm=d("str"),Nm=d(`) \u2014 A filename under which the model should be stored when calling
`),cr=n("a"),Em=d("save_pretrained()"),Am=d("."),Um=i(),_e=n("div"),f(wt.$$.fragment),Cm=i(),Zr=n("p"),Fm=d("Deactivates gradient checkpointing for the current model."),Pm=i(),ea=n("p"),Om=d(`Note that in other frameworks this feature can be referred to as \u201Cactivation checkpointing\u201D or \u201Ccheckpoint
activations\u201D.`),qm=i(),ho=n("div"),f(Dt.$$.fragment),Lm=i(),oa=n("p"),jm=d("Disable memory efficient attention as implemented in xformers."),Im=i(),ge=n("div"),f(kt.$$.fragment),zm=i(),ta=n("p"),Vm=d("Activates gradient checkpointing for the current model."),Bm=i(),na=n("p"),Sm=d(`Note that in other frameworks this feature can be referred to as \u201Cactivation checkpointing\u201D or \u201Ccheckpoint
activations\u201D.`),Km=i(),S=n("div"),f(Tt.$$.fragment),Wm=i(),sa=n("p"),Xm=d("Enable memory efficient attention as implemented in xformers."),Hm=i(),ra=n("p"),Qm=d(`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),Rm=i(),aa=n("p"),Ym=d(`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),Gm=i(),f(_o.$$.fragment),Jm=i(),F=n("div"),f(Mt.$$.fragment),Zm=i(),ia=n("p"),ep=d("Instantiate a pretrained pytorch model from a pre-trained model configuration."),op=i(),Ue=n("p"),tp=d("The model is set in evaluation mode by default using "),la=n("code"),np=d("model.eval()"),sp=d(` (Dropout modules are deactivated). To train
the model, you should first set it back in training mode with `),da=n("code"),rp=d("model.train()"),ap=d("."),ip=i(),Nt=n("p"),lp=d("The warning "),ca=n("em"),dp=d("Weights from XXX not initialized from pretrained model"),cp=d(` means that the weights of XXX do not come
pretrained with the rest of the model. It is up to you to train those weights with a downstream fine-tuning
task.`),mp=i(),Et=n("p"),pp=d("The warning "),ma=n("em"),fp=d("Weights from XXX not used in YYY"),up=d(` means that the layer XXX is not used by YYY, therefore those
weights are discarded.`),hp=i(),f(go.$$.fragment),_p=i(),f(bo.$$.fragment),gp=i(),vo=n("div"),f(At.$$.fragment),bp=i(),pa=n("p"),vp=d("Get number of (optionally, trainable or non-embeddings) parameters in the module."),yp=i(),yo=n("div"),f(Ut.$$.fragment),xp=i(),Ct=n("p"),$p=d(`Save a model and its configuration file to a directory, so that it can be re-loaded using the
`),fa=n("code"),wp=d("[from_pretrained()](/docs/diffusers/pr_2813/en/api/models#diffusers.ModelMixin.from_pretrained)"),Dp=d(" class method."),Kl=i(),Ce=n("h2"),xo=n("a"),ua=n("span"),f(Ft.$$.fragment),kp=i(),ha=n("span"),Tp=d("UNet2DOutput"),Wl=i(),Pt=n("div"),f(Ot.$$.fragment),Xl=i(),Fe=n("h2"),$o=n("a"),_a=n("span"),f(qt.$$.fragment),Mp=i(),ga=n("span"),Np=d("UNet2DModel"),Hl=i(),Q=n("div"),f(Lt.$$.fragment),Ep=i(),ba=n("p"),Ap=d("UNet2DModel is a 2D UNet model that takes in a noisy sample and a timestep and returns sample shaped output."),Up=i(),jt=n("p"),Cp=d("This model inherits from "),mr=n("a"),Fp=d("ModelMixin"),Pp=d(`. Check the superclass documentation for the generic methods the library
implements for all the model (such as downloading or saving, etc.)`),Op=i(),pr=n("div"),f(It.$$.fragment),Ql=i(),Pe=n("h2"),wo=n("a"),va=n("span"),f(zt.$$.fragment),qp=i(),ya=n("span"),Lp=d("UNet1DOutput"),Rl=i(),Vt=n("div"),f(Bt.$$.fragment),Yl=i(),Oe=n("h2"),Do=n("a"),xa=n("span"),f(St.$$.fragment),jp=i(),$a=n("span"),Ip=d("UNet1DModel"),Gl=i(),R=n("div"),f(Kt.$$.fragment),zp=i(),wa=n("p"),Vp=d("UNet1DModel is a 1D UNet model that takes in a noisy sample and a timestep and returns sample shaped output."),Bp=i(),Wt=n("p"),Sp=d("This model inherits from "),fr=n("a"),Kp=d("ModelMixin"),Wp=d(`. Check the superclass documentation for the generic methods the library
implements for all the model (such as downloading or saving, etc.)`),Xp=i(),ur=n("div"),f(Xt.$$.fragment),Jl=i(),qe=n("h2"),ko=n("a"),Da=n("span"),f(Ht.$$.fragment),Hp=i(),ka=n("span"),Qp=d("UNet2DConditionOutput"),Zl=i(),Qt=n("div"),f(Rt.$$.fragment),ed=i(),Le=n("h2"),To=n("a"),Ta=n("span"),f(Yt.$$.fragment),Rp=i(),Ma=n("span"),Yp=d("UNet2DConditionModel"),od=i(),P=n("div"),f(Gt.$$.fragment),Gp=i(),Na=n("p"),Jp=d(`UNet2DConditionModel is a conditional 2D UNet model that takes in a noisy sample, conditional state, and a timestep
and returns sample shaped output.`),Zp=i(),Jt=n("p"),ef=d("This model inherits from "),hr=n("a"),of=d("ModelMixin"),tf=d(`. Check the superclass documentation for the generic methods the library
implements for all the models (such as downloading or saving, etc.)`),nf=i(),_r=n("div"),f(Zt.$$.fragment),sf=i(),be=n("div"),f(en.$$.fragment),rf=i(),Ea=n("p"),af=d("Enable sliced attention computation."),lf=i(),Aa=n("p"),df=d(`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),cf=i(),gr=n("div"),f(on.$$.fragment),td=i(),je=n("h2"),Mo=n("a"),Ua=n("span"),f(tn.$$.fragment),mf=i(),Ca=n("span"),pf=d("UNet3DConditionOutput"),nd=i(),nn=n("div"),f(sn.$$.fragment),sd=i(),Ie=n("h2"),No=n("a"),Fa=n("span"),f(rn.$$.fragment),ff=i(),Pa=n("span"),uf=d("UNet3DConditionModel"),rd=i(),O=n("div"),f(an.$$.fragment),hf=i(),Oa=n("p"),_f=d(`UNet3DConditionModel is a conditional 2D UNet model that takes in a noisy sample, conditional state, and a timestep
and returns sample shaped output.`),gf=i(),ln=n("p"),bf=d("This model inherits from "),br=n("a"),vf=d("ModelMixin"),yf=d(`. Check the superclass documentation for the generic methods the library
implements for all the models (such as downloading or saving, etc.)`),xf=i(),vr=n("div"),f(dn.$$.fragment),$f=i(),ve=n("div"),f(cn.$$.fragment),wf=i(),qa=n("p"),Df=d("Enable sliced attention computation."),kf=i(),La=n("p"),Tf=d(`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),Mf=i(),yr=n("div"),f(mn.$$.fragment),ad=i(),ze=n("h2"),Eo=n("a"),ja=n("span"),f(pn.$$.fragment),Nf=i(),Ia=n("span"),Ef=d("DecoderOutput"),id=i(),Ve=n("div"),f(fn.$$.fragment),Af=i(),za=n("p"),Uf=d("Output of decoding method."),ld=i(),Be=n("h2"),Ao=n("a"),Va=n("span"),f(un.$$.fragment),Cf=i(),Ba=n("span"),Ff=d("VQEncoderOutput"),dd=i(),Se=n("div"),f(hn.$$.fragment),Pf=i(),Sa=n("p"),Of=d("Output of VQModel encoding method."),cd=i(),Ke=n("h2"),Uo=n("a"),Ka=n("span"),f(_n.$$.fragment),qf=i(),Wa=n("span"),Lf=d("VQModel"),md=i(),Y=n("div"),f(gn.$$.fragment),jf=i(),Xa=n("p"),If=d(`VQ-VAE model from the paper Neural Discrete Representation Learning by Aaron van den Oord, Oriol Vinyals and Koray
Kavukcuoglu.`),zf=i(),bn=n("p"),Vf=d("This model inherits from "),xr=n("a"),Bf=d("ModelMixin"),Sf=d(`. Check the superclass documentation for the generic methods the library
implements for all the model (such as downloading or saving, etc.)`),Kf=i(),$r=n("div"),f(vn.$$.fragment),pd=i(),We=n("h2"),Co=n("a"),Ha=n("span"),f(yn.$$.fragment),Wf=i(),Qa=n("span"),Xf=d("AutoencoderKLOutput"),fd=i(),Xe=n("div"),f(xn.$$.fragment),Hf=i(),Ra=n("p"),Qf=d("Output of AutoencoderKL encoding method."),ud=i(),He=n("h2"),Fo=n("a"),Ya=n("span"),f($n.$$.fragment),Rf=i(),Ga=n("span"),Yf=d("AutoencoderKL"),hd=i(),E=n("div"),f(wn.$$.fragment),Gf=i(),Ja=n("p"),Jf=d(`Variational Autoencoder (VAE) model with KL loss from the paper Auto-Encoding Variational Bayes by Diederik P. Kingma
and Max Welling.`),Zf=i(),Dn=n("p"),eu=d("This model inherits from "),wr=n("a"),ou=d("ModelMixin"),tu=d(`. Check the superclass documentation for the generic methods the library
implements for all the model (such as downloading or saving, etc.)`),nu=i(),Po=n("div"),f(kn.$$.fragment),su=i(),Tn=n("p"),ru=d("Disable sliced VAE decoding. If "),Za=n("code"),au=d("enable_slicing"),iu=d(` was previously invoked, this method will go back to computing
decoding in one step.`),lu=i(),Oo=n("div"),f(Mn.$$.fragment),du=i(),Nn=n("p"),cu=d("Disable tiled VAE decoding. If "),ei=n("code"),mu=d("enable_vae_tiling"),pu=d(` was previously invoked, this method will go back to
computing decoding in one step.`),fu=i(),qo=n("div"),f(En.$$.fragment),uu=i(),oi=n("p"),hu=d(`Enable sliced VAE decoding. When this option is enabled, the VAE will split the input tensor in slices to
compute decoding in several steps. This is useful to save some memory and allow larger batch sizes.`),_u=i(),Lo=n("div"),f(An.$$.fragment),gu=i(),ti=n("p"),bu=d(`Enable tiled VAE decoding. When this option is enabled, the VAE will split the input tensor into tiles to
compute decoding and encoding in several steps. This is useful to save a large amount of memory and to allow
the processing of larger images.`),vu=i(),Dr=n("div"),f(Un.$$.fragment),yu=i(),jo=n("div"),f(Cn.$$.fragment),xu=i(),ni=n("p"),$u=d("Decode a batch of images using a tiled decoder."),wu=i(),Io=n("div"),f(Fn.$$.fragment),Du=i(),si=n("p"),ku=d("Encode a batch of images using a tiled encoder."),_d=i(),Qe=n("h2"),zo=n("a"),ri=n("span"),f(Pn.$$.fragment),Tu=i(),ai=n("span"),Mu=d("Transformer2DModel"),gd=i(),q=n("div"),f(On.$$.fragment),Nu=i(),ii=n("p"),Eu=d(`Transformer model for image-like data. Takes either discrete (classes of vector embeddings) or continuous (actual
embeddings) inputs.`),Au=i(),li=n("p"),Uu=d(`When input is continuous: First, project the input (aka embedding) and reshape to b, t, d. Then apply standard
transformer action. Finally, reshape to image.`),Cu=i(),qn=n("p"),Fu=d(`When input is discrete: First, input (classes of latent pixels) is converted to embeddings and has positional
embeddings applied, see `),di=n("code"),Pu=d("ImagePositionalEmbeddings"),Ou=d(`. Then apply standard transformer action. Finally, predict
classes of unnoised image.`),qu=i(),ci=n("p"),Lu=d(`Note that it is assumed one of the input classes is the masked latent pixel. The predicted classes of the unnoised
image do not contain a prediction for the masked pixel as the unnoised image cannot be masked.`),ju=i(),kr=n("div"),f(Ln.$$.fragment),bd=i(),Re=n("h2"),Vo=n("a"),mi=n("span"),f(jn.$$.fragment),Iu=i(),pi=n("span"),zu=d("Transformer2DModelOutput"),vd=i(),In=n("div"),f(zn.$$.fragment),yd=i(),Ye=n("h2"),Bo=n("a"),fi=n("span"),f(Vn.$$.fragment),Vu=i(),ui=n("span"),Bu=d("TransformerTemporalModel"),xd=i(),de=n("div"),f(Bn.$$.fragment),Su=i(),hi=n("p"),Ku=d("Transformer model for video-like data."),Wu=i(),Tr=n("div"),f(Sn.$$.fragment),$d=i(),Ge=n("h2"),So=n("a"),_i=n("span"),f(Kn.$$.fragment),Xu=i(),gi=n("span"),Hu=d("Transformer2DModelOutput"),wd=i(),Wn=n("div"),f(Xn.$$.fragment),Dd=i(),Je=n("h2"),Ko=n("a"),bi=n("span"),f(Hn.$$.fragment),Qu=i(),vi=n("span"),Ru=d("PriorTransformer"),kd=i(),V=n("div"),f(Qn.$$.fragment),Yu=i(),yi=n("p"),Gu=d(`The prior transformer from unCLIP is used to predict CLIP image embeddings from CLIP text embeddings. Note that the
transformer predicts the image embeddings through a denoising diffusion process.`),Ju=i(),Rn=n("p"),Zu=d("This model inherits from "),Mr=n("a"),eh=d("ModelMixin"),oh=d(`. Check the superclass documentation for the generic methods the library
implements for all the models (such as downloading or saving, etc.)`),th=i(),Nr=n("p"),nh=d("For more details, see the original paper: "),Yn=n("a"),sh=d("https://arxiv.org/abs/2204.06125"),rh=i(),Er=n("div"),f(Gn.$$.fragment),Td=i(),Ze=n("h2"),Wo=n("a"),xi=n("span"),f(Jn.$$.fragment),ah=i(),$i=n("span"),ih=d("PriorTransformerOutput"),Md=i(),Zn=n("div"),f(es.$$.fragment),Nd=i(),eo=n("h2"),Xo=n("a"),wi=n("span"),f(os.$$.fragment),lh=i(),Di=n("span"),dh=d("ControlNetOutput"),Ed=i(),ts=n("div"),f(ns.$$.fragment),Ad=i(),oo=n("h2"),Ho=n("a"),ki=n("span"),f(ss.$$.fragment),ch=i(),Ti=n("span"),mh=d("ControlNetModel"),Ud=i(),G=n("div"),f(rs.$$.fragment),ph=i(),Qo=n("div"),f(as.$$.fragment),fh=i(),Mi=n("p"),uh=d("Instantiate Controlnet class from UNet2DConditionModel."),hh=i(),ye=n("div"),f(is.$$.fragment),_h=i(),Ni=n("p"),gh=d("Enable sliced attention computation."),bh=i(),Ei=n("p"),vh=d(`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),yh=i(),Ar=n("div"),f(ls.$$.fragment),Cd=i(),to=n("h2"),Ro=n("a"),Ai=n("span"),f(ds.$$.fragment),xh=i(),Ui=n("span"),$h=d("FlaxModelMixin"),Fd=i(),U=n("div"),f(cs.$$.fragment),wh=i(),Ci=n("p"),Dh=d("Base class for all flax models."),kh=i(),Ur=n("p"),Cr=n("a"),Th=d("FlaxModelMixin"),Mh=d(` takes care of storing the configuration of the models and handles methods for loading,
downloading and saving models.`),Nh=i(),K=n("div"),f(ms.$$.fragment),Eh=i(),Fi=n("p"),Ah=d("Instantiate a pretrained flax model from a pre-trained model configuration."),Uh=i(),ps=n("p"),Ch=d("The warning "),Pi=n("em"),Fh=d("Weights from XXX not initialized from pretrained model"),Ph=d(` means that the weights of XXX do not come
pretrained with the rest of the model. It is up to you to train those weights with a downstream fine-tuning
task.`),Oh=i(),fs=n("p"),qh=d("The warning "),Oi=n("em"),Lh=d("Weights from XXX not used in YYY"),jh=d(` means that the layer XXX is not used by YYY, therefore those
weights are discarded.`),Ih=i(),f(Yo.$$.fragment),zh=i(),Go=n("div"),f(us.$$.fragment),Vh=i(),hs=n("p"),Bh=d(`Save a model and its configuration file to a directory, so that it can be re-loaded using the
`),qi=n("code"),Sh=d("[from_pretrained()](/docs/diffusers/pr_2813/en/api/models#diffusers.FlaxModelMixin.from_pretrained)"),Kh=d(" class method"),Wh=i(),te=n("div"),f(_s.$$.fragment),Xh=i(),J=n("p"),Hh=d("Cast the floating-point "),Li=n("code"),Qh=d("params"),Rh=d(" to "),ji=n("code"),Yh=d("jax.numpy.bfloat16"),Gh=d(". This returns a new "),Ii=n("code"),Jh=d("params"),Zh=d(` tree and does not cast
the `),zi=n("code"),e_=d("params"),o_=d(" in place."),t_=i(),Vi=n("p"),n_=d(`This method can be used on TPU to explicitly convert the model parameters to bfloat16 precision to do full
half-precision training or to save weights in bfloat16 for inference in order to save memory and improve speed.`),s_=i(),f(Jo.$$.fragment),r_=i(),ne=n("div"),f(gs.$$.fragment),a_=i(),Z=n("p"),i_=d("Cast the floating-point "),Bi=n("code"),l_=d("params"),d_=d(" to "),Si=n("code"),c_=d("jax.numpy.float16"),m_=d(". This returns a new "),Ki=n("code"),p_=d("params"),f_=d(` tree and does not cast the
`),Wi=n("code"),u_=d("params"),h_=d(" in place."),__=i(),Xi=n("p"),g_=d(`This method can be used on GPU to explicitly convert the model parameters to float16 precision to do full
half-precision training or to save weights in float16 for inference in order to save memory and improve speed.`),b_=i(),f(Zo.$$.fragment),v_=i(),xe=n("div"),f(bs.$$.fragment),y_=i(),ee=n("p"),x_=d("Cast the floating-point "),Hi=n("code"),$_=d("params"),w_=d(" to "),Qi=n("code"),D_=d("jax.numpy.float32"),k_=d(`. This method can be used to explicitly convert the
model parameters to fp32 precision. This returns a new `),Ri=n("code"),T_=d("params"),M_=d(" tree and does not cast the "),Yi=n("code"),N_=d("params"),E_=d(" in place."),A_=i(),f(et.$$.fragment),Pd=i(),no=n("h2"),ot=n("a"),Gi=n("span"),f(vs.$$.fragment),U_=i(),Ji=n("span"),C_=d("FlaxUNet2DConditionOutput"),Od=i(),so=n("div"),f(ys.$$.fragment),F_=i(),tt=n("div"),f(xs.$$.fragment),P_=i(),Zi=n("p"),O_=d("\u201CReturns a new object replacing the specified fields with new values."),qd=i(),ro=n("h2"),nt=n("a"),el=n("span"),f($s.$$.fragment),q_=i(),ol=n("span"),L_=d("FlaxUNet2DConditionModel"),Ld=i(),L=n("div"),f(ws.$$.fragment),j_=i(),tl=n("p"),I_=d(`FlaxUNet2DConditionModel is a conditional 2D UNet model that takes in a noisy sample, conditional state, and a
timestep and returns sample shaped output.`),z_=i(),Ds=n("p"),V_=d("This model inherits from "),Fr=n("a"),B_=d("FlaxModelMixin"),S_=d(`. Check the superclass documentation for the generic methods the library
implements for all the models (such as downloading or saving, etc.)`),K_=i(),ks=n("p"),W_=d("Also, this model is a Flax Linen "),Ts=n("a"),X_=d("flax.linen.Module"),H_=d(`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),Q_=i(),nl=n("p"),R_=d("Finally, this model supports inherent JAX features such as:"),Y_=i(),ce=n("ul"),sl=n("li"),Ms=n("a"),G_=d("Just-In-Time (JIT) compilation"),J_=i(),rl=n("li"),Ns=n("a"),Z_=d("Automatic Differentiation"),eg=i(),al=n("li"),Es=n("a"),og=d("Vectorization"),tg=i(),il=n("li"),As=n("a"),ng=d("Parallelization"),jd=i(),ao=n("h2"),st=n("a"),ll=n("span"),f(Us.$$.fragment),sg=i(),dl=n("span"),rg=d("FlaxDecoderOutput"),Id=i(),me=n("div"),f(Cs.$$.fragment),ag=i(),cl=n("p"),ig=d("Output of decoding method."),lg=i(),rt=n("div"),f(Fs.$$.fragment),dg=i(),ml=n("p"),cg=d("\u201CReturns a new object replacing the specified fields with new values."),zd=i(),io=n("h2"),at=n("a"),pl=n("span"),f(Ps.$$.fragment),mg=i(),fl=n("span"),pg=d("FlaxAutoencoderKLOutput"),Vd=i(),pe=n("div"),f(Os.$$.fragment),fg=i(),ul=n("p"),ug=d("Output of AutoencoderKL encoding method."),hg=i(),it=n("div"),f(qs.$$.fragment),_g=i(),hl=n("p"),gg=d("\u201CReturns a new object replacing the specified fields with new values."),Bd=i(),lo=n("h2"),lt=n("a"),_l=n("span"),f(Ls.$$.fragment),bg=i(),gl=n("span"),vg=d("FlaxAutoencoderKL"),Sd=i(),B=n("div"),f(js.$$.fragment),yg=i(),bl=n("p"),xg=d(`Flax Implementation of Variational Autoencoder (VAE) model with KL loss from the paper Auto-Encoding Variational
Bayes by Diederik P. Kingma and Max Welling.`),$g=i(),Is=n("p"),wg=d("This model is a Flax Linen "),zs=n("a"),Dg=d("flax.linen.Module"),kg=d(`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),Tg=i(),vl=n("p"),Mg=d("Finally, this model supports inherent JAX features such as:"),Ng=i(),fe=n("ul"),yl=n("li"),Vs=n("a"),Eg=d("Just-In-Time (JIT) compilation"),Ag=i(),xl=n("li"),Bs=n("a"),Ug=d("Automatic Differentiation"),Cg=i(),$l=n("li"),Ss=n("a"),Fg=d("Vectorization"),Pg=i(),wl=n("li"),Ks=n("a"),Og=d("Parallelization"),Kd=i(),co=n("h2"),dt=n("a"),Dl=n("span"),f(Ws.$$.fragment),qg=i(),kl=n("span"),Lg=d("FlaxControlNetOutput"),Wd=i(),mo=n("div"),f(Xs.$$.fragment),jg=i(),ct=n("div"),f(Hs.$$.fragment),Ig=i(),Tl=n("p"),zg=d("\u201CReturns a new object replacing the specified fields with new values."),Xd=i(),po=n("h2"),mt=n("a"),Ml=n("span"),f(Qs.$$.fragment),Vg=i(),Nl=n("span"),Bg=d("FlaxControlNetModel"),Hd=i(),j=n("div"),f(Rs.$$.fragment),Sg=i(),Ys=n("p"),Kg=d("Quoting from "),Gs=n("a"),Wg=d("https://arxiv.org/abs/2302.05543"),Xg=d(`: \u201CStable Diffusion uses a pre-processing method similar to VQ-GAN
[11] to convert the entire dataset of 512 \xD7 512 images into smaller 64 \xD7 64 \u201Clatent images\u201D for stabilized
training. This requires ControlNets to convert image-based conditions to 64 \xD7 64 feature space to match the
convolution size. We use a tiny network E(\xB7) of four convolution layers with 4 \xD7 4 kernels and 2 \xD7 2 strides
(activated by ReLU, channels are 16, 32, 64, 128, initialized with Gaussian weights, trained jointly with the full
model) to encode image-space conditions \u2026 into feature maps \u2026\u201D`),Hg=i(),Js=n("p"),Qg=d("This model inherits from "),Pr=n("a"),Rg=d("FlaxModelMixin"),Yg=d(`. Check the superclass documentation for the generic methods the library
implements for all the models (such as downloading or saving, etc.)`),Gg=i(),Zs=n("p"),Jg=d("Also, this model is a Flax Linen "),er=n("a"),Zg=d("flax.linen.Module"),e2=d(`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),o2=i(),El=n("p"),t2=d("Finally, this model supports inherent JAX features such as:"),n2=i(),ue=n("ul"),Al=n("li"),or=n("a"),s2=d("Just-In-Time (JIT) compilation"),r2=i(),Ul=n("li"),tr=n("a"),a2=d("Automatic Differentiation"),i2=i(),Cl=n("li"),nr=n("a"),l2=d("Vectorization"),d2=i(),Fl=n("li"),sr=n("a"),c2=d("Parallelization"),this.h()},l(o){const m=Ay('[data-svelte="svelte-1phssyn"]',document.head);x=s(m,"META",{name:!0,content:!0}),m.forEach(t),T=l(o),D=s(o,"H1",{class:!0});var rr=r(D);$=s(rr,"A",{id:!0,class:!0,href:!0});var Pl=r($);k=s(Pl,"SPAN",{});var Ol=r(k);u(v.$$.fragment,Ol),Ol.forEach(t),Pl.forEach(t),w=l(rr),oe=s(rr,"SPAN",{});var ql=r(oe);Ee=c(ql,"Models"),ql.forEach(t),rr.forEach(t),X=l(o),H=s(o,"P",{});var fo=r(H);ir=c(fo,`Diffusers contains pretrained models for popular algorithms and modules for creating the next set of diffusion models.
The primary function of these models is to denoise an input sample, by modeling the distribution $p`),Wr=s(fo,"EM",{});var Ll=r(Wr);fm=c(Ll,"\\theta(\\mathbf{x}"),Ll.forEach(t),um=c(fo,`{t-1}|\\mathbf{x}_t)$.
The models are built on the base class [\u2018ModelMixin\u2019] that is a `),Xr=s(fo,"CODE",{});var jl=r(Xr);hm=c(jl,"torch.nn.module"),jl.forEach(t),_m=c(fo," with basic functionality for saving and loading models both locally and from the HuggingFace hub."),fo.forEach(t),Bl=l(o),Ae=s(o,"H2",{class:!0});var Rd=r(Ae);uo=s(Rd,"A",{id:!0,class:!0,href:!0});var u2=r(uo);Hr=s(u2,"SPAN",{});var h2=r(Hr);u(xt.$$.fragment,h2),h2.forEach(t),u2.forEach(t),gm=l(Rd),Qr=s(Rd,"SPAN",{});var _2=r(Qr);bm=c(_2,"ModelMixin"),_2.forEach(t),Rd.forEach(t),Sl=l(o),N=s(o,"DIV",{class:!0});var A=r(N);u($t.$$.fragment,A),vm=l(A),Rr=s(A,"P",{});var g2=r(Rr);ym=c(g2,"Base class for all models."),g2.forEach(t),xm=l(A),lr=s(A,"P",{});var m2=r(lr);dr=s(m2,"A",{href:!0});var b2=r(dr);$m=c(b2,"ModelMixin"),b2.forEach(t),wm=c(m2,` takes care of storing the configuration of the models and handles methods for loading, downloading
and saving models.`),m2.forEach(t),Dm=l(A),Yr=s(A,"UL",{});var v2=r(Yr);he=s(v2,"LI",{});var ar=r(he);Gr=s(ar,"STRONG",{});var y2=r(Gr);km=c(y2,"config_name"),y2.forEach(t),Tm=c(ar," ("),Jr=s(ar,"CODE",{});var x2=r(Jr);Mm=c(x2,"str"),x2.forEach(t),Nm=c(ar,`) \u2014 A filename under which the model should be stored when calling
`),cr=s(ar,"A",{href:!0});var $2=r(cr);Em=c($2,"save_pretrained()"),$2.forEach(t),Am=c(ar,"."),ar.forEach(t),v2.forEach(t),Um=l(A),_e=s(A,"DIV",{class:!0});var Or=r(_e);u(wt.$$.fragment,Or),Cm=l(Or),Zr=s(Or,"P",{});var w2=r(Zr);Fm=c(w2,"Deactivates gradient checkpointing for the current model."),w2.forEach(t),Pm=l(Or),ea=s(Or,"P",{});var D2=r(ea);Om=c(D2,`Note that in other frameworks this feature can be referred to as \u201Cactivation checkpointing\u201D or \u201Ccheckpoint
activations\u201D.`),D2.forEach(t),Or.forEach(t),qm=l(A),ho=s(A,"DIV",{class:!0});var Yd=r(ho);u(Dt.$$.fragment,Yd),Lm=l(Yd),oa=s(Yd,"P",{});var k2=r(oa);jm=c(k2,"Disable memory efficient attention as implemented in xformers."),k2.forEach(t),Yd.forEach(t),Im=l(A),ge=s(A,"DIV",{class:!0});var qr=r(ge);u(kt.$$.fragment,qr),zm=l(qr),ta=s(qr,"P",{});var T2=r(ta);Vm=c(T2,"Activates gradient checkpointing for the current model."),T2.forEach(t),Bm=l(qr),na=s(qr,"P",{});var M2=r(na);Sm=c(M2,`Note that in other frameworks this feature can be referred to as \u201Cactivation checkpointing\u201D or \u201Ccheckpoint
activations\u201D.`),M2.forEach(t),qr.forEach(t),Km=l(A),S=s(A,"DIV",{class:!0});var $e=r(S);u(Tt.$$.fragment,$e),Wm=l($e),sa=s($e,"P",{});var N2=r(sa);Xm=c(N2,"Enable memory efficient attention as implemented in xformers."),N2.forEach(t),Hm=l($e),ra=s($e,"P",{});var E2=r(ra);Qm=c(E2,`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),E2.forEach(t),Rm=l($e),aa=s($e,"P",{});var A2=r(aa);Ym=c(A2,`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),A2.forEach(t),Gm=l($e),u(_o.$$.fragment,$e),$e.forEach(t),Jm=l(A),F=s(A,"DIV",{class:!0});var W=r(F);u(Mt.$$.fragment,W),Zm=l(W),ia=s(W,"P",{});var U2=r(ia);ep=c(U2,"Instantiate a pretrained pytorch model from a pre-trained model configuration."),U2.forEach(t),op=l(W),Ue=s(W,"P",{});var Lr=r(Ue);tp=c(Lr,"The model is set in evaluation mode by default using "),la=s(Lr,"CODE",{});var C2=r(la);np=c(C2,"model.eval()"),C2.forEach(t),sp=c(Lr,` (Dropout modules are deactivated). To train
the model, you should first set it back in training mode with `),da=s(Lr,"CODE",{});var F2=r(da);rp=c(F2,"model.train()"),F2.forEach(t),ap=c(Lr,"."),Lr.forEach(t),ip=l(W),Nt=s(W,"P",{});var Gd=r(Nt);lp=c(Gd,"The warning "),ca=s(Gd,"EM",{});var P2=r(ca);dp=c(P2,"Weights from XXX not initialized from pretrained model"),P2.forEach(t),cp=c(Gd,` means that the weights of XXX do not come
pretrained with the rest of the model. It is up to you to train those weights with a downstream fine-tuning
task.`),Gd.forEach(t),mp=l(W),Et=s(W,"P",{});var Jd=r(Et);pp=c(Jd,"The warning "),ma=s(Jd,"EM",{});var O2=r(ma);fp=c(O2,"Weights from XXX not used in YYY"),O2.forEach(t),up=c(Jd,` means that the layer XXX is not used by YYY, therefore those
weights are discarded.`),Jd.forEach(t),hp=l(W),u(go.$$.fragment,W),_p=l(W),u(bo.$$.fragment,W),W.forEach(t),gp=l(A),vo=s(A,"DIV",{class:!0});var Zd=r(vo);u(At.$$.fragment,Zd),bp=l(Zd),pa=s(Zd,"P",{});var q2=r(pa);vp=c(q2,"Get number of (optionally, trainable or non-embeddings) parameters in the module."),q2.forEach(t),Zd.forEach(t),yp=l(A),yo=s(A,"DIV",{class:!0});var ec=r(yo);u(Ut.$$.fragment,ec),xp=l(ec),Ct=s(ec,"P",{});var oc=r(Ct);$p=c(oc,`Save a model and its configuration file to a directory, so that it can be re-loaded using the
`),fa=s(oc,"CODE",{});var L2=r(fa);wp=c(L2,"[from_pretrained()](/docs/diffusers/pr_2813/en/api/models#diffusers.ModelMixin.from_pretrained)"),L2.forEach(t),Dp=c(oc," class method."),oc.forEach(t),ec.forEach(t),A.forEach(t),Kl=l(o),Ce=s(o,"H2",{class:!0});var tc=r(Ce);xo=s(tc,"A",{id:!0,class:!0,href:!0});var j2=r(xo);ua=s(j2,"SPAN",{});var I2=r(ua);u(Ft.$$.fragment,I2),I2.forEach(t),j2.forEach(t),kp=l(tc),ha=s(tc,"SPAN",{});var z2=r(ha);Tp=c(z2,"UNet2DOutput"),z2.forEach(t),tc.forEach(t),Wl=l(o),Pt=s(o,"DIV",{class:!0});var V2=r(Pt);u(Ot.$$.fragment,V2),V2.forEach(t),Xl=l(o),Fe=s(o,"H2",{class:!0});var nc=r(Fe);$o=s(nc,"A",{id:!0,class:!0,href:!0});var B2=r($o);_a=s(B2,"SPAN",{});var S2=r(_a);u(qt.$$.fragment,S2),S2.forEach(t),B2.forEach(t),Mp=l(nc),ga=s(nc,"SPAN",{});var K2=r(ga);Np=c(K2,"UNet2DModel"),K2.forEach(t),nc.forEach(t),Hl=l(o),Q=s(o,"DIV",{class:!0});var pt=r(Q);u(Lt.$$.fragment,pt),Ep=l(pt),ba=s(pt,"P",{});var W2=r(ba);Ap=c(W2,"UNet2DModel is a 2D UNet model that takes in a noisy sample and a timestep and returns sample shaped output."),W2.forEach(t),Up=l(pt),jt=s(pt,"P",{});var sc=r(jt);Cp=c(sc,"This model inherits from "),mr=s(sc,"A",{href:!0});var X2=r(mr);Fp=c(X2,"ModelMixin"),X2.forEach(t),Pp=c(sc,`. Check the superclass documentation for the generic methods the library
implements for all the model (such as downloading or saving, etc.)`),sc.forEach(t),Op=l(pt),pr=s(pt,"DIV",{class:!0});var H2=r(pr);u(It.$$.fragment,H2),H2.forEach(t),pt.forEach(t),Ql=l(o),Pe=s(o,"H2",{class:!0});var rc=r(Pe);wo=s(rc,"A",{id:!0,class:!0,href:!0});var Q2=r(wo);va=s(Q2,"SPAN",{});var R2=r(va);u(zt.$$.fragment,R2),R2.forEach(t),Q2.forEach(t),qp=l(rc),ya=s(rc,"SPAN",{});var Y2=r(ya);Lp=c(Y2,"UNet1DOutput"),Y2.forEach(t),rc.forEach(t),Rl=l(o),Vt=s(o,"DIV",{class:!0});var G2=r(Vt);u(Bt.$$.fragment,G2),G2.forEach(t),Yl=l(o),Oe=s(o,"H2",{class:!0});var ac=r(Oe);Do=s(ac,"A",{id:!0,class:!0,href:!0});var J2=r(Do);xa=s(J2,"SPAN",{});var Z2=r(xa);u(St.$$.fragment,Z2),Z2.forEach(t),J2.forEach(t),jp=l(ac),$a=s(ac,"SPAN",{});var eb=r($a);Ip=c(eb,"UNet1DModel"),eb.forEach(t),ac.forEach(t),Gl=l(o),R=s(o,"DIV",{class:!0});var ft=r(R);u(Kt.$$.fragment,ft),zp=l(ft),wa=s(ft,"P",{});var ob=r(wa);Vp=c(ob,"UNet1DModel is a 1D UNet model that takes in a noisy sample and a timestep and returns sample shaped output."),ob.forEach(t),Bp=l(ft),Wt=s(ft,"P",{});var ic=r(Wt);Sp=c(ic,"This model inherits from "),fr=s(ic,"A",{href:!0});var tb=r(fr);Kp=c(tb,"ModelMixin"),tb.forEach(t),Wp=c(ic,`. Check the superclass documentation for the generic methods the library
implements for all the model (such as downloading or saving, etc.)`),ic.forEach(t),Xp=l(ft),ur=s(ft,"DIV",{class:!0});var nb=r(ur);u(Xt.$$.fragment,nb),nb.forEach(t),ft.forEach(t),Jl=l(o),qe=s(o,"H2",{class:!0});var lc=r(qe);ko=s(lc,"A",{id:!0,class:!0,href:!0});var sb=r(ko);Da=s(sb,"SPAN",{});var rb=r(Da);u(Ht.$$.fragment,rb),rb.forEach(t),sb.forEach(t),Hp=l(lc),ka=s(lc,"SPAN",{});var ab=r(ka);Qp=c(ab,"UNet2DConditionOutput"),ab.forEach(t),lc.forEach(t),Zl=l(o),Qt=s(o,"DIV",{class:!0});var ib=r(Qt);u(Rt.$$.fragment,ib),ib.forEach(t),ed=l(o),Le=s(o,"H2",{class:!0});var dc=r(Le);To=s(dc,"A",{id:!0,class:!0,href:!0});var lb=r(To);Ta=s(lb,"SPAN",{});var db=r(Ta);u(Yt.$$.fragment,db),db.forEach(t),lb.forEach(t),Rp=l(dc),Ma=s(dc,"SPAN",{});var cb=r(Ma);Yp=c(cb,"UNet2DConditionModel"),cb.forEach(t),dc.forEach(t),od=l(o),P=s(o,"DIV",{class:!0});var se=r(P);u(Gt.$$.fragment,se),Gp=l(se),Na=s(se,"P",{});var mb=r(Na);Jp=c(mb,`UNet2DConditionModel is a conditional 2D UNet model that takes in a noisy sample, conditional state, and a timestep
and returns sample shaped output.`),mb.forEach(t),Zp=l(se),Jt=s(se,"P",{});var cc=r(Jt);ef=c(cc,"This model inherits from "),hr=s(cc,"A",{href:!0});var pb=r(hr);of=c(pb,"ModelMixin"),pb.forEach(t),tf=c(cc,`. Check the superclass documentation for the generic methods the library
implements for all the models (such as downloading or saving, etc.)`),cc.forEach(t),nf=l(se),_r=s(se,"DIV",{class:!0});var fb=r(_r);u(Zt.$$.fragment,fb),fb.forEach(t),sf=l(se),be=s(se,"DIV",{class:!0});var jr=r(be);u(en.$$.fragment,jr),rf=l(jr),Ea=s(jr,"P",{});var ub=r(Ea);af=c(ub,"Enable sliced attention computation."),ub.forEach(t),lf=l(jr),Aa=s(jr,"P",{});var hb=r(Aa);df=c(hb,`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),hb.forEach(t),jr.forEach(t),cf=l(se),gr=s(se,"DIV",{class:!0});var _b=r(gr);u(on.$$.fragment,_b),_b.forEach(t),se.forEach(t),td=l(o),je=s(o,"H2",{class:!0});var mc=r(je);Mo=s(mc,"A",{id:!0,class:!0,href:!0});var gb=r(Mo);Ua=s(gb,"SPAN",{});var bb=r(Ua);u(tn.$$.fragment,bb),bb.forEach(t),gb.forEach(t),mf=l(mc),Ca=s(mc,"SPAN",{});var vb=r(Ca);pf=c(vb,"UNet3DConditionOutput"),vb.forEach(t),mc.forEach(t),nd=l(o),nn=s(o,"DIV",{class:!0});var yb=r(nn);u(sn.$$.fragment,yb),yb.forEach(t),sd=l(o),Ie=s(o,"H2",{class:!0});var pc=r(Ie);No=s(pc,"A",{id:!0,class:!0,href:!0});var xb=r(No);Fa=s(xb,"SPAN",{});var $b=r(Fa);u(rn.$$.fragment,$b),$b.forEach(t),xb.forEach(t),ff=l(pc),Pa=s(pc,"SPAN",{});var wb=r(Pa);uf=c(wb,"UNet3DConditionModel"),wb.forEach(t),pc.forEach(t),rd=l(o),O=s(o,"DIV",{class:!0});var re=r(O);u(an.$$.fragment,re),hf=l(re),Oa=s(re,"P",{});var Db=r(Oa);_f=c(Db,`UNet3DConditionModel is a conditional 2D UNet model that takes in a noisy sample, conditional state, and a timestep
and returns sample shaped output.`),Db.forEach(t),gf=l(re),ln=s(re,"P",{});var fc=r(ln);bf=c(fc,"This model inherits from "),br=s(fc,"A",{href:!0});var kb=r(br);vf=c(kb,"ModelMixin"),kb.forEach(t),yf=c(fc,`. Check the superclass documentation for the generic methods the library
implements for all the models (such as downloading or saving, etc.)`),fc.forEach(t),xf=l(re),vr=s(re,"DIV",{class:!0});var Tb=r(vr);u(dn.$$.fragment,Tb),Tb.forEach(t),$f=l(re),ve=s(re,"DIV",{class:!0});var Ir=r(ve);u(cn.$$.fragment,Ir),wf=l(Ir),qa=s(Ir,"P",{});var Mb=r(qa);Df=c(Mb,"Enable sliced attention computation."),Mb.forEach(t),kf=l(Ir),La=s(Ir,"P",{});var Nb=r(La);Tf=c(Nb,`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),Nb.forEach(t),Ir.forEach(t),Mf=l(re),yr=s(re,"DIV",{class:!0});var Eb=r(yr);u(mn.$$.fragment,Eb),Eb.forEach(t),re.forEach(t),ad=l(o),ze=s(o,"H2",{class:!0});var uc=r(ze);Eo=s(uc,"A",{id:!0,class:!0,href:!0});var Ab=r(Eo);ja=s(Ab,"SPAN",{});var Ub=r(ja);u(pn.$$.fragment,Ub),Ub.forEach(t),Ab.forEach(t),Nf=l(uc),Ia=s(uc,"SPAN",{});var Cb=r(Ia);Ef=c(Cb,"DecoderOutput"),Cb.forEach(t),uc.forEach(t),id=l(o),Ve=s(o,"DIV",{class:!0});var hc=r(Ve);u(fn.$$.fragment,hc),Af=l(hc),za=s(hc,"P",{});var Fb=r(za);Uf=c(Fb,"Output of decoding method."),Fb.forEach(t),hc.forEach(t),ld=l(o),Be=s(o,"H2",{class:!0});var _c=r(Be);Ao=s(_c,"A",{id:!0,class:!0,href:!0});var Pb=r(Ao);Va=s(Pb,"SPAN",{});var Ob=r(Va);u(un.$$.fragment,Ob),Ob.forEach(t),Pb.forEach(t),Cf=l(_c),Ba=s(_c,"SPAN",{});var qb=r(Ba);Ff=c(qb,"VQEncoderOutput"),qb.forEach(t),_c.forEach(t),dd=l(o),Se=s(o,"DIV",{class:!0});var gc=r(Se);u(hn.$$.fragment,gc),Pf=l(gc),Sa=s(gc,"P",{});var Lb=r(Sa);Of=c(Lb,"Output of VQModel encoding method."),Lb.forEach(t),gc.forEach(t),cd=l(o),Ke=s(o,"H2",{class:!0});var bc=r(Ke);Uo=s(bc,"A",{id:!0,class:!0,href:!0});var jb=r(Uo);Ka=s(jb,"SPAN",{});var Ib=r(Ka);u(_n.$$.fragment,Ib),Ib.forEach(t),jb.forEach(t),qf=l(bc),Wa=s(bc,"SPAN",{});var zb=r(Wa);Lf=c(zb,"VQModel"),zb.forEach(t),bc.forEach(t),md=l(o),Y=s(o,"DIV",{class:!0});var ut=r(Y);u(gn.$$.fragment,ut),jf=l(ut),Xa=s(ut,"P",{});var Vb=r(Xa);If=c(Vb,`VQ-VAE model from the paper Neural Discrete Representation Learning by Aaron van den Oord, Oriol Vinyals and Koray
Kavukcuoglu.`),Vb.forEach(t),zf=l(ut),bn=s(ut,"P",{});var vc=r(bn);Vf=c(vc,"This model inherits from "),xr=s(vc,"A",{href:!0});var Bb=r(xr);Bf=c(Bb,"ModelMixin"),Bb.forEach(t),Sf=c(vc,`. Check the superclass documentation for the generic methods the library
implements for all the model (such as downloading or saving, etc.)`),vc.forEach(t),Kf=l(ut),$r=s(ut,"DIV",{class:!0});var Sb=r($r);u(vn.$$.fragment,Sb),Sb.forEach(t),ut.forEach(t),pd=l(o),We=s(o,"H2",{class:!0});var yc=r(We);Co=s(yc,"A",{id:!0,class:!0,href:!0});var Kb=r(Co);Ha=s(Kb,"SPAN",{});var Wb=r(Ha);u(yn.$$.fragment,Wb),Wb.forEach(t),Kb.forEach(t),Wf=l(yc),Qa=s(yc,"SPAN",{});var Xb=r(Qa);Xf=c(Xb,"AutoencoderKLOutput"),Xb.forEach(t),yc.forEach(t),fd=l(o),Xe=s(o,"DIV",{class:!0});var xc=r(Xe);u(xn.$$.fragment,xc),Hf=l(xc),Ra=s(xc,"P",{});var Hb=r(Ra);Qf=c(Hb,"Output of AutoencoderKL encoding method."),Hb.forEach(t),xc.forEach(t),ud=l(o),He=s(o,"H2",{class:!0});var $c=r(He);Fo=s($c,"A",{id:!0,class:!0,href:!0});var Qb=r(Fo);Ya=s(Qb,"SPAN",{});var Rb=r(Ya);u($n.$$.fragment,Rb),Rb.forEach(t),Qb.forEach(t),Rf=l($c),Ga=s($c,"SPAN",{});var Yb=r(Ga);Yf=c(Yb,"AutoencoderKL"),Yb.forEach(t),$c.forEach(t),hd=l(o),E=s(o,"DIV",{class:!0});var C=r(E);u(wn.$$.fragment,C),Gf=l(C),Ja=s(C,"P",{});var Gb=r(Ja);Jf=c(Gb,`Variational Autoencoder (VAE) model with KL loss from the paper Auto-Encoding Variational Bayes by Diederik P. Kingma
and Max Welling.`),Gb.forEach(t),Zf=l(C),Dn=s(C,"P",{});var wc=r(Dn);eu=c(wc,"This model inherits from "),wr=s(wc,"A",{href:!0});var Jb=r(wr);ou=c(Jb,"ModelMixin"),Jb.forEach(t),tu=c(wc,`. Check the superclass documentation for the generic methods the library
implements for all the model (such as downloading or saving, etc.)`),wc.forEach(t),nu=l(C),Po=s(C,"DIV",{class:!0});var Dc=r(Po);u(kn.$$.fragment,Dc),su=l(Dc),Tn=s(Dc,"P",{});var kc=r(Tn);ru=c(kc,"Disable sliced VAE decoding. If "),Za=s(kc,"CODE",{});var Zb=r(Za);au=c(Zb,"enable_slicing"),Zb.forEach(t),iu=c(kc,` was previously invoked, this method will go back to computing
decoding in one step.`),kc.forEach(t),Dc.forEach(t),lu=l(C),Oo=s(C,"DIV",{class:!0});var Tc=r(Oo);u(Mn.$$.fragment,Tc),du=l(Tc),Nn=s(Tc,"P",{});var Mc=r(Nn);cu=c(Mc,"Disable tiled VAE decoding. If "),ei=s(Mc,"CODE",{});var ev=r(ei);mu=c(ev,"enable_vae_tiling"),ev.forEach(t),pu=c(Mc,` was previously invoked, this method will go back to
computing decoding in one step.`),Mc.forEach(t),Tc.forEach(t),fu=l(C),qo=s(C,"DIV",{class:!0});var Nc=r(qo);u(En.$$.fragment,Nc),uu=l(Nc),oi=s(Nc,"P",{});var ov=r(oi);hu=c(ov,`Enable sliced VAE decoding. When this option is enabled, the VAE will split the input tensor in slices to
compute decoding in several steps. This is useful to save some memory and allow larger batch sizes.`),ov.forEach(t),Nc.forEach(t),_u=l(C),Lo=s(C,"DIV",{class:!0});var Ec=r(Lo);u(An.$$.fragment,Ec),gu=l(Ec),ti=s(Ec,"P",{});var tv=r(ti);bu=c(tv,`Enable tiled VAE decoding. When this option is enabled, the VAE will split the input tensor into tiles to
compute decoding and encoding in several steps. This is useful to save a large amount of memory and to allow
the processing of larger images.`),tv.forEach(t),Ec.forEach(t),vu=l(C),Dr=s(C,"DIV",{class:!0});var nv=r(Dr);u(Un.$$.fragment,nv),nv.forEach(t),yu=l(C),jo=s(C,"DIV",{class:!0});var Ac=r(jo);u(Cn.$$.fragment,Ac),xu=l(Ac),ni=s(Ac,"P",{});var sv=r(ni);$u=c(sv,"Decode a batch of images using a tiled decoder."),sv.forEach(t),Ac.forEach(t),wu=l(C),Io=s(C,"DIV",{class:!0});var Uc=r(Io);u(Fn.$$.fragment,Uc),Du=l(Uc),si=s(Uc,"P",{});var rv=r(si);ku=c(rv,"Encode a batch of images using a tiled encoder."),rv.forEach(t),Uc.forEach(t),C.forEach(t),_d=l(o),Qe=s(o,"H2",{class:!0});var Cc=r(Qe);zo=s(Cc,"A",{id:!0,class:!0,href:!0});var av=r(zo);ri=s(av,"SPAN",{});var iv=r(ri);u(Pn.$$.fragment,iv),iv.forEach(t),av.forEach(t),Tu=l(Cc),ai=s(Cc,"SPAN",{});var lv=r(ai);Mu=c(lv,"Transformer2DModel"),lv.forEach(t),Cc.forEach(t),gd=l(o),q=s(o,"DIV",{class:!0});var ae=r(q);u(On.$$.fragment,ae),Nu=l(ae),ii=s(ae,"P",{});var dv=r(ii);Eu=c(dv,`Transformer model for image-like data. Takes either discrete (classes of vector embeddings) or continuous (actual
embeddings) inputs.`),dv.forEach(t),Au=l(ae),li=s(ae,"P",{});var cv=r(li);Uu=c(cv,`When input is continuous: First, project the input (aka embedding) and reshape to b, t, d. Then apply standard
transformer action. Finally, reshape to image.`),cv.forEach(t),Cu=l(ae),qn=s(ae,"P",{});var Fc=r(qn);Fu=c(Fc,`When input is discrete: First, input (classes of latent pixels) is converted to embeddings and has positional
embeddings applied, see `),di=s(Fc,"CODE",{});var mv=r(di);Pu=c(mv,"ImagePositionalEmbeddings"),mv.forEach(t),Ou=c(Fc,`. Then apply standard transformer action. Finally, predict
classes of unnoised image.`),Fc.forEach(t),qu=l(ae),ci=s(ae,"P",{});var pv=r(ci);Lu=c(pv,`Note that it is assumed one of the input classes is the masked latent pixel. The predicted classes of the unnoised
image do not contain a prediction for the masked pixel as the unnoised image cannot be masked.`),pv.forEach(t),ju=l(ae),kr=s(ae,"DIV",{class:!0});var fv=r(kr);u(Ln.$$.fragment,fv),fv.forEach(t),ae.forEach(t),bd=l(o),Re=s(o,"H2",{class:!0});var Pc=r(Re);Vo=s(Pc,"A",{id:!0,class:!0,href:!0});var uv=r(Vo);mi=s(uv,"SPAN",{});var hv=r(mi);u(jn.$$.fragment,hv),hv.forEach(t),uv.forEach(t),Iu=l(Pc),pi=s(Pc,"SPAN",{});var _v=r(pi);zu=c(_v,"Transformer2DModelOutput"),_v.forEach(t),Pc.forEach(t),vd=l(o),In=s(o,"DIV",{class:!0});var gv=r(In);u(zn.$$.fragment,gv),gv.forEach(t),yd=l(o),Ye=s(o,"H2",{class:!0});var Oc=r(Ye);Bo=s(Oc,"A",{id:!0,class:!0,href:!0});var bv=r(Bo);fi=s(bv,"SPAN",{});var vv=r(fi);u(Vn.$$.fragment,vv),vv.forEach(t),bv.forEach(t),Vu=l(Oc),ui=s(Oc,"SPAN",{});var yv=r(ui);Bu=c(yv,"TransformerTemporalModel"),yv.forEach(t),Oc.forEach(t),xd=l(o),de=s(o,"DIV",{class:!0});var zr=r(de);u(Bn.$$.fragment,zr),Su=l(zr),hi=s(zr,"P",{});var xv=r(hi);Ku=c(xv,"Transformer model for video-like data."),xv.forEach(t),Wu=l(zr),Tr=s(zr,"DIV",{class:!0});var $v=r(Tr);u(Sn.$$.fragment,$v),$v.forEach(t),zr.forEach(t),$d=l(o),Ge=s(o,"H2",{class:!0});var qc=r(Ge);So=s(qc,"A",{id:!0,class:!0,href:!0});var wv=r(So);_i=s(wv,"SPAN",{});var Dv=r(_i);u(Kn.$$.fragment,Dv),Dv.forEach(t),wv.forEach(t),Xu=l(qc),gi=s(qc,"SPAN",{});var kv=r(gi);Hu=c(kv,"Transformer2DModelOutput"),kv.forEach(t),qc.forEach(t),wd=l(o),Wn=s(o,"DIV",{class:!0});var Tv=r(Wn);u(Xn.$$.fragment,Tv),Tv.forEach(t),Dd=l(o),Je=s(o,"H2",{class:!0});var Lc=r(Je);Ko=s(Lc,"A",{id:!0,class:!0,href:!0});var Mv=r(Ko);bi=s(Mv,"SPAN",{});var Nv=r(bi);u(Hn.$$.fragment,Nv),Nv.forEach(t),Mv.forEach(t),Qu=l(Lc),vi=s(Lc,"SPAN",{});var Ev=r(vi);Ru=c(Ev,"PriorTransformer"),Ev.forEach(t),Lc.forEach(t),kd=l(o),V=s(o,"DIV",{class:!0});var we=r(V);u(Qn.$$.fragment,we),Yu=l(we),yi=s(we,"P",{});var Av=r(yi);Gu=c(Av,`The prior transformer from unCLIP is used to predict CLIP image embeddings from CLIP text embeddings. Note that the
transformer predicts the image embeddings through a denoising diffusion process.`),Av.forEach(t),Ju=l(we),Rn=s(we,"P",{});var jc=r(Rn);Zu=c(jc,"This model inherits from "),Mr=s(jc,"A",{href:!0});var Uv=r(Mr);eh=c(Uv,"ModelMixin"),Uv.forEach(t),oh=c(jc,`. Check the superclass documentation for the generic methods the library
implements for all the models (such as downloading or saving, etc.)`),jc.forEach(t),th=l(we),Nr=s(we,"P",{});var p2=r(Nr);nh=c(p2,"For more details, see the original paper: "),Yn=s(p2,"A",{href:!0,rel:!0});var Cv=r(Yn);sh=c(Cv,"https://arxiv.org/abs/2204.06125"),Cv.forEach(t),p2.forEach(t),rh=l(we),Er=s(we,"DIV",{class:!0});var Fv=r(Er);u(Gn.$$.fragment,Fv),Fv.forEach(t),we.forEach(t),Td=l(o),Ze=s(o,"H2",{class:!0});var Ic=r(Ze);Wo=s(Ic,"A",{id:!0,class:!0,href:!0});var Pv=r(Wo);xi=s(Pv,"SPAN",{});var Ov=r(xi);u(Jn.$$.fragment,Ov),Ov.forEach(t),Pv.forEach(t),ah=l(Ic),$i=s(Ic,"SPAN",{});var qv=r($i);ih=c(qv,"PriorTransformerOutput"),qv.forEach(t),Ic.forEach(t),Md=l(o),Zn=s(o,"DIV",{class:!0});var Lv=r(Zn);u(es.$$.fragment,Lv),Lv.forEach(t),Nd=l(o),eo=s(o,"H2",{class:!0});var zc=r(eo);Xo=s(zc,"A",{id:!0,class:!0,href:!0});var jv=r(Xo);wi=s(jv,"SPAN",{});var Iv=r(wi);u(os.$$.fragment,Iv),Iv.forEach(t),jv.forEach(t),lh=l(zc),Di=s(zc,"SPAN",{});var zv=r(Di);dh=c(zv,"ControlNetOutput"),zv.forEach(t),zc.forEach(t),Ed=l(o),ts=s(o,"DIV",{class:!0});var Vv=r(ts);u(ns.$$.fragment,Vv),Vv.forEach(t),Ad=l(o),oo=s(o,"H2",{class:!0});var Vc=r(oo);Ho=s(Vc,"A",{id:!0,class:!0,href:!0});var Bv=r(Ho);ki=s(Bv,"SPAN",{});var Sv=r(ki);u(ss.$$.fragment,Sv),Sv.forEach(t),Bv.forEach(t),ch=l(Vc),Ti=s(Vc,"SPAN",{});var Kv=r(Ti);mh=c(Kv,"ControlNetModel"),Kv.forEach(t),Vc.forEach(t),Ud=l(o),G=s(o,"DIV",{class:!0});var ht=r(G);u(rs.$$.fragment,ht),ph=l(ht),Qo=s(ht,"DIV",{class:!0});var Bc=r(Qo);u(as.$$.fragment,Bc),fh=l(Bc),Mi=s(Bc,"P",{});var Wv=r(Mi);uh=c(Wv,"Instantiate Controlnet class from UNet2DConditionModel."),Wv.forEach(t),Bc.forEach(t),hh=l(ht),ye=s(ht,"DIV",{class:!0});var Vr=r(ye);u(is.$$.fragment,Vr),_h=l(Vr),Ni=s(Vr,"P",{});var Xv=r(Ni);gh=c(Xv,"Enable sliced attention computation."),Xv.forEach(t),bh=l(Vr),Ei=s(Vr,"P",{});var Hv=r(Ei);vh=c(Hv,`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),Hv.forEach(t),Vr.forEach(t),yh=l(ht),Ar=s(ht,"DIV",{class:!0});var Qv=r(Ar);u(ls.$$.fragment,Qv),Qv.forEach(t),ht.forEach(t),Cd=l(o),to=s(o,"H2",{class:!0});var Sc=r(to);Ro=s(Sc,"A",{id:!0,class:!0,href:!0});var Rv=r(Ro);Ai=s(Rv,"SPAN",{});var Yv=r(Ai);u(ds.$$.fragment,Yv),Yv.forEach(t),Rv.forEach(t),xh=l(Sc),Ui=s(Sc,"SPAN",{});var Gv=r(Ui);$h=c(Gv,"FlaxModelMixin"),Gv.forEach(t),Sc.forEach(t),Fd=l(o),U=s(o,"DIV",{class:!0});var z=r(U);u(cs.$$.fragment,z),wh=l(z),Ci=s(z,"P",{});var Jv=r(Ci);Dh=c(Jv,"Base class for all flax models."),Jv.forEach(t),kh=l(z),Ur=s(z,"P",{});var f2=r(Ur);Cr=s(f2,"A",{href:!0});var Zv=r(Cr);Th=c(Zv,"FlaxModelMixin"),Zv.forEach(t),Mh=c(f2,` takes care of storing the configuration of the models and handles methods for loading,
downloading and saving models.`),f2.forEach(t),Nh=l(z),K=s(z,"DIV",{class:!0});var De=r(K);u(ms.$$.fragment,De),Eh=l(De),Fi=s(De,"P",{});var e1=r(Fi);Ah=c(e1,"Instantiate a pretrained flax model from a pre-trained model configuration."),e1.forEach(t),Uh=l(De),ps=s(De,"P",{});var Kc=r(ps);Ch=c(Kc,"The warning "),Pi=s(Kc,"EM",{});var o1=r(Pi);Fh=c(o1,"Weights from XXX not initialized from pretrained model"),o1.forEach(t),Ph=c(Kc,` means that the weights of XXX do not come
pretrained with the rest of the model. It is up to you to train those weights with a downstream fine-tuning
task.`),Kc.forEach(t),Oh=l(De),fs=s(De,"P",{});var Wc=r(fs);qh=c(Wc,"The warning "),Oi=s(Wc,"EM",{});var t1=r(Oi);Lh=c(t1,"Weights from XXX not used in YYY"),t1.forEach(t),jh=c(Wc,` means that the layer XXX is not used by YYY, therefore those
weights are discarded.`),Wc.forEach(t),Ih=l(De),u(Yo.$$.fragment,De),De.forEach(t),zh=l(z),Go=s(z,"DIV",{class:!0});var Xc=r(Go);u(us.$$.fragment,Xc),Vh=l(Xc),hs=s(Xc,"P",{});var Hc=r(hs);Bh=c(Hc,`Save a model and its configuration file to a directory, so that it can be re-loaded using the
`),qi=s(Hc,"CODE",{});var n1=r(qi);Sh=c(n1,"[from_pretrained()](/docs/diffusers/pr_2813/en/api/models#diffusers.FlaxModelMixin.from_pretrained)"),n1.forEach(t),Kh=c(Hc," class method"),Hc.forEach(t),Xc.forEach(t),Wh=l(z),te=s(z,"DIV",{class:!0});var _t=r(te);u(_s.$$.fragment,_t),Xh=l(_t),J=s(_t,"P",{});var ke=r(J);Hh=c(ke,"Cast the floating-point "),Li=s(ke,"CODE",{});var s1=r(Li);Qh=c(s1,"params"),s1.forEach(t),Rh=c(ke," to "),ji=s(ke,"CODE",{});var r1=r(ji);Yh=c(r1,"jax.numpy.bfloat16"),r1.forEach(t),Gh=c(ke,". This returns a new "),Ii=s(ke,"CODE",{});var a1=r(Ii);Jh=c(a1,"params"),a1.forEach(t),Zh=c(ke,` tree and does not cast
the `),zi=s(ke,"CODE",{});var i1=r(zi);e_=c(i1,"params"),i1.forEach(t),o_=c(ke," in place."),ke.forEach(t),t_=l(_t),Vi=s(_t,"P",{});var l1=r(Vi);n_=c(l1,`This method can be used on TPU to explicitly convert the model parameters to bfloat16 precision to do full
half-precision training or to save weights in bfloat16 for inference in order to save memory and improve speed.`),l1.forEach(t),s_=l(_t),u(Jo.$$.fragment,_t),_t.forEach(t),r_=l(z),ne=s(z,"DIV",{class:!0});var gt=r(ne);u(gs.$$.fragment,gt),a_=l(gt),Z=s(gt,"P",{});var Te=r(Z);i_=c(Te,"Cast the floating-point "),Bi=s(Te,"CODE",{});var d1=r(Bi);l_=c(d1,"params"),d1.forEach(t),d_=c(Te," to "),Si=s(Te,"CODE",{});var c1=r(Si);c_=c(c1,"jax.numpy.float16"),c1.forEach(t),m_=c(Te,". This returns a new "),Ki=s(Te,"CODE",{});var m1=r(Ki);p_=c(m1,"params"),m1.forEach(t),f_=c(Te,` tree and does not cast the
`),Wi=s(Te,"CODE",{});var p1=r(Wi);u_=c(p1,"params"),p1.forEach(t),h_=c(Te," in place."),Te.forEach(t),__=l(gt),Xi=s(gt,"P",{});var f1=r(Xi);g_=c(f1,`This method can be used on GPU to explicitly convert the model parameters to float16 precision to do full
half-precision training or to save weights in float16 for inference in order to save memory and improve speed.`),f1.forEach(t),b_=l(gt),u(Zo.$$.fragment,gt),gt.forEach(t),v_=l(z),xe=s(z,"DIV",{class:!0});var Br=r(xe);u(bs.$$.fragment,Br),y_=l(Br),ee=s(Br,"P",{});var Me=r(ee);x_=c(Me,"Cast the floating-point "),Hi=s(Me,"CODE",{});var u1=r(Hi);$_=c(u1,"params"),u1.forEach(t),w_=c(Me," to "),Qi=s(Me,"CODE",{});var h1=r(Qi);D_=c(h1,"jax.numpy.float32"),h1.forEach(t),k_=c(Me,`. This method can be used to explicitly convert the
model parameters to fp32 precision. This returns a new `),Ri=s(Me,"CODE",{});var _1=r(Ri);T_=c(_1,"params"),_1.forEach(t),M_=c(Me," tree and does not cast the "),Yi=s(Me,"CODE",{});var g1=r(Yi);N_=c(g1,"params"),g1.forEach(t),E_=c(Me," in place."),Me.forEach(t),A_=l(Br),u(et.$$.fragment,Br),Br.forEach(t),z.forEach(t),Pd=l(o),no=s(o,"H2",{class:!0});var Qc=r(no);ot=s(Qc,"A",{id:!0,class:!0,href:!0});var b1=r(ot);Gi=s(b1,"SPAN",{});var v1=r(Gi);u(vs.$$.fragment,v1),v1.forEach(t),b1.forEach(t),U_=l(Qc),Ji=s(Qc,"SPAN",{});var y1=r(Ji);C_=c(y1,"FlaxUNet2DConditionOutput"),y1.forEach(t),Qc.forEach(t),Od=l(o),so=s(o,"DIV",{class:!0});var Rc=r(so);u(ys.$$.fragment,Rc),F_=l(Rc),tt=s(Rc,"DIV",{class:!0});var Yc=r(tt);u(xs.$$.fragment,Yc),P_=l(Yc),Zi=s(Yc,"P",{});var x1=r(Zi);O_=c(x1,"\u201CReturns a new object replacing the specified fields with new values."),x1.forEach(t),Yc.forEach(t),Rc.forEach(t),qd=l(o),ro=s(o,"H2",{class:!0});var Gc=r(ro);nt=s(Gc,"A",{id:!0,class:!0,href:!0});var $1=r(nt);el=s($1,"SPAN",{});var w1=r(el);u($s.$$.fragment,w1),w1.forEach(t),$1.forEach(t),q_=l(Gc),ol=s(Gc,"SPAN",{});var D1=r(ol);L_=c(D1,"FlaxUNet2DConditionModel"),D1.forEach(t),Gc.forEach(t),Ld=l(o),L=s(o,"DIV",{class:!0});var ie=r(L);u(ws.$$.fragment,ie),j_=l(ie),tl=s(ie,"P",{});var k1=r(tl);I_=c(k1,`FlaxUNet2DConditionModel is a conditional 2D UNet model that takes in a noisy sample, conditional state, and a
timestep and returns sample shaped output.`),k1.forEach(t),z_=l(ie),Ds=s(ie,"P",{});var Jc=r(Ds);V_=c(Jc,"This model inherits from "),Fr=s(Jc,"A",{href:!0});var T1=r(Fr);B_=c(T1,"FlaxModelMixin"),T1.forEach(t),S_=c(Jc,`. Check the superclass documentation for the generic methods the library
implements for all the models (such as downloading or saving, etc.)`),Jc.forEach(t),K_=l(ie),ks=s(ie,"P",{});var Zc=r(ks);W_=c(Zc,"Also, this model is a Flax Linen "),Ts=s(Zc,"A",{href:!0,rel:!0});var M1=r(Ts);X_=c(M1,"flax.linen.Module"),M1.forEach(t),H_=c(Zc,`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),Zc.forEach(t),Q_=l(ie),nl=s(ie,"P",{});var N1=r(nl);R_=c(N1,"Finally, this model supports inherent JAX features such as:"),N1.forEach(t),Y_=l(ie),ce=s(ie,"UL",{});var bt=r(ce);sl=s(bt,"LI",{});var E1=r(sl);Ms=s(E1,"A",{href:!0,rel:!0});var A1=r(Ms);G_=c(A1,"Just-In-Time (JIT) compilation"),A1.forEach(t),E1.forEach(t),J_=l(bt),rl=s(bt,"LI",{});var U1=r(rl);Ns=s(U1,"A",{href:!0,rel:!0});var C1=r(Ns);Z_=c(C1,"Automatic Differentiation"),C1.forEach(t),U1.forEach(t),eg=l(bt),al=s(bt,"LI",{});var F1=r(al);Es=s(F1,"A",{href:!0,rel:!0});var P1=r(Es);og=c(P1,"Vectorization"),P1.forEach(t),F1.forEach(t),tg=l(bt),il=s(bt,"LI",{});var O1=r(il);As=s(O1,"A",{href:!0,rel:!0});var q1=r(As);ng=c(q1,"Parallelization"),q1.forEach(t),O1.forEach(t),bt.forEach(t),ie.forEach(t),jd=l(o),ao=s(o,"H2",{class:!0});var em=r(ao);st=s(em,"A",{id:!0,class:!0,href:!0});var L1=r(st);ll=s(L1,"SPAN",{});var j1=r(ll);u(Us.$$.fragment,j1),j1.forEach(t),L1.forEach(t),sg=l(em),dl=s(em,"SPAN",{});var I1=r(dl);rg=c(I1,"FlaxDecoderOutput"),I1.forEach(t),em.forEach(t),Id=l(o),me=s(o,"DIV",{class:!0});var Sr=r(me);u(Cs.$$.fragment,Sr),ag=l(Sr),cl=s(Sr,"P",{});var z1=r(cl);ig=c(z1,"Output of decoding method."),z1.forEach(t),lg=l(Sr),rt=s(Sr,"DIV",{class:!0});var om=r(rt);u(Fs.$$.fragment,om),dg=l(om),ml=s(om,"P",{});var V1=r(ml);cg=c(V1,"\u201CReturns a new object replacing the specified fields with new values."),V1.forEach(t),om.forEach(t),Sr.forEach(t),zd=l(o),io=s(o,"H2",{class:!0});var tm=r(io);at=s(tm,"A",{id:!0,class:!0,href:!0});var B1=r(at);pl=s(B1,"SPAN",{});var S1=r(pl);u(Ps.$$.fragment,S1),S1.forEach(t),B1.forEach(t),mg=l(tm),fl=s(tm,"SPAN",{});var K1=r(fl);pg=c(K1,"FlaxAutoencoderKLOutput"),K1.forEach(t),tm.forEach(t),Vd=l(o),pe=s(o,"DIV",{class:!0});var Kr=r(pe);u(Os.$$.fragment,Kr),fg=l(Kr),ul=s(Kr,"P",{});var W1=r(ul);ug=c(W1,"Output of AutoencoderKL encoding method."),W1.forEach(t),hg=l(Kr),it=s(Kr,"DIV",{class:!0});var nm=r(it);u(qs.$$.fragment,nm),_g=l(nm),hl=s(nm,"P",{});var X1=r(hl);gg=c(X1,"\u201CReturns a new object replacing the specified fields with new values."),X1.forEach(t),nm.forEach(t),Kr.forEach(t),Bd=l(o),lo=s(o,"H2",{class:!0});var sm=r(lo);lt=s(sm,"A",{id:!0,class:!0,href:!0});var H1=r(lt);_l=s(H1,"SPAN",{});var Q1=r(_l);u(Ls.$$.fragment,Q1),Q1.forEach(t),H1.forEach(t),bg=l(sm),gl=s(sm,"SPAN",{});var R1=r(gl);vg=c(R1,"FlaxAutoencoderKL"),R1.forEach(t),sm.forEach(t),Sd=l(o),B=s(o,"DIV",{class:!0});var Ne=r(B);u(js.$$.fragment,Ne),yg=l(Ne),bl=s(Ne,"P",{});var Y1=r(bl);xg=c(Y1,`Flax Implementation of Variational Autoencoder (VAE) model with KL loss from the paper Auto-Encoding Variational
Bayes by Diederik P. Kingma and Max Welling.`),Y1.forEach(t),$g=l(Ne),Is=s(Ne,"P",{});var rm=r(Is);wg=c(rm,"This model is a Flax Linen "),zs=s(rm,"A",{href:!0,rel:!0});var G1=r(zs);Dg=c(G1,"flax.linen.Module"),G1.forEach(t),kg=c(rm,`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),rm.forEach(t),Tg=l(Ne),vl=s(Ne,"P",{});var J1=r(vl);Mg=c(J1,"Finally, this model supports inherent JAX features such as:"),J1.forEach(t),Ng=l(Ne),fe=s(Ne,"UL",{});var vt=r(fe);yl=s(vt,"LI",{});var Z1=r(yl);Vs=s(Z1,"A",{href:!0,rel:!0});var ey=r(Vs);Eg=c(ey,"Just-In-Time (JIT) compilation"),ey.forEach(t),Z1.forEach(t),Ag=l(vt),xl=s(vt,"LI",{});var oy=r(xl);Bs=s(oy,"A",{href:!0,rel:!0});var ty=r(Bs);Ug=c(ty,"Automatic Differentiation"),ty.forEach(t),oy.forEach(t),Cg=l(vt),$l=s(vt,"LI",{});var ny=r($l);Ss=s(ny,"A",{href:!0,rel:!0});var sy=r(Ss);Fg=c(sy,"Vectorization"),sy.forEach(t),ny.forEach(t),Pg=l(vt),wl=s(vt,"LI",{});var ry=r(wl);Ks=s(ry,"A",{href:!0,rel:!0});var ay=r(Ks);Og=c(ay,"Parallelization"),ay.forEach(t),ry.forEach(t),vt.forEach(t),Ne.forEach(t),Kd=l(o),co=s(o,"H2",{class:!0});var am=r(co);dt=s(am,"A",{id:!0,class:!0,href:!0});var iy=r(dt);Dl=s(iy,"SPAN",{});var ly=r(Dl);u(Ws.$$.fragment,ly),ly.forEach(t),iy.forEach(t),qg=l(am),kl=s(am,"SPAN",{});var dy=r(kl);Lg=c(dy,"FlaxControlNetOutput"),dy.forEach(t),am.forEach(t),Wd=l(o),mo=s(o,"DIV",{class:!0});var im=r(mo);u(Xs.$$.fragment,im),jg=l(im),ct=s(im,"DIV",{class:!0});var lm=r(ct);u(Hs.$$.fragment,lm),Ig=l(lm),Tl=s(lm,"P",{});var cy=r(Tl);zg=c(cy,"\u201CReturns a new object replacing the specified fields with new values."),cy.forEach(t),lm.forEach(t),im.forEach(t),Xd=l(o),po=s(o,"H2",{class:!0});var dm=r(po);mt=s(dm,"A",{id:!0,class:!0,href:!0});var my=r(mt);Ml=s(my,"SPAN",{});var py=r(Ml);u(Qs.$$.fragment,py),py.forEach(t),my.forEach(t),Vg=l(dm),Nl=s(dm,"SPAN",{});var fy=r(Nl);Bg=c(fy,"FlaxControlNetModel"),fy.forEach(t),dm.forEach(t),Hd=l(o),j=s(o,"DIV",{class:!0});var le=r(j);u(Rs.$$.fragment,le),Sg=l(le),Ys=s(le,"P",{});var cm=r(Ys);Kg=c(cm,"Quoting from "),Gs=s(cm,"A",{href:!0,rel:!0});var uy=r(Gs);Wg=c(uy,"https://arxiv.org/abs/2302.05543"),uy.forEach(t),Xg=c(cm,`: \u201CStable Diffusion uses a pre-processing method similar to VQ-GAN
[11] to convert the entire dataset of 512 \xD7 512 images into smaller 64 \xD7 64 \u201Clatent images\u201D for stabilized
training. This requires ControlNets to convert image-based conditions to 64 \xD7 64 feature space to match the
convolution size. We use a tiny network E(\xB7) of four convolution layers with 4 \xD7 4 kernels and 2 \xD7 2 strides
(activated by ReLU, channels are 16, 32, 64, 128, initialized with Gaussian weights, trained jointly with the full
model) to encode image-space conditions \u2026 into feature maps \u2026\u201D`),cm.forEach(t),Hg=l(le),Js=s(le,"P",{});var mm=r(Js);Qg=c(mm,"This model inherits from "),Pr=s(mm,"A",{href:!0});var hy=r(Pr);Rg=c(hy,"FlaxModelMixin"),hy.forEach(t),Yg=c(mm,`. Check the superclass documentation for the generic methods the library
implements for all the models (such as downloading or saving, etc.)`),mm.forEach(t),Gg=l(le),Zs=s(le,"P",{});var pm=r(Zs);Jg=c(pm,"Also, this model is a Flax Linen "),er=s(pm,"A",{href:!0,rel:!0});var _y=r(er);Zg=c(_y,"flax.linen.Module"),_y.forEach(t),e2=c(pm,`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),pm.forEach(t),o2=l(le),El=s(le,"P",{});var gy=r(El);t2=c(gy,"Finally, this model supports inherent JAX features such as:"),gy.forEach(t),n2=l(le),ue=s(le,"UL",{});var yt=r(ue);Al=s(yt,"LI",{});var by=r(Al);or=s(by,"A",{href:!0,rel:!0});var vy=r(or);s2=c(vy,"Just-In-Time (JIT) compilation"),vy.forEach(t),by.forEach(t),r2=l(yt),Ul=s(yt,"LI",{});var yy=r(Ul);tr=s(yy,"A",{href:!0,rel:!0});var xy=r(tr);a2=c(xy,"Automatic Differentiation"),xy.forEach(t),yy.forEach(t),i2=l(yt),Cl=s(yt,"LI",{});var $y=r(Cl);nr=s($y,"A",{href:!0,rel:!0});var wy=r(nr);l2=c(wy,"Vectorization"),wy.forEach(t),$y.forEach(t),d2=l(yt),Fl=s(yt,"LI",{});var Dy=r(Fl);sr=s(Dy,"A",{href:!0,rel:!0});var ky=r(sr);c2=c(ky,"Parallelization"),ky.forEach(t),Dy.forEach(t),yt.forEach(t),le.forEach(t),this.h()},h(){a(x,"name","hf:doc:metadata"),a(x,"content",JSON.stringify(zy)),a($,"id","models"),a($,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a($,"href","#models"),a(D,"class","relative group"),a(uo,"id","diffusers.ModelMixin"),a(uo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(uo,"href","#diffusers.ModelMixin"),a(Ae,"class","relative group"),a(dr,"href","/docs/diffusers/pr_2813/en/api/models#diffusers.ModelMixin"),a(cr,"href","/docs/diffusers/pr_2813/en/api/models#diffusers.ModelMixin.save_pretrained"),a(_e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(ho,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(ge,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(F,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(vo,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(yo,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(xo,"id","diffusers.models.unet_2d.UNet2DOutput"),a(xo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(xo,"href","#diffusers.models.unet_2d.UNet2DOutput"),a(Ce,"class","relative group"),a(Pt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a($o,"id","diffusers.UNet2DModel"),a($o,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a($o,"href","#diffusers.UNet2DModel"),a(Fe,"class","relative group"),a(mr,"href","/docs/diffusers/pr_2813/en/api/models#diffusers.ModelMixin"),a(pr,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(wo,"id","diffusers.models.unet_1d.UNet1DOutput"),a(wo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(wo,"href","#diffusers.models.unet_1d.UNet1DOutput"),a(Pe,"class","relative group"),a(Vt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Do,"id","diffusers.UNet1DModel"),a(Do,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(Do,"href","#diffusers.UNet1DModel"),a(Oe,"class","relative group"),a(fr,"href","/docs/diffusers/pr_2813/en/api/models#diffusers.ModelMixin"),a(ur,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(R,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(ko,"id","diffusers.models.unet_2d_condition.UNet2DConditionOutput"),a(ko,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(ko,"href","#diffusers.models.unet_2d_condition.UNet2DConditionOutput"),a(qe,"class","relative group"),a(Qt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(To,"id","diffusers.UNet2DConditionModel"),a(To,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(To,"href","#diffusers.UNet2DConditionModel"),a(Le,"class","relative group"),a(hr,"href","/docs/diffusers/pr_2813/en/api/models#diffusers.ModelMixin"),a(_r,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(be,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(gr,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(P,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Mo,"id","diffusers.models.unet_3d_condition.UNet3DConditionOutput"),a(Mo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(Mo,"href","#diffusers.models.unet_3d_condition.UNet3DConditionOutput"),a(je,"class","relative group"),a(nn,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(No,"id","diffusers.UNet3DConditionModel"),a(No,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(No,"href","#diffusers.UNet3DConditionModel"),a(Ie,"class","relative group"),a(br,"href","/docs/diffusers/pr_2813/en/api/models#diffusers.ModelMixin"),a(vr,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(ve,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(yr,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(O,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Eo,"id","diffusers.models.vae.DecoderOutput"),a(Eo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(Eo,"href","#diffusers.models.vae.DecoderOutput"),a(ze,"class","relative group"),a(Ve,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Ao,"id","diffusers.models.vq_model.VQEncoderOutput"),a(Ao,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(Ao,"href","#diffusers.models.vq_model.VQEncoderOutput"),a(Be,"class","relative group"),a(Se,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Uo,"id","diffusers.VQModel"),a(Uo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(Uo,"href","#diffusers.VQModel"),a(Ke,"class","relative group"),a(xr,"href","/docs/diffusers/pr_2813/en/api/models#diffusers.ModelMixin"),a($r,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Co,"id","diffusers.models.autoencoder_kl.AutoencoderKLOutput"),a(Co,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(Co,"href","#diffusers.models.autoencoder_kl.AutoencoderKLOutput"),a(We,"class","relative group"),a(Xe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Fo,"id","diffusers.AutoencoderKL"),a(Fo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(Fo,"href","#diffusers.AutoencoderKL"),a(He,"class","relative group"),a(wr,"href","/docs/diffusers/pr_2813/en/api/models#diffusers.ModelMixin"),a(Po,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Oo,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(qo,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Lo,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Dr,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(jo,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Io,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(E,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(zo,"id","diffusers.Transformer2DModel"),a(zo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(zo,"href","#diffusers.Transformer2DModel"),a(Qe,"class","relative group"),a(kr,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Vo,"id","diffusers.models.transformer_2d.Transformer2DModelOutput"),a(Vo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(Vo,"href","#diffusers.models.transformer_2d.Transformer2DModelOutput"),a(Re,"class","relative group"),a(In,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Bo,"id","diffusers.models.transformer_temporal.TransformerTemporalModel"),a(Bo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(Bo,"href","#diffusers.models.transformer_temporal.TransformerTemporalModel"),a(Ye,"class","relative group"),a(Tr,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(de,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(So,"id","diffusers.models.transformer_temporal.TransformerTemporalModelOutput"),a(So,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(So,"href","#diffusers.models.transformer_temporal.TransformerTemporalModelOutput"),a(Ge,"class","relative group"),a(Wn,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Ko,"id","diffusers.PriorTransformer"),a(Ko,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(Ko,"href","#diffusers.PriorTransformer"),a(Je,"class","relative group"),a(Mr,"href","/docs/diffusers/pr_2813/en/api/models#diffusers.ModelMixin"),a(Yn,"href","https://arxiv.org/abs/2204.06125"),a(Yn,"rel","nofollow"),a(Er,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(V,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Wo,"id","diffusers.models.prior_transformer.PriorTransformerOutput"),a(Wo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(Wo,"href","#diffusers.models.prior_transformer.PriorTransformerOutput"),a(Ze,"class","relative group"),a(Zn,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Xo,"id","diffusers.models.controlnet.ControlNetOutput"),a(Xo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(Xo,"href","#diffusers.models.controlnet.ControlNetOutput"),a(eo,"class","relative group"),a(ts,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Ho,"id","diffusers.ControlNetModel"),a(Ho,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(Ho,"href","#diffusers.ControlNetModel"),a(oo,"class","relative group"),a(Qo,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(ye,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Ar,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(G,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Ro,"id","diffusers.FlaxModelMixin"),a(Ro,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(Ro,"href","#diffusers.FlaxModelMixin"),a(to,"class","relative group"),a(Cr,"href","/docs/diffusers/pr_2813/en/api/models#diffusers.FlaxModelMixin"),a(K,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Go,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(te,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(ne,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(xe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(ot,"id","diffusers.models.unet_2d_condition_flax.FlaxUNet2DConditionOutput"),a(ot,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(ot,"href","#diffusers.models.unet_2d_condition_flax.FlaxUNet2DConditionOutput"),a(no,"class","relative group"),a(tt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(so,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(nt,"id","diffusers.FlaxUNet2DConditionModel"),a(nt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(nt,"href","#diffusers.FlaxUNet2DConditionModel"),a(ro,"class","relative group"),a(Fr,"href","/docs/diffusers/pr_2813/en/api/models#diffusers.FlaxModelMixin"),a(Ts,"href","https://flax.readthedocs.io/en/latest/flax.linen.html#module"),a(Ts,"rel","nofollow"),a(Ms,"href","https://jax.readthedocs.io/en/latest/jax.html#just-in-time-compilation-jit"),a(Ms,"rel","nofollow"),a(Ns,"href","https://jax.readthedocs.io/en/latest/jax.html#automatic-differentiation"),a(Ns,"rel","nofollow"),a(Es,"href","https://jax.readthedocs.io/en/latest/jax.html#vectorization-vmap"),a(Es,"rel","nofollow"),a(As,"href","https://jax.readthedocs.io/en/latest/jax.html#parallelization-pmap"),a(As,"rel","nofollow"),a(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(st,"id","diffusers.models.vae_flax.FlaxDecoderOutput"),a(st,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(st,"href","#diffusers.models.vae_flax.FlaxDecoderOutput"),a(ao,"class","relative group"),a(rt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(me,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(at,"id","diffusers.models.vae_flax.FlaxAutoencoderKLOutput"),a(at,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(at,"href","#diffusers.models.vae_flax.FlaxAutoencoderKLOutput"),a(io,"class","relative group"),a(it,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(pe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(lt,"id","diffusers.FlaxAutoencoderKL"),a(lt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(lt,"href","#diffusers.FlaxAutoencoderKL"),a(lo,"class","relative group"),a(zs,"href","https://flax.readthedocs.io/en/latest/flax.linen.html#module"),a(zs,"rel","nofollow"),a(Vs,"href","https://jax.readthedocs.io/en/latest/jax.html#just-in-time-compilation-jit"),a(Vs,"rel","nofollow"),a(Bs,"href","https://jax.readthedocs.io/en/latest/jax.html#automatic-differentiation"),a(Bs,"rel","nofollow"),a(Ss,"href","https://jax.readthedocs.io/en/latest/jax.html#vectorization-vmap"),a(Ss,"rel","nofollow"),a(Ks,"href","https://jax.readthedocs.io/en/latest/jax.html#parallelization-pmap"),a(Ks,"rel","nofollow"),a(B,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(dt,"id","diffusers.models.controlnet_flax.FlaxControlNetOutput"),a(dt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(dt,"href","#diffusers.models.controlnet_flax.FlaxControlNetOutput"),a(co,"class","relative group"),a(ct,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(mo,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(mt,"id","diffusers.FlaxControlNetModel"),a(mt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(mt,"href","#diffusers.FlaxControlNetModel"),a(po,"class","relative group"),a(Gs,"href","https://arxiv.org/abs/2302.05543"),a(Gs,"rel","nofollow"),a(Pr,"href","/docs/diffusers/pr_2813/en/api/models#diffusers.FlaxModelMixin"),a(er,"href","https://flax.readthedocs.io/en/latest/flax.linen.html#module"),a(er,"rel","nofollow"),a(or,"href","https://jax.readthedocs.io/en/latest/jax.html#just-in-time-compilation-jit"),a(or,"rel","nofollow"),a(tr,"href","https://jax.readthedocs.io/en/latest/jax.html#automatic-differentiation"),a(tr,"rel","nofollow"),a(nr,"href","https://jax.readthedocs.io/en/latest/jax.html#vectorization-vmap"),a(nr,"rel","nofollow"),a(sr,"href","https://jax.readthedocs.io/en/latest/jax.html#parallelization-pmap"),a(sr,"rel","nofollow"),a(j,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(o,m){e(document.head,x),p(o,T,m),p(o,D,m),e(D,$),e($,k),h(v,k,null),e(D,w),e(D,oe),e(oe,Ee),p(o,X,m),p(o,H,m),e(H,ir),e(H,Wr),e(Wr,fm),e(H,um),e(H,Xr),e(Xr,hm),e(H,_m),p(o,Bl,m),p(o,Ae,m),e(Ae,uo),e(uo,Hr),h(xt,Hr,null),e(Ae,gm),e(Ae,Qr),e(Qr,bm),p(o,Sl,m),p(o,N,m),h($t,N,null),e(N,vm),e(N,Rr),e(Rr,ym),e(N,xm),e(N,lr),e(lr,dr),e(dr,$m),e(lr,wm),e(N,Dm),e(N,Yr),e(Yr,he),e(he,Gr),e(Gr,km),e(he,Tm),e(he,Jr),e(Jr,Mm),e(he,Nm),e(he,cr),e(cr,Em),e(he,Am),e(N,Um),e(N,_e),h(wt,_e,null),e(_e,Cm),e(_e,Zr),e(Zr,Fm),e(_e,Pm),e(_e,ea),e(ea,Om),e(N,qm),e(N,ho),h(Dt,ho,null),e(ho,Lm),e(ho,oa),e(oa,jm),e(N,Im),e(N,ge),h(kt,ge,null),e(ge,zm),e(ge,ta),e(ta,Vm),e(ge,Bm),e(ge,na),e(na,Sm),e(N,Km),e(N,S),h(Tt,S,null),e(S,Wm),e(S,sa),e(sa,Xm),e(S,Hm),e(S,ra),e(ra,Qm),e(S,Rm),e(S,aa),e(aa,Ym),e(S,Gm),h(_o,S,null),e(N,Jm),e(N,F),h(Mt,F,null),e(F,Zm),e(F,ia),e(ia,ep),e(F,op),e(F,Ue),e(Ue,tp),e(Ue,la),e(la,np),e(Ue,sp),e(Ue,da),e(da,rp),e(Ue,ap),e(F,ip),e(F,Nt),e(Nt,lp),e(Nt,ca),e(ca,dp),e(Nt,cp),e(F,mp),e(F,Et),e(Et,pp),e(Et,ma),e(ma,fp),e(Et,up),e(F,hp),h(go,F,null),e(F,_p),h(bo,F,null),e(N,gp),e(N,vo),h(At,vo,null),e(vo,bp),e(vo,pa),e(pa,vp),e(N,yp),e(N,yo),h(Ut,yo,null),e(yo,xp),e(yo,Ct),e(Ct,$p),e(Ct,fa),e(fa,wp),e(Ct,Dp),p(o,Kl,m),p(o,Ce,m),e(Ce,xo),e(xo,ua),h(Ft,ua,null),e(Ce,kp),e(Ce,ha),e(ha,Tp),p(o,Wl,m),p(o,Pt,m),h(Ot,Pt,null),p(o,Xl,m),p(o,Fe,m),e(Fe,$o),e($o,_a),h(qt,_a,null),e(Fe,Mp),e(Fe,ga),e(ga,Np),p(o,Hl,m),p(o,Q,m),h(Lt,Q,null),e(Q,Ep),e(Q,ba),e(ba,Ap),e(Q,Up),e(Q,jt),e(jt,Cp),e(jt,mr),e(mr,Fp),e(jt,Pp),e(Q,Op),e(Q,pr),h(It,pr,null),p(o,Ql,m),p(o,Pe,m),e(Pe,wo),e(wo,va),h(zt,va,null),e(Pe,qp),e(Pe,ya),e(ya,Lp),p(o,Rl,m),p(o,Vt,m),h(Bt,Vt,null),p(o,Yl,m),p(o,Oe,m),e(Oe,Do),e(Do,xa),h(St,xa,null),e(Oe,jp),e(Oe,$a),e($a,Ip),p(o,Gl,m),p(o,R,m),h(Kt,R,null),e(R,zp),e(R,wa),e(wa,Vp),e(R,Bp),e(R,Wt),e(Wt,Sp),e(Wt,fr),e(fr,Kp),e(Wt,Wp),e(R,Xp),e(R,ur),h(Xt,ur,null),p(o,Jl,m),p(o,qe,m),e(qe,ko),e(ko,Da),h(Ht,Da,null),e(qe,Hp),e(qe,ka),e(ka,Qp),p(o,Zl,m),p(o,Qt,m),h(Rt,Qt,null),p(o,ed,m),p(o,Le,m),e(Le,To),e(To,Ta),h(Yt,Ta,null),e(Le,Rp),e(Le,Ma),e(Ma,Yp),p(o,od,m),p(o,P,m),h(Gt,P,null),e(P,Gp),e(P,Na),e(Na,Jp),e(P,Zp),e(P,Jt),e(Jt,ef),e(Jt,hr),e(hr,of),e(Jt,tf),e(P,nf),e(P,_r),h(Zt,_r,null),e(P,sf),e(P,be),h(en,be,null),e(be,rf),e(be,Ea),e(Ea,af),e(be,lf),e(be,Aa),e(Aa,df),e(P,cf),e(P,gr),h(on,gr,null),p(o,td,m),p(o,je,m),e(je,Mo),e(Mo,Ua),h(tn,Ua,null),e(je,mf),e(je,Ca),e(Ca,pf),p(o,nd,m),p(o,nn,m),h(sn,nn,null),p(o,sd,m),p(o,Ie,m),e(Ie,No),e(No,Fa),h(rn,Fa,null),e(Ie,ff),e(Ie,Pa),e(Pa,uf),p(o,rd,m),p(o,O,m),h(an,O,null),e(O,hf),e(O,Oa),e(Oa,_f),e(O,gf),e(O,ln),e(ln,bf),e(ln,br),e(br,vf),e(ln,yf),e(O,xf),e(O,vr),h(dn,vr,null),e(O,$f),e(O,ve),h(cn,ve,null),e(ve,wf),e(ve,qa),e(qa,Df),e(ve,kf),e(ve,La),e(La,Tf),e(O,Mf),e(O,yr),h(mn,yr,null),p(o,ad,m),p(o,ze,m),e(ze,Eo),e(Eo,ja),h(pn,ja,null),e(ze,Nf),e(ze,Ia),e(Ia,Ef),p(o,id,m),p(o,Ve,m),h(fn,Ve,null),e(Ve,Af),e(Ve,za),e(za,Uf),p(o,ld,m),p(o,Be,m),e(Be,Ao),e(Ao,Va),h(un,Va,null),e(Be,Cf),e(Be,Ba),e(Ba,Ff),p(o,dd,m),p(o,Se,m),h(hn,Se,null),e(Se,Pf),e(Se,Sa),e(Sa,Of),p(o,cd,m),p(o,Ke,m),e(Ke,Uo),e(Uo,Ka),h(_n,Ka,null),e(Ke,qf),e(Ke,Wa),e(Wa,Lf),p(o,md,m),p(o,Y,m),h(gn,Y,null),e(Y,jf),e(Y,Xa),e(Xa,If),e(Y,zf),e(Y,bn),e(bn,Vf),e(bn,xr),e(xr,Bf),e(bn,Sf),e(Y,Kf),e(Y,$r),h(vn,$r,null),p(o,pd,m),p(o,We,m),e(We,Co),e(Co,Ha),h(yn,Ha,null),e(We,Wf),e(We,Qa),e(Qa,Xf),p(o,fd,m),p(o,Xe,m),h(xn,Xe,null),e(Xe,Hf),e(Xe,Ra),e(Ra,Qf),p(o,ud,m),p(o,He,m),e(He,Fo),e(Fo,Ya),h($n,Ya,null),e(He,Rf),e(He,Ga),e(Ga,Yf),p(o,hd,m),p(o,E,m),h(wn,E,null),e(E,Gf),e(E,Ja),e(Ja,Jf),e(E,Zf),e(E,Dn),e(Dn,eu),e(Dn,wr),e(wr,ou),e(Dn,tu),e(E,nu),e(E,Po),h(kn,Po,null),e(Po,su),e(Po,Tn),e(Tn,ru),e(Tn,Za),e(Za,au),e(Tn,iu),e(E,lu),e(E,Oo),h(Mn,Oo,null),e(Oo,du),e(Oo,Nn),e(Nn,cu),e(Nn,ei),e(ei,mu),e(Nn,pu),e(E,fu),e(E,qo),h(En,qo,null),e(qo,uu),e(qo,oi),e(oi,hu),e(E,_u),e(E,Lo),h(An,Lo,null),e(Lo,gu),e(Lo,ti),e(ti,bu),e(E,vu),e(E,Dr),h(Un,Dr,null),e(E,yu),e(E,jo),h(Cn,jo,null),e(jo,xu),e(jo,ni),e(ni,$u),e(E,wu),e(E,Io),h(Fn,Io,null),e(Io,Du),e(Io,si),e(si,ku),p(o,_d,m),p(o,Qe,m),e(Qe,zo),e(zo,ri),h(Pn,ri,null),e(Qe,Tu),e(Qe,ai),e(ai,Mu),p(o,gd,m),p(o,q,m),h(On,q,null),e(q,Nu),e(q,ii),e(ii,Eu),e(q,Au),e(q,li),e(li,Uu),e(q,Cu),e(q,qn),e(qn,Fu),e(qn,di),e(di,Pu),e(qn,Ou),e(q,qu),e(q,ci),e(ci,Lu),e(q,ju),e(q,kr),h(Ln,kr,null),p(o,bd,m),p(o,Re,m),e(Re,Vo),e(Vo,mi),h(jn,mi,null),e(Re,Iu),e(Re,pi),e(pi,zu),p(o,vd,m),p(o,In,m),h(zn,In,null),p(o,yd,m),p(o,Ye,m),e(Ye,Bo),e(Bo,fi),h(Vn,fi,null),e(Ye,Vu),e(Ye,ui),e(ui,Bu),p(o,xd,m),p(o,de,m),h(Bn,de,null),e(de,Su),e(de,hi),e(hi,Ku),e(de,Wu),e(de,Tr),h(Sn,Tr,null),p(o,$d,m),p(o,Ge,m),e(Ge,So),e(So,_i),h(Kn,_i,null),e(Ge,Xu),e(Ge,gi),e(gi,Hu),p(o,wd,m),p(o,Wn,m),h(Xn,Wn,null),p(o,Dd,m),p(o,Je,m),e(Je,Ko),e(Ko,bi),h(Hn,bi,null),e(Je,Qu),e(Je,vi),e(vi,Ru),p(o,kd,m),p(o,V,m),h(Qn,V,null),e(V,Yu),e(V,yi),e(yi,Gu),e(V,Ju),e(V,Rn),e(Rn,Zu),e(Rn,Mr),e(Mr,eh),e(Rn,oh),e(V,th),e(V,Nr),e(Nr,nh),e(Nr,Yn),e(Yn,sh),e(V,rh),e(V,Er),h(Gn,Er,null),p(o,Td,m),p(o,Ze,m),e(Ze,Wo),e(Wo,xi),h(Jn,xi,null),e(Ze,ah),e(Ze,$i),e($i,ih),p(o,Md,m),p(o,Zn,m),h(es,Zn,null),p(o,Nd,m),p(o,eo,m),e(eo,Xo),e(Xo,wi),h(os,wi,null),e(eo,lh),e(eo,Di),e(Di,dh),p(o,Ed,m),p(o,ts,m),h(ns,ts,null),p(o,Ad,m),p(o,oo,m),e(oo,Ho),e(Ho,ki),h(ss,ki,null),e(oo,ch),e(oo,Ti),e(Ti,mh),p(o,Ud,m),p(o,G,m),h(rs,G,null),e(G,ph),e(G,Qo),h(as,Qo,null),e(Qo,fh),e(Qo,Mi),e(Mi,uh),e(G,hh),e(G,ye),h(is,ye,null),e(ye,_h),e(ye,Ni),e(Ni,gh),e(ye,bh),e(ye,Ei),e(Ei,vh),e(G,yh),e(G,Ar),h(ls,Ar,null),p(o,Cd,m),p(o,to,m),e(to,Ro),e(Ro,Ai),h(ds,Ai,null),e(to,xh),e(to,Ui),e(Ui,$h),p(o,Fd,m),p(o,U,m),h(cs,U,null),e(U,wh),e(U,Ci),e(Ci,Dh),e(U,kh),e(U,Ur),e(Ur,Cr),e(Cr,Th),e(Ur,Mh),e(U,Nh),e(U,K),h(ms,K,null),e(K,Eh),e(K,Fi),e(Fi,Ah),e(K,Uh),e(K,ps),e(ps,Ch),e(ps,Pi),e(Pi,Fh),e(ps,Ph),e(K,Oh),e(K,fs),e(fs,qh),e(fs,Oi),e(Oi,Lh),e(fs,jh),e(K,Ih),h(Yo,K,null),e(U,zh),e(U,Go),h(us,Go,null),e(Go,Vh),e(Go,hs),e(hs,Bh),e(hs,qi),e(qi,Sh),e(hs,Kh),e(U,Wh),e(U,te),h(_s,te,null),e(te,Xh),e(te,J),e(J,Hh),e(J,Li),e(Li,Qh),e(J,Rh),e(J,ji),e(ji,Yh),e(J,Gh),e(J,Ii),e(Ii,Jh),e(J,Zh),e(J,zi),e(zi,e_),e(J,o_),e(te,t_),e(te,Vi),e(Vi,n_),e(te,s_),h(Jo,te,null),e(U,r_),e(U,ne),h(gs,ne,null),e(ne,a_),e(ne,Z),e(Z,i_),e(Z,Bi),e(Bi,l_),e(Z,d_),e(Z,Si),e(Si,c_),e(Z,m_),e(Z,Ki),e(Ki,p_),e(Z,f_),e(Z,Wi),e(Wi,u_),e(Z,h_),e(ne,__),e(ne,Xi),e(Xi,g_),e(ne,b_),h(Zo,ne,null),e(U,v_),e(U,xe),h(bs,xe,null),e(xe,y_),e(xe,ee),e(ee,x_),e(ee,Hi),e(Hi,$_),e(ee,w_),e(ee,Qi),e(Qi,D_),e(ee,k_),e(ee,Ri),e(Ri,T_),e(ee,M_),e(ee,Yi),e(Yi,N_),e(ee,E_),e(xe,A_),h(et,xe,null),p(o,Pd,m),p(o,no,m),e(no,ot),e(ot,Gi),h(vs,Gi,null),e(no,U_),e(no,Ji),e(Ji,C_),p(o,Od,m),p(o,so,m),h(ys,so,null),e(so,F_),e(so,tt),h(xs,tt,null),e(tt,P_),e(tt,Zi),e(Zi,O_),p(o,qd,m),p(o,ro,m),e(ro,nt),e(nt,el),h($s,el,null),e(ro,q_),e(ro,ol),e(ol,L_),p(o,Ld,m),p(o,L,m),h(ws,L,null),e(L,j_),e(L,tl),e(tl,I_),e(L,z_),e(L,Ds),e(Ds,V_),e(Ds,Fr),e(Fr,B_),e(Ds,S_),e(L,K_),e(L,ks),e(ks,W_),e(ks,Ts),e(Ts,X_),e(ks,H_),e(L,Q_),e(L,nl),e(nl,R_),e(L,Y_),e(L,ce),e(ce,sl),e(sl,Ms),e(Ms,G_),e(ce,J_),e(ce,rl),e(rl,Ns),e(Ns,Z_),e(ce,eg),e(ce,al),e(al,Es),e(Es,og),e(ce,tg),e(ce,il),e(il,As),e(As,ng),p(o,jd,m),p(o,ao,m),e(ao,st),e(st,ll),h(Us,ll,null),e(ao,sg),e(ao,dl),e(dl,rg),p(o,Id,m),p(o,me,m),h(Cs,me,null),e(me,ag),e(me,cl),e(cl,ig),e(me,lg),e(me,rt),h(Fs,rt,null),e(rt,dg),e(rt,ml),e(ml,cg),p(o,zd,m),p(o,io,m),e(io,at),e(at,pl),h(Ps,pl,null),e(io,mg),e(io,fl),e(fl,pg),p(o,Vd,m),p(o,pe,m),h(Os,pe,null),e(pe,fg),e(pe,ul),e(ul,ug),e(pe,hg),e(pe,it),h(qs,it,null),e(it,_g),e(it,hl),e(hl,gg),p(o,Bd,m),p(o,lo,m),e(lo,lt),e(lt,_l),h(Ls,_l,null),e(lo,bg),e(lo,gl),e(gl,vg),p(o,Sd,m),p(o,B,m),h(js,B,null),e(B,yg),e(B,bl),e(bl,xg),e(B,$g),e(B,Is),e(Is,wg),e(Is,zs),e(zs,Dg),e(Is,kg),e(B,Tg),e(B,vl),e(vl,Mg),e(B,Ng),e(B,fe),e(fe,yl),e(yl,Vs),e(Vs,Eg),e(fe,Ag),e(fe,xl),e(xl,Bs),e(Bs,Ug),e(fe,Cg),e(fe,$l),e($l,Ss),e(Ss,Fg),e(fe,Pg),e(fe,wl),e(wl,Ks),e(Ks,Og),p(o,Kd,m),p(o,co,m),e(co,dt),e(dt,Dl),h(Ws,Dl,null),e(co,qg),e(co,kl),e(kl,Lg),p(o,Wd,m),p(o,mo,m),h(Xs,mo,null),e(mo,jg),e(mo,ct),h(Hs,ct,null),e(ct,Ig),e(ct,Tl),e(Tl,zg),p(o,Xd,m),p(o,po,m),e(po,mt),e(mt,Ml),h(Qs,Ml,null),e(po,Vg),e(po,Nl),e(Nl,Bg),p(o,Hd,m),p(o,j,m),h(Rs,j,null),e(j,Sg),e(j,Ys),e(Ys,Kg),e(Ys,Gs),e(Gs,Wg),e(Ys,Xg),e(j,Hg),e(j,Js),e(Js,Qg),e(Js,Pr),e(Pr,Rg),e(Js,Yg),e(j,Gg),e(j,Zs),e(Zs,Jg),e(Zs,er),e(er,Zg),e(Zs,e2),e(j,o2),e(j,El),e(El,t2),e(j,n2),e(j,ue),e(ue,Al),e(Al,or),e(or,s2),e(ue,r2),e(ue,Ul),e(Ul,tr),e(tr,a2),e(ue,i2),e(ue,Cl),e(Cl,nr),e(nr,l2),e(ue,d2),e(ue,Fl),e(Fl,sr),e(sr,c2),Qd=!0},p(o,[m]){const rr={};m&2&&(rr.$$scope={dirty:m,ctx:o}),_o.$set(rr);const Pl={};m&2&&(Pl.$$scope={dirty:m,ctx:o}),go.$set(Pl);const Ol={};m&2&&(Ol.$$scope={dirty:m,ctx:o}),bo.$set(Ol);const ql={};m&2&&(ql.$$scope={dirty:m,ctx:o}),Yo.$set(ql);const fo={};m&2&&(fo.$$scope={dirty:m,ctx:o}),Jo.$set(fo);const Ll={};m&2&&(Ll.$$scope={dirty:m,ctx:o}),Zo.$set(Ll);const jl={};m&2&&(jl.$$scope={dirty:m,ctx:o}),et.$set(jl)},i(o){Qd||(_(v.$$.fragment,o),_(xt.$$.fragment,o),_($t.$$.fragment,o),_(wt.$$.fragment,o),_(Dt.$$.fragment,o),_(kt.$$.fragment,o),_(Tt.$$.fragment,o),_(_o.$$.fragment,o),_(Mt.$$.fragment,o),_(go.$$.fragment,o),_(bo.$$.fragment,o),_(At.$$.fragment,o),_(Ut.$$.fragment,o),_(Ft.$$.fragment,o),_(Ot.$$.fragment,o),_(qt.$$.fragment,o),_(Lt.$$.fragment,o),_(It.$$.fragment,o),_(zt.$$.fragment,o),_(Bt.$$.fragment,o),_(St.$$.fragment,o),_(Kt.$$.fragment,o),_(Xt.$$.fragment,o),_(Ht.$$.fragment,o),_(Rt.$$.fragment,o),_(Yt.$$.fragment,o),_(Gt.$$.fragment,o),_(Zt.$$.fragment,o),_(en.$$.fragment,o),_(on.$$.fragment,o),_(tn.$$.fragment,o),_(sn.$$.fragment,o),_(rn.$$.fragment,o),_(an.$$.fragment,o),_(dn.$$.fragment,o),_(cn.$$.fragment,o),_(mn.$$.fragment,o),_(pn.$$.fragment,o),_(fn.$$.fragment,o),_(un.$$.fragment,o),_(hn.$$.fragment,o),_(_n.$$.fragment,o),_(gn.$$.fragment,o),_(vn.$$.fragment,o),_(yn.$$.fragment,o),_(xn.$$.fragment,o),_($n.$$.fragment,o),_(wn.$$.fragment,o),_(kn.$$.fragment,o),_(Mn.$$.fragment,o),_(En.$$.fragment,o),_(An.$$.fragment,o),_(Un.$$.fragment,o),_(Cn.$$.fragment,o),_(Fn.$$.fragment,o),_(Pn.$$.fragment,o),_(On.$$.fragment,o),_(Ln.$$.fragment,o),_(jn.$$.fragment,o),_(zn.$$.fragment,o),_(Vn.$$.fragment,o),_(Bn.$$.fragment,o),_(Sn.$$.fragment,o),_(Kn.$$.fragment,o),_(Xn.$$.fragment,o),_(Hn.$$.fragment,o),_(Qn.$$.fragment,o),_(Gn.$$.fragment,o),_(Jn.$$.fragment,o),_(es.$$.fragment,o),_(os.$$.fragment,o),_(ns.$$.fragment,o),_(ss.$$.fragment,o),_(rs.$$.fragment,o),_(as.$$.fragment,o),_(is.$$.fragment,o),_(ls.$$.fragment,o),_(ds.$$.fragment,o),_(cs.$$.fragment,o),_(ms.$$.fragment,o),_(Yo.$$.fragment,o),_(us.$$.fragment,o),_(_s.$$.fragment,o),_(Jo.$$.fragment,o),_(gs.$$.fragment,o),_(Zo.$$.fragment,o),_(bs.$$.fragment,o),_(et.$$.fragment,o),_(vs.$$.fragment,o),_(ys.$$.fragment,o),_(xs.$$.fragment,o),_($s.$$.fragment,o),_(ws.$$.fragment,o),_(Us.$$.fragment,o),_(Cs.$$.fragment,o),_(Fs.$$.fragment,o),_(Ps.$$.fragment,o),_(Os.$$.fragment,o),_(qs.$$.fragment,o),_(Ls.$$.fragment,o),_(js.$$.fragment,o),_(Ws.$$.fragment,o),_(Xs.$$.fragment,o),_(Hs.$$.fragment,o),_(Qs.$$.fragment,o),_(Rs.$$.fragment,o),Qd=!0)},o(o){g(v.$$.fragment,o),g(xt.$$.fragment,o),g($t.$$.fragment,o),g(wt.$$.fragment,o),g(Dt.$$.fragment,o),g(kt.$$.fragment,o),g(Tt.$$.fragment,o),g(_o.$$.fragment,o),g(Mt.$$.fragment,o),g(go.$$.fragment,o),g(bo.$$.fragment,o),g(At.$$.fragment,o),g(Ut.$$.fragment,o),g(Ft.$$.fragment,o),g(Ot.$$.fragment,o),g(qt.$$.fragment,o),g(Lt.$$.fragment,o),g(It.$$.fragment,o),g(zt.$$.fragment,o),g(Bt.$$.fragment,o),g(St.$$.fragment,o),g(Kt.$$.fragment,o),g(Xt.$$.fragment,o),g(Ht.$$.fragment,o),g(Rt.$$.fragment,o),g(Yt.$$.fragment,o),g(Gt.$$.fragment,o),g(Zt.$$.fragment,o),g(en.$$.fragment,o),g(on.$$.fragment,o),g(tn.$$.fragment,o),g(sn.$$.fragment,o),g(rn.$$.fragment,o),g(an.$$.fragment,o),g(dn.$$.fragment,o),g(cn.$$.fragment,o),g(mn.$$.fragment,o),g(pn.$$.fragment,o),g(fn.$$.fragment,o),g(un.$$.fragment,o),g(hn.$$.fragment,o),g(_n.$$.fragment,o),g(gn.$$.fragment,o),g(vn.$$.fragment,o),g(yn.$$.fragment,o),g(xn.$$.fragment,o),g($n.$$.fragment,o),g(wn.$$.fragment,o),g(kn.$$.fragment,o),g(Mn.$$.fragment,o),g(En.$$.fragment,o),g(An.$$.fragment,o),g(Un.$$.fragment,o),g(Cn.$$.fragment,o),g(Fn.$$.fragment,o),g(Pn.$$.fragment,o),g(On.$$.fragment,o),g(Ln.$$.fragment,o),g(jn.$$.fragment,o),g(zn.$$.fragment,o),g(Vn.$$.fragment,o),g(Bn.$$.fragment,o),g(Sn.$$.fragment,o),g(Kn.$$.fragment,o),g(Xn.$$.fragment,o),g(Hn.$$.fragment,o),g(Qn.$$.fragment,o),g(Gn.$$.fragment,o),g(Jn.$$.fragment,o),g(es.$$.fragment,o),g(os.$$.fragment,o),g(ns.$$.fragment,o),g(ss.$$.fragment,o),g(rs.$$.fragment,o),g(as.$$.fragment,o),g(is.$$.fragment,o),g(ls.$$.fragment,o),g(ds.$$.fragment,o),g(cs.$$.fragment,o),g(ms.$$.fragment,o),g(Yo.$$.fragment,o),g(us.$$.fragment,o),g(_s.$$.fragment,o),g(Jo.$$.fragment,o),g(gs.$$.fragment,o),g(Zo.$$.fragment,o),g(bs.$$.fragment,o),g(et.$$.fragment,o),g(vs.$$.fragment,o),g(ys.$$.fragment,o),g(xs.$$.fragment,o),g($s.$$.fragment,o),g(ws.$$.fragment,o),g(Us.$$.fragment,o),g(Cs.$$.fragment,o),g(Fs.$$.fragment,o),g(Ps.$$.fragment,o),g(Os.$$.fragment,o),g(qs.$$.fragment,o),g(Ls.$$.fragment,o),g(js.$$.fragment,o),g(Ws.$$.fragment,o),g(Xs.$$.fragment,o),g(Hs.$$.fragment,o),g(Qs.$$.fragment,o),g(Rs.$$.fragment,o),Qd=!1},d(o){t(x),o&&t(T),o&&t(D),b(v),o&&t(X),o&&t(H),o&&t(Bl),o&&t(Ae),b(xt),o&&t(Sl),o&&t(N),b($t),b(wt),b(Dt),b(kt),b(Tt),b(_o),b(Mt),b(go),b(bo),b(At),b(Ut),o&&t(Kl),o&&t(Ce),b(Ft),o&&t(Wl),o&&t(Pt),b(Ot),o&&t(Xl),o&&t(Fe),b(qt),o&&t(Hl),o&&t(Q),b(Lt),b(It),o&&t(Ql),o&&t(Pe),b(zt),o&&t(Rl),o&&t(Vt),b(Bt),o&&t(Yl),o&&t(Oe),b(St),o&&t(Gl),o&&t(R),b(Kt),b(Xt),o&&t(Jl),o&&t(qe),b(Ht),o&&t(Zl),o&&t(Qt),b(Rt),o&&t(ed),o&&t(Le),b(Yt),o&&t(od),o&&t(P),b(Gt),b(Zt),b(en),b(on),o&&t(td),o&&t(je),b(tn),o&&t(nd),o&&t(nn),b(sn),o&&t(sd),o&&t(Ie),b(rn),o&&t(rd),o&&t(O),b(an),b(dn),b(cn),b(mn),o&&t(ad),o&&t(ze),b(pn),o&&t(id),o&&t(Ve),b(fn),o&&t(ld),o&&t(Be),b(un),o&&t(dd),o&&t(Se),b(hn),o&&t(cd),o&&t(Ke),b(_n),o&&t(md),o&&t(Y),b(gn),b(vn),o&&t(pd),o&&t(We),b(yn),o&&t(fd),o&&t(Xe),b(xn),o&&t(ud),o&&t(He),b($n),o&&t(hd),o&&t(E),b(wn),b(kn),b(Mn),b(En),b(An),b(Un),b(Cn),b(Fn),o&&t(_d),o&&t(Qe),b(Pn),o&&t(gd),o&&t(q),b(On),b(Ln),o&&t(bd),o&&t(Re),b(jn),o&&t(vd),o&&t(In),b(zn),o&&t(yd),o&&t(Ye),b(Vn),o&&t(xd),o&&t(de),b(Bn),b(Sn),o&&t($d),o&&t(Ge),b(Kn),o&&t(wd),o&&t(Wn),b(Xn),o&&t(Dd),o&&t(Je),b(Hn),o&&t(kd),o&&t(V),b(Qn),b(Gn),o&&t(Td),o&&t(Ze),b(Jn),o&&t(Md),o&&t(Zn),b(es),o&&t(Nd),o&&t(eo),b(os),o&&t(Ed),o&&t(ts),b(ns),o&&t(Ad),o&&t(oo),b(ss),o&&t(Ud),o&&t(G),b(rs),b(as),b(is),b(ls),o&&t(Cd),o&&t(to),b(ds),o&&t(Fd),o&&t(U),b(cs),b(ms),b(Yo),b(us),b(_s),b(Jo),b(gs),b(Zo),b(bs),b(et),o&&t(Pd),o&&t(no),b(vs),o&&t(Od),o&&t(so),b(ys),b(xs),o&&t(qd),o&&t(ro),b($s),o&&t(Ld),o&&t(L),b(ws),o&&t(jd),o&&t(ao),b(Us),o&&t(Id),o&&t(me),b(Cs),b(Fs),o&&t(zd),o&&t(io),b(Ps),o&&t(Vd),o&&t(pe),b(Os),b(qs),o&&t(Bd),o&&t(lo),b(Ls),o&&t(Sd),o&&t(B),b(js),o&&t(Kd),o&&t(co),b(Ws),o&&t(Wd),o&&t(mo),b(Xs),b(Hs),o&&t(Xd),o&&t(po),b(Qs),o&&t(Hd),o&&t(j),b(Rs)}}}const zy={local:"models",sections:[{local:"diffusers.ModelMixin",title:"ModelMixin"},{local:"diffusers.models.unet_2d.UNet2DOutput",title:"UNet2DOutput"},{local:"diffusers.UNet2DModel",title:"UNet2DModel"},{local:"diffusers.models.unet_1d.UNet1DOutput",title:"UNet1DOutput"},{local:"diffusers.UNet1DModel",title:"UNet1DModel"},{local:"diffusers.models.unet_2d_condition.UNet2DConditionOutput",title:"UNet2DConditionOutput"},{local:"diffusers.UNet2DConditionModel",title:"UNet2DConditionModel"},{local:"diffusers.models.unet_3d_condition.UNet3DConditionOutput",title:"UNet3DConditionOutput"},{local:"diffusers.UNet3DConditionModel",title:"UNet3DConditionModel"},{local:"diffusers.models.vae.DecoderOutput",title:"DecoderOutput"},{local:"diffusers.models.vq_model.VQEncoderOutput",title:"VQEncoderOutput"},{local:"diffusers.VQModel",title:"VQModel"},{local:"diffusers.models.autoencoder_kl.AutoencoderKLOutput",title:"AutoencoderKLOutput"},{local:"diffusers.AutoencoderKL",title:"AutoencoderKL"},{local:"diffusers.Transformer2DModel",title:"Transformer2DModel"},{local:"diffusers.models.transformer_2d.Transformer2DModelOutput",title:"Transformer2DModelOutput"},{local:"diffusers.models.transformer_temporal.TransformerTemporalModel",title:"TransformerTemporalModel"},{local:"diffusers.models.transformer_temporal.TransformerTemporalModelOutput",title:"Transformer2DModelOutput"},{local:"diffusers.PriorTransformer",title:"PriorTransformer"},{local:"diffusers.models.prior_transformer.PriorTransformerOutput",title:"PriorTransformerOutput"},{local:"diffusers.models.controlnet.ControlNetOutput",title:"ControlNetOutput"},{local:"diffusers.ControlNetModel",title:"ControlNetModel"},{local:"diffusers.FlaxModelMixin",title:"FlaxModelMixin"},{local:"diffusers.models.unet_2d_condition_flax.FlaxUNet2DConditionOutput",title:"FlaxUNet2DConditionOutput"},{local:"diffusers.FlaxUNet2DConditionModel",title:"FlaxUNet2DConditionModel"},{local:"diffusers.models.vae_flax.FlaxDecoderOutput",title:"FlaxDecoderOutput"},{local:"diffusers.models.vae_flax.FlaxAutoencoderKLOutput",title:"FlaxAutoencoderKLOutput"},{local:"diffusers.FlaxAutoencoderKL",title:"FlaxAutoencoderKL"},{local:"diffusers.models.controlnet_flax.FlaxControlNetOutput",title:"FlaxControlNetOutput"},{local:"diffusers.FlaxControlNetModel",title:"FlaxControlNetModel"}],title:"Models"};function Vy(I){return Uy(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Qy extends My{constructor(x){super();Ny(this,x,Vy,Iy,Ey,{})}}export{Qy as default,zy as metadata};
